import * as i1 from '@angular/cdk/scrolling';
import { CdkScrollable, CdkScrollableModule } from '@angular/cdk/scrolling';
import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, ViewEncapsulation, Injectable, Directive, Input, ElementRef, TemplateRef, ViewChild, ViewChildren, ContentChild, InjectionToken, forwardRef, Inject, EventEmitter, Output, ContentChildren, Attribute, NgModule } from '@angular/core';
import * as i5 from '@vdlx/vdl-angular/mat/button';
import { MatButtonModule } from '@vdlx/vdl-angular/mat/button';
import * as i3$2 from '@vdlx/vdl-angular/mat/core';
import { mixinDisableRipple, MatRippleModule } from '@vdlx/vdl-angular/mat/core';
import * as i4$1 from '@vdlx/vdl-angular/mat/dialog';
import { MatDialogModule } from '@vdlx/vdl-angular/mat/dialog';
import { MatDividerModule } from '@vdlx/vdl-angular/mat/divider';
import * as i2 from '@vdlx/vdl-angular/mat/expansion';
import { MatExpansionPanel, MatExpansionModule } from '@vdlx/vdl-angular/mat/expansion';
import * as i2$2 from '@vdlx/vdl-angular/mat/icon';
import { MatIconModule } from '@vdlx/vdl-angular/mat/icon';
import { MatInputModule } from '@vdlx/vdl-angular/mat/input';
import * as i3$1 from '@vdlx/vdl-angular/mat/list';
import { MatListItem, MatListModule } from '@vdlx/vdl-angular/mat/list';
import { MatDrawer, matDrawerAnimations, MatDrawerContent, MatDrawerContainer, MatSidenavModule } from '@vdlx/vdl-angular/mat/sidenav';
import { MatSlideToggleModule } from '@vdlx/vdl-angular/mat/slide-toggle';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import * as i3 from '@angular/cdk/clipboard';
import { Subject } from 'rxjs';
import * as i2$1 from '@angular/cdk/a11y';
import { FocusKeyManager } from '@angular/cdk/a11y';
import { SelectionModel } from '@angular/cdk/collections';
import { hasModifierKey, ENTER, SPACE } from '@angular/cdk/keycodes';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { takeUntil, startWith } from 'rxjs/operators';

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatNavPanel extends MatDrawer {
    constructor() {
        super(...arguments);
        /** sets fixed as true by default */
        this.fixedInViewport = true;
    }
    // Sets only position for Nav Panel to start
    get position() {
        return 'start';
    }
}
MatNavPanel.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavPanel, deps: null, target: i0.ɵɵFactoryTarget.Component });
MatNavPanel.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatNavPanel, selector: "mat-nav-panel", host: { attributes: { "tabIndex": "-1" }, properties: { "attr.align": "null", "class.mat-drawer-end": "false", "class.mat-drawer-over": "mode === \"over\"", "class.mat-drawer-push": "mode === \"push\"", "class.mat-drawer-side": "mode === \"side\"", "class.mat-drawer-opened": "opened", "class.mat-nav-panel-fixed": "true" }, classAttribute: "mat-drawer mat-app-bar-panel mat-nav-panel" }, providers: [{ provide: MatDrawer, useExisting: MatNavPanel }], exportAs: ["matNavPanel"], usesInheritance: true, ngImport: i0, template: "<div class=\"mat-drawer-inner-container\"\n     cdkScrollable\n     #content>\n\n  <ng-content select=\"[mat-nav-menu-search]\"></ng-content>\n  <ng-content select=\"mat-nav-panel-menu, [mat-nav-panel-menu]\"></ng-content>\n\n</div>", styles: [".mat-nav-panel{max-width:100vw}\n"], directives: [{ type: i1.CdkScrollable, selector: "[cdk-scrollable], [cdkScrollable]" }], animations: [matDrawerAnimations.transformDrawer], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavPanel, decorators: [{
            type: Component,
            args: [{ selector: 'mat-nav-panel', exportAs: 'matNavPanel', providers: [{ provide: MatDrawer, useExisting: MatNavPanel }], animations: [matDrawerAnimations.transformDrawer], host: {
                        class: 'mat-drawer mat-app-bar-panel mat-nav-panel',
                        tabIndex: '-1',
                        // must prevent the browser from aligning text based on value
                        '[attr.align]': 'null',
                        '[class.mat-drawer-end]': 'false',
                        '[class.mat-drawer-over]': 'mode === "over"',
                        '[class.mat-drawer-push]': 'mode === "push"',
                        '[class.mat-drawer-side]': 'mode === "side"',
                        '[class.mat-drawer-opened]': 'opened',
                        '[class.mat-nav-panel-fixed]': 'true'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<div class=\"mat-drawer-inner-container\"\n     cdkScrollable\n     #content>\n\n  <ng-content select=\"[mat-nav-menu-search]\"></ng-content>\n  <ng-content select=\"mat-nav-panel-menu, [mat-nav-panel-menu]\"></ng-content>\n\n</div>", styles: [".mat-nav-panel{max-width:100vw}\n"] }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Datepicker data that requires internationalization. */
class MatProfilePanelIntl {
    constructor() {
        /**
         * Stream that emits whenever the labels here are changed. Use this to notify
         * components if the labels have changed after initialization.
         */
        this.changes = new Subject();
        /** A label for the header in Notifications Expansion panel */
        this.notificationsLabel = 'Notifications';
        /** A label for the header in Help Expansion panel */
        this.helpLabel = 'Help';
        /** A label for the header in Settings Expansion panel */
        this.settingsLabel = 'Settings';
        /** A label for the copy button in Profile Panel Footer Customer ID Dialog */
        this.copyButtonLabel = 'Copy';
        /** Label for the View Customer ID button */
        this.viewCustomerIDButtonLabel = 'View Customer ID';
    }
}
MatProfilePanelIntl.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelIntl, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MatProfilePanelIntl.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelIntl, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelIntl, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

/* eslint-disable @angular-eslint/directive-selector */
/** Profile Panel Sign Out button directive */
class MatProfilePanelSignOutButton {
}
MatProfilePanelSignOutButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelSignOutButton, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfilePanelSignOutButton.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelSignOutButton, selector: "[mat-profile-panel-signout-button]", host: { classAttribute: "mat-profile-panel-signout-button" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelSignOutButton, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-panel-signout-button]',
                    host: {
                        class: 'mat-profile-panel-signout-button'
                    }
                }]
        }] });
/** Profile Panel Additional Content directive */
class MatProfilePanelFooterContent {
}
MatProfilePanelFooterContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelFooterContent, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfilePanelFooterContent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelFooterContent, selector: "[mat-profile-panel-footer-content]", host: { classAttribute: "mat-profile-panel-footer-content" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelFooterContent, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-panel-footer-content]',
                    host: {
                        class: 'mat-profile-panel-footer-content'
                    }
                }]
        }] });
/** Profile Panel Footer component */
class MatProfilePanelFooter {
}
MatProfilePanelFooter.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelFooter, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelFooter.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelFooter, selector: "mat-profile-panel-footer", inputs: { displayName: "displayName", applicationVersion: "applicationVersion" }, host: { classAttribute: "mat-profile-panel-footer" }, ngImport: i0, template: "<div class=\"mat-profile-panel-user-section\">\n  <div class=\"active-account-name\"\n       innerHTML=\"{{ displayName }}\"></div>\n  <ng-content select=\"[mat-profile-panel-signout-button]\"></ng-content>\n</div>\n\n<div class=\"mat-profile-panel-footer-more-content\">\n  <ng-content select=\"mat-profile-customer-id\"></ng-content>\n  <ng-content select=\"[mat-profile-panel-footer-content]\"></ng-content>\n  <div class=\"application-version\"\n       *ngIf=\"applicationVersion\"\n       innerHTML=\"Version: {{ applicationVersion }}\"></div>\n</div>", styles: [".mat-profile-panel-footer{display:block;padding:10px 20px}.mat-profile-panel-footer .mat-profile-panel-user-section{display:flex;align-items:center;justify-content:space-between}.mat-profile-panel-footer .mat-profile-panel-user-section .mat-profile-panel-signout-button{justify-self:flex-end;padding:0 8px}.mat-profile-panel-footer .mat-profile-panel-footer-more-content{padding-top:6px;display:flex;justify-content:space-between;align-items:center}.mat-profile-panel-footer .mat-profile-panel-footer-more-content a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){cursor:pointer}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container{width:unset;border-radius:4px;padding:0;min-height:64px}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container .mat-dialog-content{padding:10px 15px;margin:0}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container .mat-dialog-actions{display:flex;border-top-width:1px;border-top-style:solid;padding:5px 15px;justify-content:flex-end;min-height:unset}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){text-decoration:none}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab):hover{text-decoration:underline}\n"], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelFooter, decorators: [{
            type: Component,
            args: [{ selector: 'mat-profile-panel-footer', host: {
                        class: 'mat-profile-panel-footer'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<div class=\"mat-profile-panel-user-section\">\n  <div class=\"active-account-name\"\n       innerHTML=\"{{ displayName }}\"></div>\n  <ng-content select=\"[mat-profile-panel-signout-button]\"></ng-content>\n</div>\n\n<div class=\"mat-profile-panel-footer-more-content\">\n  <ng-content select=\"mat-profile-customer-id\"></ng-content>\n  <ng-content select=\"[mat-profile-panel-footer-content]\"></ng-content>\n  <div class=\"application-version\"\n       *ngIf=\"applicationVersion\"\n       innerHTML=\"Version: {{ applicationVersion }}\"></div>\n</div>", styles: [".mat-profile-panel-footer{display:block;padding:10px 20px}.mat-profile-panel-footer .mat-profile-panel-user-section{display:flex;align-items:center;justify-content:space-between}.mat-profile-panel-footer .mat-profile-panel-user-section .mat-profile-panel-signout-button{justify-self:flex-end;padding:0 8px}.mat-profile-panel-footer .mat-profile-panel-footer-more-content{padding-top:6px;display:flex;justify-content:space-between;align-items:center}.mat-profile-panel-footer .mat-profile-panel-footer-more-content a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){cursor:pointer}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container{width:unset;border-radius:4px;padding:0;min-height:64px}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container .mat-dialog-content{padding:10px 15px;margin:0}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container .mat-dialog-actions{display:flex;border-top-width:1px;border-top-style:solid;padding:5px 15px;justify-content:flex-end;min-height:unset}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){text-decoration:none}.cdk-overlay-pane.mat-profile-panel-customer-id-dialog .mat-dialog-container a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab):hover{text-decoration:underline}\n"] }]
        }], propDecorators: { displayName: [{
                type: Input
            }], applicationVersion: [{
                type: Input
            }] } });
class MatProfilePanelCustomerIdButton {
    constructor(_intl, clipboard, dialog, _viewContainerRef) {
        this._intl = _intl;
        this.clipboard = clipboard;
        this.dialog = dialog;
        this._viewContainerRef = _viewContainerRef;
    }
    /** Copies Customer ID to the users clipboard */
    copyCustomerId() {
        this.clipboard.copy(this.customerId);
    }
    /** Opens the Customer ID Dialog */
    showCustomerIdPopover() {
        const triggerCenter = this.trigger.nativeElement.getBoundingClientRect().width / 2;
        const parentElement = this._viewContainerRef.element.nativeElement.parentElement;
        const parentCenter = parentElement.getBoundingClientRect().width / 2;
        const offset = -triggerCenter + parentCenter;
        this.config = {
            panelClass: 'mat-profile-panel-customer-id-dialog',
            popover: true,
            position: { offsetX: offset },
            popoverAnchor: this.trigger,
            viewContainerRef: this._viewContainerRef,
            popoverPosition: 'above'
        };
        this.popoverRef = this.dialog.open(this.customerIdTemplate, this.config);
    }
}
MatProfilePanelCustomerIdButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelCustomerIdButton, deps: [{ token: MatProfilePanelIntl }, { token: i3.Clipboard }, { token: i4$1.MatDialog }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelCustomerIdButton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelCustomerIdButton, selector: "mat-profile-customer-id", inputs: { customerId: "customerId" }, viewQueries: [{ propertyName: "trigger", first: true, predicate: ["customerIdTrigger"], descendants: true, read: ElementRef, static: true }, { propertyName: "customerIdTemplate", first: true, predicate: ["customerIdTemplate"], descendants: true, read: TemplateRef, static: true }], ngImport: i0, template: `<a
      mat-button
      #customerIdTrigger
      (click)="showCustomerIdPopover()"
      (keydown.enter)="showCustomerIdPopover()"
      (keydown.space)="showCustomerIdPopover()"
      [attr.aria-label]="_intl.viewCustomerIDButtonLabel"
      [tabIndex]="0"
      >{{ _intl.viewCustomerIDButtonLabel }}</a
    >
    <ng-template #customerIdTemplate>
      <mat-dialog-content>
        <div>{{ customerId }}</div>
      </mat-dialog-content>
      <mat-dialog-actions>
        <a
          mat-button
          color="primary"
          (click)="copyCustomerId()"
          (keydown.enter)="copyCustomerId()"
          (keydown.space)="copyCustomerId()"
          [attr.aria-label]="_intl.copyButtonLabel"
          [tabIndex]="0"
          >{{ _intl.copyButtonLabel }}</a
        >
      </mat-dialog-actions>
    </ng-template>`, isInline: true, components: [{ type: i5.MatAnchor, selector: "a[mat-button], a[mat-raised-button], a[mat-icon-button], a[mat-fab],             a[mat-mini-fab], a[mat-stroked-button], a[mat-flat-button]", inputs: ["disabled", "disableRipple", "color", "tabIndex"], exportAs: ["matButton", "matAnchor"] }], directives: [{ type: i4$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { type: i4$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelCustomerIdButton, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-profile-customer-id',
                    template: `<a
      mat-button
      #customerIdTrigger
      (click)="showCustomerIdPopover()"
      (keydown.enter)="showCustomerIdPopover()"
      (keydown.space)="showCustomerIdPopover()"
      [attr.aria-label]="_intl.viewCustomerIDButtonLabel"
      [tabIndex]="0"
      >{{ _intl.viewCustomerIDButtonLabel }}</a
    >
    <ng-template #customerIdTemplate>
      <mat-dialog-content>
        <div>{{ customerId }}</div>
      </mat-dialog-content>
      <mat-dialog-actions>
        <a
          mat-button
          color="primary"
          (click)="copyCustomerId()"
          (keydown.enter)="copyCustomerId()"
          (keydown.space)="copyCustomerId()"
          [attr.aria-label]="_intl.copyButtonLabel"
          [tabIndex]="0"
          >{{ _intl.copyButtonLabel }}</a
        >
      </mat-dialog-actions>
    </ng-template>`
                }]
        }], ctorParameters: function () { return [{ type: MatProfilePanelIntl }, { type: i3.Clipboard }, { type: i4$1.MatDialog }, { type: i0.ViewContainerRef }]; }, propDecorators: { customerId: [{
                type: Input
            }], trigger: [{
                type: ViewChild,
                args: ['customerIdTrigger', { static: true, read: ElementRef }]
            }], customerIdTemplate: [{
                type: ViewChild,
                args: ['customerIdTemplate', { static: true, read: TemplateRef }]
            }] } });

/* eslint-disable @angular-eslint/directive-selector */
class MatProfileNotificationsFooter {
}
MatProfileNotificationsFooter.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileNotificationsFooter, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfileNotificationsFooter.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfileNotificationsFooter, selector: "[mat-profile-notifications-footer]", host: { classAttribute: "mat-profile-notifications-footer" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileNotificationsFooter, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-notifications-footer]',
                    host: {
                        class: 'mat-profile-notifications-footer'
                    }
                }]
        }] });
/** Help Item for help expansion */
class MatProfileHelpItem {
}
MatProfileHelpItem.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileHelpItem, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfileHelpItem.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfileHelpItem, selector: "[mat-profile-help-item]", host: { classAttribute: "mat-profile-help-item" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileHelpItem, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-help-item]',
                    host: {
                        class: 'mat-profile-help-item'
                    }
                }]
        }] });
/** Header for help expansion */
class MatProfileHelpHeader {
}
MatProfileHelpHeader.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileHelpHeader, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfileHelpHeader.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfileHelpHeader, selector: "[mat-profile-help-header]", host: { classAttribute: "mat-profile-help-header" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileHelpHeader, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-help-header]',
                    host: {
                        class: 'mat-profile-help-header'
                    }
                }]
        }] });
/** Footer for help expansion */
class MatProfileHelpFooter {
}
MatProfileHelpFooter.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileHelpFooter, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfileHelpFooter.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfileHelpFooter, selector: "[mat-profile-help-footer]", host: { classAttribute: "mat-profile-help-footer" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileHelpFooter, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-help-footer]',
                    host: {
                        class: 'mat-profile-help-footer'
                    }
                }]
        }] });
/** Item for Settings expansion */
class MatProfileSettingItem {
}
MatProfileSettingItem.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileSettingItem, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatProfileSettingItem.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatProfileSettingItem, selector: "[mat-profile-setting-item]", host: { classAttribute: "mat-profile-setting-item" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileSettingItem, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-profile-setting-item]',
                    host: {
                        class: 'mat-profile-setting-item'
                    }
                }]
        }] });
/** Content within the profile panel. This includes the Accordion with Notifications, Help and Settings Expansion Panels */
class MatProfilePanelContent {
    constructor(_intl, _changeDetectorRef) {
        this._intl = _intl;
        this._changeDetectorRef = _changeDetectorRef;
        /** Enables Notifications section in Profile Panel. Default is true. */
        this.enableNotifications = true;
        /** Enables Help section in Profile Panel. Default is true. */
        this.enableHelp = true;
        /** Enables Settings section in Profile Panel. Default is true. */
        this.enableSettings = true;
        this.panelSubscriptions = [];
        this._intlChanges = _intl.changes.subscribe(() => this._changeDetectorRef.markForCheck());
    }
    ngOnDestroy() {
        this._intlChanges.unsubscribe();
    }
}
MatProfilePanelContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelContent, deps: [{ token: MatProfilePanelIntl }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelContent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelContent, selector: "mat-profile-panel-content", inputs: { enableNotifications: "enableNotifications", enableHelp: "enableHelp", enableSettings: "enableSettings", notificationsCount: "notificationsCount" }, host: { classAttribute: "mat-profile-panel-content" }, queries: [{ propertyName: "notificationsFooter", first: true, predicate: MatProfileNotificationsFooter, descendants: true }, { propertyName: "helpHeader", first: true, predicate: MatProfileHelpHeader, descendants: true }, { propertyName: "helpFooter", first: true, predicate: MatProfileHelpFooter, descendants: true }], viewQueries: [{ propertyName: "expansionPanels", predicate: MatExpansionPanel, descendants: true }, { propertyName: "expansionElements", predicate: MatExpansionPanel, descendants: true, read: ElementRef }], ngImport: i0, template: "<mat-accordion class=\"profile-panel-accordion\">\n\n  <!-- Notifications -->\n  <mat-expansion-panel *ngIf=\"enableNotifications\"\n                       class=\"notifications-expansion-panel\"\n                       [ngClass]=\"{ 'has-footer': !!notificationsFooter }\">\n    <mat-expansion-panel-header>\n      <mat-panel-title><span>{{ _intl.notificationsLabel\n          }}</span><mat-profile-panel-expansion-badge *ngIf=\"notificationsCount > 0\"\n                                           [count]=\"notificationsCount\"></mat-profile-panel-expansion-badge></mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"expansion-body-content panel-scrollbar\">\n      <mat-list>\n        <ng-content select=\"mat-profile-panel-notification\"></ng-content>\n      </mat-list>\n    </div>\n    <mat-profile-expansion-panel-footer *ngIf=\"!!notificationsFooter\">\n      <ng-content select=\"a[mat-profile-notifications-footer]\"></ng-content>\n    </mat-profile-expansion-panel-footer>\n  </mat-expansion-panel>\n\n  <!-- Help -->\n  <mat-expansion-panel *ngIf=\"enableHelp\"\n                       class=\"help-expansion-panel\"\n                       [ngClass]=\"{ 'has-footer': !!helpFooter }\">\n    <mat-expansion-panel-header>\n      <mat-panel-title>{{ _intl.helpLabel }}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"expansion-body-header\"\n         *ngIf=\"!!helpHeader\">\n      <ng-content select=\"mat-form-field[mat-profile-help-header]\"></ng-content>\n    </div>\n    <div #helpScrollElement\n         class=\"expansion-body-content panel-scrollbar\">\n      <ng-content select=\"a[mat-profile-help-item]\"></ng-content>\n    </div>\n    <mat-profile-expansion-panel-footer *ngIf=\"!!helpFooter\">\n      <ng-content select=\"a[mat-profile-help-footer]\"></ng-content>\n    </mat-profile-expansion-panel-footer>\n  </mat-expansion-panel>\n\n  <!-- Settings -->\n  <mat-expansion-panel *ngIf=\"enableSettings\"\n                       class=\"settings-expansion-panel\">\n    <mat-expansion-panel-header>\n      <mat-panel-title>{{ _intl.settingsLabel }}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"expansion-body-content panel-scrollbar\">\n      <ng-content\n                  select=\"mat-divider[mat-profile-setting-item], mat-slide-toggle[mat-profile-setting-item], a[mat-profile-setting-item]\"></ng-content>\n    </div>\n  </mat-expansion-panel>\n</mat-accordion>", components: [{ type: i0.forwardRef(function () { return i2.MatExpansionPanel; }), selector: "mat-expansion-panel", inputs: ["disabled", "expanded", "hideToggle", "togglePosition"], outputs: ["opened", "closed", "expandedChange", "afterExpand", "afterCollapse"], exportAs: ["matExpansionPanel"] }, { type: i0.forwardRef(function () { return i2.MatExpansionPanelHeader; }), selector: "mat-expansion-panel-header", inputs: ["tabIndex", "expandedHeight", "collapsedHeight"] }, { type: i0.forwardRef(function () { return MatProfilePanelExpansionBadge; }), selector: "mat-profile-panel-expansion-badge", inputs: ["count"] }, { type: i0.forwardRef(function () { return i3$1.MatList; }), selector: "mat-list, mat-action-list", inputs: ["disableRipple", "disabled"], exportAs: ["matList"] }, { type: i0.forwardRef(function () { return MatProfileExpansionPanelFooter; }), selector: "mat-profile-expansion-panel-footer" }], directives: [{ type: i0.forwardRef(function () { return i2.MatAccordion; }), selector: "mat-accordion", inputs: ["multi", "hideToggle", "displayMode", "togglePosition"], exportAs: ["matAccordion"] }, { type: i0.forwardRef(function () { return i4.NgIf; }), selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i0.forwardRef(function () { return i4.NgClass; }), selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i0.forwardRef(function () { return i2.MatExpansionPanelTitle; }), selector: "mat-panel-title" }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelContent, decorators: [{
            type: Component,
            args: [{ selector: 'mat-profile-panel-content', host: {
                        class: 'mat-profile-panel-content'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<mat-accordion class=\"profile-panel-accordion\">\n\n  <!-- Notifications -->\n  <mat-expansion-panel *ngIf=\"enableNotifications\"\n                       class=\"notifications-expansion-panel\"\n                       [ngClass]=\"{ 'has-footer': !!notificationsFooter }\">\n    <mat-expansion-panel-header>\n      <mat-panel-title><span>{{ _intl.notificationsLabel\n          }}</span><mat-profile-panel-expansion-badge *ngIf=\"notificationsCount > 0\"\n                                           [count]=\"notificationsCount\"></mat-profile-panel-expansion-badge></mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"expansion-body-content panel-scrollbar\">\n      <mat-list>\n        <ng-content select=\"mat-profile-panel-notification\"></ng-content>\n      </mat-list>\n    </div>\n    <mat-profile-expansion-panel-footer *ngIf=\"!!notificationsFooter\">\n      <ng-content select=\"a[mat-profile-notifications-footer]\"></ng-content>\n    </mat-profile-expansion-panel-footer>\n  </mat-expansion-panel>\n\n  <!-- Help -->\n  <mat-expansion-panel *ngIf=\"enableHelp\"\n                       class=\"help-expansion-panel\"\n                       [ngClass]=\"{ 'has-footer': !!helpFooter }\">\n    <mat-expansion-panel-header>\n      <mat-panel-title>{{ _intl.helpLabel }}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"expansion-body-header\"\n         *ngIf=\"!!helpHeader\">\n      <ng-content select=\"mat-form-field[mat-profile-help-header]\"></ng-content>\n    </div>\n    <div #helpScrollElement\n         class=\"expansion-body-content panel-scrollbar\">\n      <ng-content select=\"a[mat-profile-help-item]\"></ng-content>\n    </div>\n    <mat-profile-expansion-panel-footer *ngIf=\"!!helpFooter\">\n      <ng-content select=\"a[mat-profile-help-footer]\"></ng-content>\n    </mat-profile-expansion-panel-footer>\n  </mat-expansion-panel>\n\n  <!-- Settings -->\n  <mat-expansion-panel *ngIf=\"enableSettings\"\n                       class=\"settings-expansion-panel\">\n    <mat-expansion-panel-header>\n      <mat-panel-title>{{ _intl.settingsLabel }}</mat-panel-title>\n    </mat-expansion-panel-header>\n    <div class=\"expansion-body-content panel-scrollbar\">\n      <ng-content\n                  select=\"mat-divider[mat-profile-setting-item], mat-slide-toggle[mat-profile-setting-item], a[mat-profile-setting-item]\"></ng-content>\n    </div>\n  </mat-expansion-panel>\n</mat-accordion>" }]
        }], ctorParameters: function () { return [{ type: MatProfilePanelIntl }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { enableNotifications: [{
                type: Input
            }], enableHelp: [{
                type: Input
            }], enableSettings: [{
                type: Input
            }], notificationsCount: [{
                type: Input
            }], expansionPanels: [{
                type: ViewChildren,
                args: [MatExpansionPanel]
            }], expansionElements: [{
                type: ViewChildren,
                args: [MatExpansionPanel, { read: ElementRef }]
            }], notificationsFooter: [{
                type: ContentChild,
                args: [MatProfileNotificationsFooter]
            }], helpHeader: [{
                type: ContentChild,
                args: [MatProfileHelpHeader]
            }], helpFooter: [{
                type: ContentChild,
                args: [MatProfileHelpFooter]
            }] } });
/** For displaying a badge on the profile panel expansion header title */
class MatProfilePanelExpansionBadge {
}
MatProfilePanelExpansionBadge.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelExpansionBadge, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelExpansionBadge.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelExpansionBadge, selector: "mat-profile-panel-expansion-badge", inputs: { count: "count" }, host: { classAttribute: "mat-profile-panel-expansion-badge" }, ngImport: i0, template: `<span>{{ count }}</span>`, isInline: true, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelExpansionBadge, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-profile-panel-expansion-badge',
                    template: `<span>{{ count }}</span>`,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        class: 'mat-profile-panel-expansion-badge'
                    }
                }]
        }], propDecorators: { count: [{
                type: Input
            }] } });
/** Profile Panel */
class MatProfilePanel extends MatDrawer {
    constructor() {
        super(...arguments);
        /** Sets fixed as true by default */
        this.fixedInViewport = true;
    }
    /** Sets only position for profile Panel to end */
    get position() {
        return 'end';
    }
}
MatProfilePanel.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanel, deps: null, target: i0.ɵɵFactoryTarget.Component });
MatProfilePanel.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanel, selector: "mat-profile-panel", host: { attributes: { "tabIndex": "-1" }, properties: { "attr.align": "null", "class.mat-drawer-end": "true", "class.mat-drawer-over": "mode === \"over\"", "class.mat-drawer-push": "mode === \"push\"", "class.mat-drawer-side": "mode === \"side\"", "class.mat-drawer-opened": "opened", "class.mat-profile-panel-fixed": "true", "class.has-profile-panel-footer": "!!profileFooter", "class.has-profile-panel-footer-content": "!!profileFooterContent" }, classAttribute: "mat-drawer mat-app-bar-panel mat-profile-panel" }, providers: [{ provide: MatDrawer, useExisting: MatProfilePanel }], queries: [{ propertyName: "profileFooter", first: true, predicate: MatProfilePanelFooter, descendants: true }, { propertyName: "profileFooterContent", first: true, predicate: MatProfilePanelFooterContent, descendants: true }], exportAs: ["matProfilePanel"], usesInheritance: true, ngImport: i0, template: "<div class=\"mat-drawer-inner-container\"\n     #content>\n  <div class=\"profile-panel-container\">\n    <ng-content select=\"mat-profile-panel-content\"></ng-content>\n    <ng-content></ng-content>\n  </div>\n</div>\n\n<ng-content select=\"mat-profile-panel-footer\"></ng-content>", styles: [".mat-profile-panel{width:400px;max-width:400px;position:relative}.mat-profile-panel.has-profile-panel-footer:not(.has-profile-panel-footer-content) .mat-drawer-inner-container{height:calc(100% - 44px)}.mat-profile-panel.has-profile-panel-footer.has-profile-panel-footer-content .mat-drawer-inner-container{height:calc(100% - 69px)}.mat-profile-panel:not(.has-profile-panel-footer) .mat-drawer-inner-container{height:100%}.mat-profile-panel .mat-drawer-inner-container{overflow:hidden}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container{height:100%}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion{display:flex;flex-direction:column;height:100%}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel:first-child{border-top:none}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel{flex:0 0 auto;transition-delay:.1s;transition-property:flex;transition-timing-function:ease-in}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-content{transition-delay:.1s;transition-property:height;transition-timing-function:ease-in}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.mat-expanded{flex:1 1 auto;transition-delay:0ms}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-header{-webkit-user-select:none;user-select:none}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title .mat-profile-panel-expansion-badge{margin-left:8px;border-radius:8px;padding:0 6px;height:17px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-content.ng-animating .mat-expansion-panel-body .expansion-body-content{overflow-y:hidden}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body{height:100%;padding:0}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content{height:100%;overflow:auto;display:flex;flex-direction:column}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-slide-toggle{padding:5px 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-slide-toggle:first-child{padding-top:10px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-slide-toggle:last-child{padding-bottom:10px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){padding:5px 20px;white-space:normal;margin-right:8px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-divider{margin:8px 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header{position:sticky;height:34px;top:0;padding:6px 0 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field{display:block;margin:0 20px;border-width:1px;border-style:solid;border-radius:8px;padding:2px 8px 2px 15px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-wrapper{padding-bottom:0}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-infix{border-top:0}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-underline,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-subscript-wrapper{display:none}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header+.expansion-body-content{height:calc(100% - 60px)}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-slide-toggle .mat-slide-toggle-content{flex:1 1 auto}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer{position:sticky;height:40px;bottom:0;display:grid;grid-template-columns:repeat(3,1fr);align-items:center;justify-content:flex-end;padding:0 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer>*{grid-column:2;justify-self:center}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer>*:first-child{grid-column:1;justify-self:flex-start}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer>*:last-child{grid-column:3;justify-self:flex-end}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.notifications-expansion-panel:not(.has-footer) .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.help-expansion-panel:not(.has-footer) .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.settings-expansion-panel:not(.has-footer) .mat-expansion-panel-content{height:calc(100% - 46px)}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.notifications-expansion-panel.has-footer .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.help-expansion-panel.has-footer .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.settings-expansion-panel.has-footer .mat-expansion-panel-content{height:calc(100% - 86px)}\n"], animations: [matDrawerAnimations.transformDrawer], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanel, decorators: [{
            type: Component,
            args: [{ selector: 'mat-profile-panel', exportAs: 'matProfilePanel', providers: [{ provide: MatDrawer, useExisting: MatProfilePanel }], animations: [matDrawerAnimations.transformDrawer], host: {
                        class: 'mat-drawer mat-app-bar-panel mat-profile-panel',
                        tabIndex: '-1',
                        // must prevent the browser from aligning text based on value
                        '[attr.align]': 'null',
                        '[class.mat-drawer-end]': 'true',
                        '[class.mat-drawer-over]': 'mode === "over"',
                        '[class.mat-drawer-push]': 'mode === "push"',
                        '[class.mat-drawer-side]': 'mode === "side"',
                        '[class.mat-drawer-opened]': 'opened',
                        '[class.mat-profile-panel-fixed]': 'true',
                        '[class.has-profile-panel-footer]': '!!profileFooter',
                        '[class.has-profile-panel-footer-content]': '!!profileFooterContent'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<div class=\"mat-drawer-inner-container\"\n     #content>\n  <div class=\"profile-panel-container\">\n    <ng-content select=\"mat-profile-panel-content\"></ng-content>\n    <ng-content></ng-content>\n  </div>\n</div>\n\n<ng-content select=\"mat-profile-panel-footer\"></ng-content>", styles: [".mat-profile-panel{width:400px;max-width:400px;position:relative}.mat-profile-panel.has-profile-panel-footer:not(.has-profile-panel-footer-content) .mat-drawer-inner-container{height:calc(100% - 44px)}.mat-profile-panel.has-profile-panel-footer.has-profile-panel-footer-content .mat-drawer-inner-container{height:calc(100% - 69px)}.mat-profile-panel:not(.has-profile-panel-footer) .mat-drawer-inner-container{height:100%}.mat-profile-panel .mat-drawer-inner-container{overflow:hidden}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container{height:100%}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion{display:flex;flex-direction:column;height:100%}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel:first-child{border-top:none}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel{flex:0 0 auto;transition-delay:.1s;transition-property:flex;transition-timing-function:ease-in}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-content{transition-delay:.1s;transition-property:height;transition-timing-function:ease-in}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.mat-expanded{flex:1 1 auto;transition-delay:0ms}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-header{-webkit-user-select:none;user-select:none}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title .mat-profile-panel-expansion-badge{margin-left:8px;border-radius:8px;padding:0 6px;height:17px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-content.ng-animating .mat-expansion-panel-body .expansion-body-content{overflow-y:hidden}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body{height:100%;padding:0}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content{height:100%;overflow:auto;display:flex;flex-direction:column}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-slide-toggle{padding:5px 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-slide-toggle:first-child{padding-top:10px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-slide-toggle:last-child{padding-bottom:10px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){padding:5px 20px;white-space:normal;margin-right:8px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-content>.mat-divider{margin:8px 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header{position:sticky;height:34px;top:0;padding:6px 0 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field{display:block;margin:0 20px;border-width:1px;border-style:solid;border-radius:8px;padding:2px 8px 2px 15px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-wrapper{padding-bottom:0}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-infix{border-top:0}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-underline,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header>.mat-form-field .mat-form-field-subscript-wrapper{display:none}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .expansion-body-header+.expansion-body-content{height:calc(100% - 60px)}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-slide-toggle .mat-slide-toggle-content{flex:1 1 auto}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer{position:sticky;height:40px;bottom:0;display:grid;grid-template-columns:repeat(3,1fr);align-items:center;justify-content:flex-end;padding:0 20px}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer>*{grid-column:2;justify-self:center}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer>*:first-child{grid-column:1;justify-self:flex-start}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel .mat-expansion-panel-body .mat-profile-expansion-panel-footer>*:last-child{grid-column:3;justify-self:flex-end}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.notifications-expansion-panel:not(.has-footer) .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.help-expansion-panel:not(.has-footer) .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.settings-expansion-panel:not(.has-footer) .mat-expansion-panel-content{height:calc(100% - 46px)}.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.notifications-expansion-panel.has-footer .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.help-expansion-panel.has-footer .mat-expansion-panel-content,.mat-profile-panel .mat-drawer-inner-container .profile-panel-container .mat-accordion>.mat-expansion-panel.settings-expansion-panel.has-footer .mat-expansion-panel-content{height:calc(100% - 86px)}\n"] }]
        }], propDecorators: { profileFooter: [{
                type: ContentChild,
                args: [MatProfilePanelFooter]
            }], profileFooterContent: [{
                type: ContentChild,
                args: [MatProfilePanelFooterContent]
            }] } });
/** Footer used in the Expansion Panels within profile panel */
class MatProfileExpansionPanelFooter {
}
MatProfileExpansionPanelFooter.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileExpansionPanelFooter, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatProfileExpansionPanelFooter.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfileExpansionPanelFooter, selector: "mat-profile-expansion-panel-footer", host: { classAttribute: "mat-profile-expansion-panel-footer" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfileExpansionPanelFooter, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-profile-expansion-panel-footer',
                    template: '<ng-content></ng-content>',
                    host: {
                        class: 'mat-profile-expansion-panel-footer'
                    }
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Used to provide a drawer container to a drawer while avoiding circular references.
 * @docs-private
 */
const MAT_DRAWER_CONTAINER = new InjectionToken('MAT_DRAWER_CONTAINER');
/** Component that wraps page content */
class MatAppContent extends MatDrawerContent {
    constructor(changeDetectorRef, container, elementRef, scrollDispatcher, ngZone) {
        super(changeDetectorRef, container, elementRef, scrollDispatcher, ngZone);
    }
}
MatAppContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppContent, deps: [{ token: i0.ChangeDetectorRef }, { token: forwardRef(() => MatAppPanels) }, { token: i0.ElementRef }, { token: i1.ScrollDispatcher }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component });
MatAppContent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatAppContent, selector: "mat-app-content", host: { properties: { "style.margin-left.px": "_container._contentMargins.left", "style.margin-right.px": "_container._contentMargins.right" }, classAttribute: "mat-drawer-content mat-app-panels-content" }, providers: [
        {
            provide: CdkScrollable,
            useExisting: MatAppContent
        }
    ], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppContent, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-app-content',
                    template: '<ng-content></ng-content>',
                    host: {
                        class: 'mat-drawer-content mat-app-panels-content',
                        '[style.margin-left.px]': '_container._contentMargins.left',
                        '[style.margin-right.px]': '_container._contentMargins.right'
                    },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    providers: [
                        {
                            provide: CdkScrollable,
                            useExisting: MatAppContent
                        }
                    ]
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: MatAppPanels, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => MatAppPanels)]
                }] }, { type: i0.ElementRef }, { type: i1.ScrollDispatcher }, { type: i0.NgZone }]; } });
/** Component for layout of Nav panel, Profile panel and page content */
class MatAppPanels extends MatDrawerContainer {
    constructor() {
        super(...arguments);
        /** Whether the backdrop is shown when a panel is open */
        this._showBackdrop = false;
        this._enableBackdrop = true;
        /** Emits pageScrolledChange event when App Content is scrolled */
        this.pageScrolledChange = new EventEmitter();
    }
    /** Enable backdrop to be shown when applicable */
    get enableBackdrop() {
        return this._enableBackdrop;
    }
    set enableBackdrop(value) {
        this._enableBackdrop = coerceBooleanProperty(value);
        this._checkBackdrop();
    }
    ngAfterContentInit() {
        super.ngAfterContentInit();
        this._allDrawers.forEach((panel) => {
            panel.openedStart.subscribe(() => {
                this._setShowBackdrop();
            });
            panel.closedStart.subscribe(() => {
                this._checkBackdrop(panel);
            });
        });
        this.contentSubscription = this._content
            .elementScrolled()
            .subscribe((event) => {
            this.pageScrolledChange.emit(event);
        });
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        if (this.contentSubscription) {
            this.contentSubscription.unsubscribe();
        }
    }
    /** Shows backdrop when a panel is open and backdrop is enabled */
    _setShowBackdrop() {
        this._showBackdrop = this.enableBackdrop;
        this._changeDetectorRef.detectChanges();
    }
    /** Checks to see if backdrop should be shown */
    _checkBackdrop(panel) {
        let showBackdrop = false;
        if ((this.matNavPanel?.opened || this.matProfilePanel?.opened) &&
            this.enableBackdrop) {
            showBackdrop = true;
        }
        if (panel && this.enableBackdrop) {
            if ((panel === this.matNavPanel && this.matProfilePanel?.opened) ||
                (panel === this.matProfilePanel && this.matNavPanel?.opened)) {
                showBackdrop = true;
            }
            else {
                showBackdrop = false;
            }
        }
        this._showBackdrop = showBackdrop;
        this._changeDetectorRef.detectChanges();
    }
}
MatAppPanels.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppPanels, deps: null, target: i0.ɵɵFactoryTarget.Component });
MatAppPanels.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatAppPanels, selector: "mat-app-panels", inputs: { enableBackdrop: "enableBackdrop" }, outputs: { pageScrolledChange: "pageScrolledChange" }, host: { properties: { "class.mat-drawer-container-explicit-backdrop": "_backdropOverride && enableBackdrop" }, classAttribute: "mat-drawer-container mat-app-panels" }, providers: [
        {
            provide: MAT_DRAWER_CONTAINER,
            useExisting: MatAppPanels
        }
    ], queries: [{ propertyName: "matNavPanel", first: true, predicate: MatNavPanel, descendants: true, static: true }, { propertyName: "matProfilePanel", first: true, predicate: MatProfilePanel, descendants: true, static: true }, { propertyName: "_content", first: true, predicate: MatAppContent, descendants: true }, { propertyName: "_allDrawers", predicate: MatDrawer, descendants: true }], exportAs: ["matAppPanels"], usesInheritance: true, ngImport: i0, template: "<div class=\"mat-drawer-backdrop\"\n     (click)=\"_onBackdropClicked()\"\n     [class.mat-backdrop-shown]=\"_showBackdrop && enableBackdrop\">\n</div>\n\n<ng-content select=\"mat-nav-panel, mat-profile-panel\"></ng-content>\n\n<ng-content select=\"mat-app-content\"></ng-content>", styles: [".mat-drawer-container{position:relative;z-index:1;box-sizing:border-box;-webkit-overflow-scrolling:touch;display:block;overflow:hidden}.mat-drawer-container[fullscreen]{inset:0;position:absolute}.mat-drawer-container[fullscreen].mat-drawer-container-has-open{overflow:hidden}.mat-drawer-container.mat-drawer-container-explicit-backdrop .mat-drawer-side{z-index:3}.mat-drawer-container.ng-animate-disabled .mat-drawer-backdrop,.mat-drawer-container.ng-animate-disabled .mat-drawer-content,.ng-animate-disabled .mat-drawer-container .mat-drawer-backdrop,.ng-animate-disabled .mat-drawer-container .mat-drawer-content{transition:none}.mat-drawer-backdrop{inset:0;position:absolute;display:block;z-index:3;visibility:hidden}.mat-drawer-backdrop.mat-drawer-shown{visibility:visible}.mat-drawer-transition .mat-drawer-backdrop{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:background-color,visibility}.cdk-high-contrast-active .mat-drawer-backdrop{opacity:.5}.mat-drawer-content{position:relative;z-index:1;display:block;height:100%;overflow:auto}.mat-drawer-transition .mat-drawer-content{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:transform,margin-left,margin-right}.mat-drawer-trigger{z-index:1000;display:flex;align-items:center;position:absolute;top:0;bottom:0;left:0}[dir=rtl] .mat-drawer-trigger{right:0;left:unset}.mat-drawer{position:relative;z-index:4;display:block;position:absolute;top:0;bottom:0;z-index:3;outline:0;box-sizing:border-box;overflow-y:auto;transform:translate(-100%)}.cdk-high-contrast-active .mat-drawer,.cdk-high-contrast-active [dir=rtl] .mat-drawer.mat-drawer-end{border-right:solid 1px currentColor}.cdk-high-contrast-active [dir=rtl] .mat-drawer,.cdk-high-contrast-active .mat-drawer.mat-drawer-end{border-left:solid 1px currentColor;border-right:none}.mat-drawer.mat-drawer-side{z-index:2}.mat-drawer.mat-drawer-end{right:0;transform:translate(100%)}[dir=rtl] .mat-drawer{transform:translate(100%)}[dir=rtl] .mat-drawer.mat-drawer-end{left:0;right:auto;transform:translate(-100%)}.mat-drawer[style*=\"visibility: hidden\"]{display:none}.mat-drawer.mat-drawer-scroll-disabled,.mat-drawer.mat-drawer-scroll-disabled .mat-drawer-inner-container{overflow:unset}.mat-drawer-inner-container{width:100%;height:100%;overflow:auto;-webkit-overflow-scrolling:touch}.mat-sidenav-fixed{position:fixed}\n", ".mat-header+.mat-drawer-container>.mat-drawer-backdrop{position:fixed}.mat-header+.mat-app-panels{width:100%;overflow-y:visible;overflow-x:hidden;transition:top ease-in-out .25s}.mat-header+.mat-app-panels>.mat-backdrop-shown{visibility:visible}.mat-header+.mat-app-panels>.mat-app-bar-panel{transition:top ease-in-out .25s;bottom:0;overflow:hidden;position:fixed}.mat-header+.mat-app-panels>.mat-app-bar-panel .panel-scrollbar{scrollbar-width:thin}.mat-header+.mat-app-panels>.mat-app-bar-panel .panel-scrollbar::-webkit-scrollbar{width:8px;height:8px}.mat-header+.mat-app-panels>.mat-app-bar-panel .panel-scrollbar::-webkit-scrollbar-thumb{border-radius:3px}.mat-header+.mat-app-panels>.mat-app-bar-panel a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){text-decoration:none}.mat-header+.mat-app-panels>.mat-app-bar-panel a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab):hover,.mat-header+.mat-app-panels>.mat-app-bar-panel a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab).cdk-keyboard-focused{text-decoration:underline}.mat-header:not(.app-banner-visible)+.mat-app-panels>.mat-app-bar-panel{height:calc(100vh - 60px);top:60px}.mat-header:not(.app-banner-visible):not(.page-bar-hidden,.app-bar-collapsed)+.mat-app-panels{height:calc(100vh - 120px)}.mat-header:not(.app-banner-visible).app-bar-collapsed+.mat-app-panels,.mat-header:not(.app-banner-visible).page-bar-hidden+.mat-app-panels{height:calc(100vh - 60px);transition:top ease-in-out .25s .25s,height ease-in-out .25s .25s}.mat-header:not(.app-banner-visible).app-bar-collapsed+.mat-app-panels>.mat-drawer-backdrop,.mat-header:not(.app-banner-visible).page-bar-hidden+.mat-app-panels>.mat-drawer-backdrop{margin-top:-60px}.mat-header.app-banner-visible+.mat-app-panels>.mat-app-bar-panel{height:calc(100vh - 120px);top:120px}.mat-header.app-banner-visible:not(.page-bar-hidden,.app-bar-collapsed)+.mat-app-panels{height:calc(100vh - 180px)}.mat-header.app-banner-visible.app-bar-collapsed+.mat-app-panels,.mat-header.app-banner-visible.page-bar-hidden+.mat-app-panels{transition:top ease-in-out .25s .25s}.mat-header.app-banner-visible.app-bar-collapsed+.mat-app-panels>.mat-drawer-backdrop,.mat-header.app-banner-visible.page-bar-hidden+.mat-app-panels>.mat-drawer-backdrop{margin-top:-120px}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppPanels, decorators: [{
            type: Component,
            args: [{ selector: 'mat-app-panels', exportAs: 'matAppPanels', host: {
                        class: 'mat-drawer-container mat-app-panels',
                        '[class.mat-drawer-container-explicit-backdrop]': '_backdropOverride && enableBackdrop'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, providers: [
                        {
                            provide: MAT_DRAWER_CONTAINER,
                            useExisting: MatAppPanels
                        }
                    ], template: "<div class=\"mat-drawer-backdrop\"\n     (click)=\"_onBackdropClicked()\"\n     [class.mat-backdrop-shown]=\"_showBackdrop && enableBackdrop\">\n</div>\n\n<ng-content select=\"mat-nav-panel, mat-profile-panel\"></ng-content>\n\n<ng-content select=\"mat-app-content\"></ng-content>", styles: [".mat-drawer-container{position:relative;z-index:1;box-sizing:border-box;-webkit-overflow-scrolling:touch;display:block;overflow:hidden}.mat-drawer-container[fullscreen]{inset:0;position:absolute}.mat-drawer-container[fullscreen].mat-drawer-container-has-open{overflow:hidden}.mat-drawer-container.mat-drawer-container-explicit-backdrop .mat-drawer-side{z-index:3}.mat-drawer-container.ng-animate-disabled .mat-drawer-backdrop,.mat-drawer-container.ng-animate-disabled .mat-drawer-content,.ng-animate-disabled .mat-drawer-container .mat-drawer-backdrop,.ng-animate-disabled .mat-drawer-container .mat-drawer-content{transition:none}.mat-drawer-backdrop{inset:0;position:absolute;display:block;z-index:3;visibility:hidden}.mat-drawer-backdrop.mat-drawer-shown{visibility:visible}.mat-drawer-transition .mat-drawer-backdrop{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:background-color,visibility}.cdk-high-contrast-active .mat-drawer-backdrop{opacity:.5}.mat-drawer-content{position:relative;z-index:1;display:block;height:100%;overflow:auto}.mat-drawer-transition .mat-drawer-content{transition-duration:.4s;transition-timing-function:cubic-bezier(.25,.8,.25,1);transition-property:transform,margin-left,margin-right}.mat-drawer-trigger{z-index:1000;display:flex;align-items:center;position:absolute;top:0;bottom:0;left:0}[dir=rtl] .mat-drawer-trigger{right:0;left:unset}.mat-drawer{position:relative;z-index:4;display:block;position:absolute;top:0;bottom:0;z-index:3;outline:0;box-sizing:border-box;overflow-y:auto;transform:translate(-100%)}.cdk-high-contrast-active .mat-drawer,.cdk-high-contrast-active [dir=rtl] .mat-drawer.mat-drawer-end{border-right:solid 1px currentColor}.cdk-high-contrast-active [dir=rtl] .mat-drawer,.cdk-high-contrast-active .mat-drawer.mat-drawer-end{border-left:solid 1px currentColor;border-right:none}.mat-drawer.mat-drawer-side{z-index:2}.mat-drawer.mat-drawer-end{right:0;transform:translate(100%)}[dir=rtl] .mat-drawer{transform:translate(100%)}[dir=rtl] .mat-drawer.mat-drawer-end{left:0;right:auto;transform:translate(-100%)}.mat-drawer[style*=\"visibility: hidden\"]{display:none}.mat-drawer.mat-drawer-scroll-disabled,.mat-drawer.mat-drawer-scroll-disabled .mat-drawer-inner-container{overflow:unset}.mat-drawer-inner-container{width:100%;height:100%;overflow:auto;-webkit-overflow-scrolling:touch}.mat-sidenav-fixed{position:fixed}\n", ".mat-header+.mat-drawer-container>.mat-drawer-backdrop{position:fixed}.mat-header+.mat-app-panels{width:100%;overflow-y:visible;overflow-x:hidden;transition:top ease-in-out .25s}.mat-header+.mat-app-panels>.mat-backdrop-shown{visibility:visible}.mat-header+.mat-app-panels>.mat-app-bar-panel{transition:top ease-in-out .25s;bottom:0;overflow:hidden;position:fixed}.mat-header+.mat-app-panels>.mat-app-bar-panel .panel-scrollbar{scrollbar-width:thin}.mat-header+.mat-app-panels>.mat-app-bar-panel .panel-scrollbar::-webkit-scrollbar{width:8px;height:8px}.mat-header+.mat-app-panels>.mat-app-bar-panel .panel-scrollbar::-webkit-scrollbar-thumb{border-radius:3px}.mat-header+.mat-app-panels>.mat-app-bar-panel a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){text-decoration:none}.mat-header+.mat-app-panels>.mat-app-bar-panel a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab):hover,.mat-header+.mat-app-panels>.mat-app-bar-panel a.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab).cdk-keyboard-focused{text-decoration:underline}.mat-header:not(.app-banner-visible)+.mat-app-panels>.mat-app-bar-panel{height:calc(100vh - 60px);top:60px}.mat-header:not(.app-banner-visible):not(.page-bar-hidden,.app-bar-collapsed)+.mat-app-panels{height:calc(100vh - 120px)}.mat-header:not(.app-banner-visible).app-bar-collapsed+.mat-app-panels,.mat-header:not(.app-banner-visible).page-bar-hidden+.mat-app-panels{height:calc(100vh - 60px);transition:top ease-in-out .25s .25s,height ease-in-out .25s .25s}.mat-header:not(.app-banner-visible).app-bar-collapsed+.mat-app-panels>.mat-drawer-backdrop,.mat-header:not(.app-banner-visible).page-bar-hidden+.mat-app-panels>.mat-drawer-backdrop{margin-top:-60px}.mat-header.app-banner-visible+.mat-app-panels>.mat-app-bar-panel{height:calc(100vh - 120px);top:120px}.mat-header.app-banner-visible:not(.page-bar-hidden,.app-bar-collapsed)+.mat-app-panels{height:calc(100vh - 180px)}.mat-header.app-banner-visible.app-bar-collapsed+.mat-app-panels,.mat-header.app-banner-visible.page-bar-hidden+.mat-app-panels{transition:top ease-in-out .25s .25s}.mat-header.app-banner-visible.app-bar-collapsed+.mat-app-panels>.mat-drawer-backdrop,.mat-header.app-banner-visible.page-bar-hidden+.mat-app-panels>.mat-drawer-backdrop{margin-top:-120px}\n"] }]
        }], propDecorators: { enableBackdrop: [{
                type: Input
            }], pageScrolledChange: [{
                type: Output
            }], _allDrawers: [{
                type: ContentChildren,
                args: [MatDrawer, {
                        // We need to use `descendants: true`, because Ivy will no longer match
                        // indirect descendants if it's left as false.
                        descendants: true
                    }]
            }], matNavPanel: [{
                type: ContentChild,
                args: [MatNavPanel, { static: true }]
            }], matProfilePanel: [{
                type: ContentChild,
                args: [MatProfilePanel, { static: true }]
            }], _content: [{
                type: ContentChild,
                args: [MatAppContent]
            }] } });

/* eslint-disable @angular-eslint/directive-selector */
const _MatNavMenuListBase = mixinDisableRipple(class {
});
const _MatNavMenuOptionBase = mixinDisableRipple(class {
});
/** @docs-private */
const MAT_NAV_MENU_LIST_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => MatNavMenuList),
    multi: false
};
/** Change event that is being fired whenever the selected state of an option changes. */
class MatNavMenuListChange {
    constructor(
    /** Reference to the nav menu list that emitted the event. */
    source, 
    /** Reference to the options that have been changed. */
    options) {
        this.source = source;
        this.options = options;
    }
}
/**
 * Component for nav-menu-options of nav-menu-list. Each nav-menu-options can put current item
 * into the selectionModel of nav-menu-list if the current item is selected.
 */
class MatNavMenuOption extends _MatNavMenuOptionBase {
    constructor(_element, _changeDetector, 
    /** @docs-private */
    navMenuList) {
        super();
        this._element = _element;
        this._changeDetector = _changeDetector;
        this.navMenuList = navMenuList;
        this._selected = false;
        this._disabled = false;
        this._hasFocus = false;
        /**
         * Emits when the selected state of the option has changed.
         * Use to facilitate two-data binding to the `selected` property.
         * @docs-private
         */
        this.selectedChange = new EventEmitter();
        /**
         * This is set to true after the first OnChanges cycle so we don't clear the value of `selected`
         * in the first cycle.
         */
        this._inputsInitialized = false;
    }
    /** Value of the option */
    get value() {
        return this._value;
    }
    set value(newValue) {
        if (this.selected &&
            !this.navMenuList.compareWith(newValue, this.value) &&
            this._inputsInitialized) {
            this.selected = false;
        }
        this._value = newValue;
    }
    /** Whether the option is disabled. */
    get disabled() {
        return this._disabled || (this.navMenuList && this.navMenuList.disabled);
    }
    set disabled(value) {
        const newValue = coerceBooleanProperty(value);
        if (newValue !== this._disabled) {
            this._disabled = newValue;
            this._changeDetector.markForCheck();
        }
    }
    /** Whether the option is selected. */
    get selected() {
        return this.navMenuList.selectedOptions.isSelected(this);
    }
    set selected(value) {
        const isSelected = coerceBooleanProperty(value);
        if (isSelected !== this._selected) {
            this._setSelected(isSelected);
            if (isSelected) {
                this.navMenuList._reportValueChange();
            }
        }
    }
    ngOnInit() {
        const list = this.navMenuList;
        if (list._value &&
            list._value.some((value) => list.compareWith(this._value, value))) {
            this._setSelected(true);
        }
        const wasSelected = this._selected;
        // List options that are selected at initialization can't be reported properly to the form
        // control. This is because it takes some time until the selection-list knows about all
        // available options. Also it can happen that the ControlValueAccessor has an initial value
        // that should be used instead. Deferring the value change report to the next tick ensures
        // that the form control value is not being overwritten.
        Promise.resolve().then(() => {
            if (this._selected || wasSelected) {
                this.selected = true;
                this._changeDetector.markForCheck();
            }
        });
        this._inputsInitialized = true;
    }
    ngOnDestroy() {
        if (this.selected) {
            // We have to delay this until the next tick in order
            // to avoid changed after checked errors.
            Promise.resolve().then(() => {
                this.selected = false;
            });
        }
        const hadFocus = this._hasFocus;
        const newActiveItem = this.navMenuList._removeOptionFromList(this);
        // Only move focus if this option was focused at the time it was destroyed.
        if (hadFocus && newActiveItem) {
            newActiveItem.focus();
        }
    }
    /** Toggles the selection state of the option. */
    toggle() {
        this.selected = !this.selected;
    }
    /** Allows for programmatic focusing of the option. */
    focus() {
        this._element.nativeElement.focus();
    }
    /** Whether the option has focus. */
    hasFocus() {
        return this._hasFocus;
    }
    /**
     * Returns the list item's text label. Implemented as a part of the FocusKeyManager.
     * @docs-private
     */
    getLabel() {
        return this._text ? this._text.nativeElement.textContent || '' : '';
    }
    /** Whether this list item should show a ripple effect when clicked. */
    _isRippleDisabled() {
        return (this.disabled || this.disableRipple || this.navMenuList.disableRipple);
    }
    /** Handles click event for nav menu list options */
    _handleClick() {
        if (!this.disabled && !this.selected) {
            this.toggle();
            // Emit a change event if the selected state of the option changed through user interaction.
            this.navMenuList._emitChangeEvent([this]);
        }
    }
    /** Handles focus event for nav menu list options */
    _handleFocus() {
        this.navMenuList._setFocusedOption(this);
        this._hasFocus = true;
    }
    /** Handles blur event for nav menu list options */
    _handleBlur() {
        this.navMenuList._onTouched();
        this._hasFocus = false;
    }
    /** Retrieves the DOM element of the component host. */
    _getHostElement() {
        return this._element.nativeElement;
    }
    /** Sets the selected state of the option. Returns whether the value has changed. */
    _setSelected(selected) {
        if (selected === this._selected) {
            return false;
        }
        this._selected = selected;
        if (selected) {
            this.navMenuList.selectedOptions.select(this);
        }
        else {
            this.navMenuList.selectedOptions.deselect(this);
        }
        this.selectedChange.emit(selected);
        this._changeDetector.markForCheck();
        return true;
    }
    /**
     * Notifies Angular that the option needs to be checked in the next change detection run. Mainly
     * used to trigger an update of the list option if the disabled state of the nav menu list
     * changed.
     */
    _markForCheck() {
        this._changeDetector.markForCheck();
    }
}
MatNavMenuOption.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavMenuOption, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: forwardRef(() => MatNavMenuList) }], target: i0.ɵɵFactoryTarget.Component });
MatNavMenuOption.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatNavMenuOption, selector: "mat-nav-menu-option", inputs: { disableRipple: "disableRipple", value: "value", disabled: "disabled", selected: "selected" }, outputs: { selectedChange: "selectedChange" }, host: { attributes: { "role": "option" }, listeners: { "focus": "_handleFocus()", "blur": "_handleBlur()", "click": "_handleClick()" }, properties: { "class.has-focus": "this._hasFocus", "class.mat-nav-menu-option-disabled": "disabled", "class.mat-nav-menu-selected-option": "selected", "attr.aria-selected": "selected", "attr.aria-disabled": "disabled", "attr.tabindex": "-1" }, classAttribute: "mat-nav-menu-item mat-nav-menu-option mat-focus-indicator" }, viewQueries: [{ propertyName: "_text", first: true, predicate: ["text"], descendants: true, static: true }], exportAs: ["matNavMenuOption"], usesInheritance: true, ngImport: i0, template: "<div class=\"mat-nav-menu-item-content\">\n\n  <div mat-ripple\n       class=\"mat-nav-menu-item-ripple\"\n       [matRippleTrigger]=\"_getHostElement()\"\n       [matRippleDisabled]=\"_isRippleDisabled()\"></div>\n\n  <div class=\"mat-nav-menu-text\"\n       [attr.data-label-text]=\"getLabel()\"\n       #text>\n    <ng-content></ng-content>\n  </div>\n\n</div>", directives: [{ type: i3$2.MatRipple, selector: "[mat-ripple], [matRipple]", inputs: ["matRippleColor", "matRippleUnbounded", "matRippleCentered", "matRippleRadius", "matRippleAnimation", "matRippleDisabled", "matRippleTrigger"], exportAs: ["matRipple"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavMenuOption, decorators: [{
            type: Component,
            args: [{ selector: 'mat-nav-menu-option', exportAs: 'matNavMenuOption', inputs: ['disableRipple'], host: {
                        role: 'option',
                        class: 'mat-nav-menu-item mat-nav-menu-option mat-focus-indicator',
                        '[class.has-focus]': 'this._hasFocus',
                        '(focus)': '_handleFocus()',
                        '(blur)': '_handleBlur()',
                        '(click)': '_handleClick()',
                        '[class.mat-nav-menu-option-disabled]': 'disabled',
                        '[class.mat-nav-menu-selected-option]': 'selected',
                        '[attr.aria-selected]': 'selected',
                        '[attr.aria-disabled]': 'disabled',
                        '[attr.tabindex]': '-1'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"mat-nav-menu-item-content\">\n\n  <div mat-ripple\n       class=\"mat-nav-menu-item-ripple\"\n       [matRippleTrigger]=\"_getHostElement()\"\n       [matRippleDisabled]=\"_isRippleDisabled()\"></div>\n\n  <div class=\"mat-nav-menu-text\"\n       [attr.data-label-text]=\"getLabel()\"\n       #text>\n    <ng-content></ng-content>\n  </div>\n\n</div>" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: MatNavMenuList, decorators: [{
                    type: Inject,
                    args: [forwardRef(() => MatNavMenuList)]
                }] }]; }, propDecorators: { selectedChange: [{
                type: Output
            }], _text: [{
                type: ViewChild,
                args: ['text', { static: true }]
            }], value: [{
                type: Input
            }], disabled: [{
                type: Input
            }], selected: [{
                type: Input
            }] } });
/**
 * Material Design list component where each item is a selectable option. Behaves as a listbox.
 */
class MatNavMenuList extends _MatNavMenuListBase {
    constructor(_element, 
    // @breaking-change 11.0.0 Remove `tabIndex` parameter.
    tabIndex, _changeDetector, _focusMonitor) {
        super();
        this._element = _element;
        this._changeDetector = _changeDetector;
        this._focusMonitor = _focusMonitor;
        this._contentInitialized = false;
        /** Emits a change event whenever the selected state of an option changes. */
        this.selectionChange = new EventEmitter();
        /** Emits a change event whenever the focus state of an option changes. */
        this.focusChange = new EventEmitter();
        /**
         * Tabindex of the nav menu list.
         * @breaking-change 11.0.0 Remove `tabIndex` input. Check Selection List to see what they do in the future
         */
        this.tabIndex = 0;
        /**
         * Function used for comparing an option against the selected value when determining which
         * options should appear as selected. The first argument is the value of an options. The second
         * one is a value from the selected value. A boolean must be returned.
         */
        this.compareWith = (a1, a2) => a1 === a2;
        this._disabled = false;
        /** The currently selected options. */
        this.selectedOptions = new SelectionModel(false);
        /** The tabindex of the nav menu list. */
        this._tabIndex = -1;
        /** View to model callback that should be called whenever the selected options change. */
        this._onChange = (_) => { };
        /** Emits when the list has been destroyed. */
        this._destroyed = new Subject();
        /** View to model callback that should be called if the list or its options lost focus. */
        this._onTouched = () => { };
    }
    /** Whether the nav menu list is disabled. */
    get disabled() {
        return this._disabled;
    }
    set disabled(value) {
        this._disabled = coerceBooleanProperty(value);
        // The `MatNavMenuOption` are using the `OnPush` change detection
        // strategy. Therefore the options will not check for any changes if the `MatNavMenuList`
        // changed its state. Since we know that a change to `disabled` property of the list affects
        // the state of the options, we manually mark each option for check.
        this._markOptionsForCheck();
    }
    ngAfterContentInit() {
        this._keyManager = new FocusKeyManager(this.options)
            .withWrap()
            .withTypeAhead()
            .withHomeAndEnd()
            // Allow disabled items to be focusable. For accessibility reasons, there must be a way for
            // screenreader users, that allows reading the different options of the list.
            .skipPredicate(() => false)
            .withAllowedModifierKeys(['shiftKey']);
        if (this._value) {
            this._setOptionsFromValues(this._value);
        }
        // If the user attempts to tab out of the nav menu list, allow focus to escape.
        this._keyManager.tabOut.pipe(takeUntil(this._destroyed)).subscribe(() => {
            this._allowFocusEscape();
        });
        // When the number of options change, update the tabindex of the nav menu list.
        this.options.changes
            .pipe(startWith(null), takeUntil(this._destroyed))
            .subscribe(() => {
            this._updateTabIndex();
        });
        // Sync external changes to the model back to the options.
        this.selectedOptions.changed
            .pipe(takeUntil(this._destroyed))
            .subscribe((event) => {
            if (event.added) {
                for (let item of event.added) {
                    item.selected = true;
                }
            }
            if (event.removed) {
                for (let item of event.removed) {
                    item.selected = false;
                }
            }
        });
        this._focusMonitor
            .monitor(this._element)
            .pipe(takeUntil(this._destroyed))
            .subscribe((origin) => {
            if (origin === 'keyboard' || origin === 'program') {
                let toFocus = 0;
                for (let i = 0; i < this.options.length; i++) {
                    if (this.options.get(i)?.selected) {
                        toFocus = i;
                        break;
                    }
                }
                this._keyManager.setActiveItem(toFocus);
                this.focusChange.emit(this.options.get(toFocus)); // VDL change
            }
        });
    }
    ngOnChanges(changes) {
        const disableRippleChanges = changes['disableRipple'];
        if (disableRippleChanges && !disableRippleChanges.firstChange) {
            this._markOptionsForCheck();
        }
    }
    ngOnDestroy() {
        // @breaking-change 11.0.0 Remove null assertion once _focusMonitor is required.
        this._focusMonitor?.stopMonitoring(this._element);
        this._destroyed.next();
        this._destroyed.complete();
        this._isDestroyed = true;
    }
    /** Focuses the nav menu list. */
    focus(options) {
        this._element.nativeElement.focus(options);
    }
    /** Sets the focused option of the nav-menu-list. */
    _setFocusedOption(option) {
        this._keyManager.updateActiveItem(option);
        this.focusChange.emit(option);
    }
    /**
     * Removes an option from the nav menu list and updates the active item.
     * @returns Currently-active item.
     */
    _removeOptionFromList(option) {
        const optionIndex = this._getOptionIndex(option);
        if (optionIndex > -1 && this._keyManager.activeItemIndex === optionIndex) {
            // Check whether the option is the last item
            if (optionIndex > 0) {
                this._keyManager.updateActiveItem(optionIndex - 1);
            }
            else if (optionIndex === 0 && this.options.length > 1) {
                this._keyManager.updateActiveItem(Math.min(optionIndex + 1, this.options.length - 1));
            }
        }
        return this._keyManager.activeItem;
    }
    /** Passes relevant key presses to our key manager. */
    _keydown(event) {
        const keyCode = event.keyCode;
        const manager = this._keyManager;
        const hasModifier = hasModifierKey(event);
        switch (keyCode) {
            case SPACE:
            case ENTER:
                if (!hasModifier && !manager.isTyping()) {
                    this._toggleFocusedOption();
                    // Always prevent space from scrolling the page since the list has focus
                    event.preventDefault();
                }
                break;
            default:
                manager.onKeydown(event);
        }
    }
    /** Reports a value change to the ControlValueAccessor */
    _reportValueChange() {
        // Stop reporting value changes after the list has been destroyed. This avoids
        // cases where the list might wrongly reset its value once it is removed, but
        // the form control is still live.
        if (this.options && !this._isDestroyed) {
            const value = this._getSelectedOptionValues();
            this._onChange(value);
            this._value = value;
        }
    }
    /** Emits a change event if the selected state of an option changed. */
    _emitChangeEvent(options) {
        this.selectionChange.emit(new MatNavMenuListChange(this, options));
    }
    /** Implemented as part of ControlValueAccessor. */
    writeValue(values) {
        this._value = values;
        if (this.options) {
            this._setOptionsFromValues(values || []);
        }
    }
    /** Implemented as a part of ControlValueAccessor. */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn) {
        this._onChange = fn;
    }
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /** Sets the selected options based on the specified values. */
    _setOptionsFromValues(values) {
        this.options.forEach((option) => option._setSelected(false));
        values.forEach((value) => {
            const correspondingOption = this.options.find((option) => {
                // Skip options that are already in the model. This allows us to handle cases
                // where the same primitive value is selected multiple times.
                return option.selected ? false : this.compareWith(option.value, value);
            });
            if (correspondingOption) {
                correspondingOption._setSelected(true);
            }
        });
    }
    /** Returns the values of the selected options. */
    _getSelectedOptionValues() {
        return this.options
            .filter((option) => option.selected)
            .map((option) => option.value);
    }
    /** Toggles the state of the currently focused option if enabled. */
    _toggleFocusedOption() {
        let focusedIndex = this._keyManager.activeItemIndex;
        if (focusedIndex != null && this._isValidIndex(focusedIndex)) {
            let focusedOption = this.options.toArray()[focusedIndex];
            if (focusedOption && !focusedOption.disabled && !focusedOption.selected) {
                focusedOption.toggle();
                // Emit a change event because the focused option changed its state through user
                // interaction.
                this._emitChangeEvent([focusedOption]);
            }
        }
    }
    /**
     * Utility to ensure all indexes are valid.
     * @param index The index to be checked.
     * @returns True if the index is valid for our list of options.
     */
    _isValidIndex(index) {
        return index >= 0 && index < this.options.length;
    }
    /** Returns the index of the specified list option. */
    _getOptionIndex(option) {
        return this.options.toArray().indexOf(option);
    }
    /** Marks all the options to be checked in the next change detection run. */
    _markOptionsForCheck() {
        if (this.options) {
            this.options.forEach((option) => option._markForCheck());
        }
    }
    /**
     * Removes the tabindex from the nav menu list and resets it back afterwards, allowing the user
     * to tab out of it. This prevents the list from capturing focus and redirecting it back within
     * the list, creating a focus trap if it user tries to tab away.
     */
    _allowFocusEscape() {
        this._tabIndex = -1;
        setTimeout(() => {
            this._tabIndex = 0;
            this._changeDetector.markForCheck();
        });
    }
    /** Updates the tabindex based upon if the nav-menu list is empty. */
    _updateTabIndex() {
        this._tabIndex = this.options.length === 0 ? -1 : 0;
    }
}
MatNavMenuList.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavMenuList, deps: [{ token: i0.ElementRef }, { token: 'tabindex', attribute: true }, { token: i0.ChangeDetectorRef }, { token: i2$1.FocusMonitor }], target: i0.ɵɵFactoryTarget.Component });
MatNavMenuList.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatNavMenuList, selector: "mat-nav-menu-list", inputs: { disableRipple: "disableRipple", headerLabel: "headerLabel", tabIndex: "tabIndex", compareWith: "compareWith", disabled: "disabled" }, outputs: { selectionChange: "selectionChange", focusChange: "focusChange" }, host: { attributes: { "role": "listbox" }, listeners: { "keydown": "_keydown($event)" }, properties: { "attr.aria-disabled": "disabled.toString()", "attr.tabindex": "_tabIndex" }, classAttribute: "mat-nav-menu-list mat-nav-menu-base" }, providers: [MAT_NAV_MENU_LIST_VALUE_ACCESSOR], queries: [{ propertyName: "options", predicate: MatNavMenuOption, descendants: true }], exportAs: ["matNavMenuList"], usesInheritance: true, usesOnChanges: true, ngImport: i0, template: '<div class="nav-menu-header" *ngIf="!!headerLabel">{{ headerLabel }}</div><ng-content></ng-content>', isInline: true, styles: [".mat-nav-menu-base{padding-top:8px;display:block;-webkit-tap-highlight-color:transparent}.mat-nav-menu-base .mat-nav-menu-option{display:block;min-height:18px;-webkit-tap-highlight-color:transparent;width:100%;padding:6px 0}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-item-content{display:flex;flex-direction:row;align-items:center;box-sizing:border-box;position:relative;height:inherit}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-item-content-reverse{display:flex;align-items:center;flex-direction:row-reverse;justify-content:space-around}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-item-ripple{display:block;inset:0;position:absolute;pointer-events:none}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-text{display:flex;flex-direction:column;flex:auto;box-sizing:border-box;overflow:hidden;padding:0;white-space:normal}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-text>*{margin:0;padding:0;font-weight:400;font-size:inherit}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-text:empty{display:none}.mat-nav-menu-base .mat-nav-menu-option .mat-divider{position:absolute;bottom:0;left:0;width:100%;margin:0}[dir=rtl] .mat-nav-menu-base .mat-nav-menu-option .mat-divider{margin-left:auto;margin-right:0}.mat-nav-menu-base .mat-nav-menu-option .mat-divider.mat-divider-inset{position:absolute}.mat-nav-menu-base[dense]{padding-top:4px;display:block}.mat-nav-menu-base[dense] .mat-nav-menu-option{display:block;min-height:12px;-webkit-tap-highlight-color:transparent;width:100%;padding:6px 0}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-item-content{display:flex;flex-direction:row;align-items:center;box-sizing:border-box;position:relative;height:inherit}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-item-content-reverse{display:flex;align-items:center;flex-direction:row-reverse;justify-content:space-around}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-item-ripple{display:block;inset:0;position:absolute;pointer-events:none}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-text{display:flex;flex-direction:column;flex:auto;box-sizing:border-box;overflow:hidden;padding:0;white-space:normal}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-text>*{margin:0;padding:0;font-weight:400;font-size:inherit}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-text:empty{display:none}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-divider{position:absolute;bottom:0;left:0;width:100%;margin:0}[dir=rtl] .mat-nav-menu-base[dense] .mat-nav-menu-option .mat-divider{margin-left:auto;margin-right:0}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-divider.mat-divider-inset{position:absolute}.mat-nav-menu-option:not(.mat-nav-menu-option-disabled){cursor:pointer;outline:none}.mat-nav-menu-option-disabled{pointer-events:none}.cdk-high-contrast-active .mat-nav-menu-option-disabled{opacity:.5}.cdk-high-contrast-active :host .mat-nav-menu-option-disabled{opacity:.5}.cdk-high-contrast-active .mat-nav-menu-list:focus{outline-style:dotted}.cdk-high-contrast-active .mat-nav-menu-option:hover,.cdk-high-contrast-active .mat-nav-menu-option:focus{outline:dotted 1px;z-index:1}.cdk-high-contrast-active .mat-nav-menu-selected-option:after{content:\"\";position:absolute;top:50%;right:0;transform:translateY(-50%);width:10px;height:0;border-bottom:solid 10px;border-radius:10px}.cdk-high-contrast-active [dir=rtl] .mat-nav-menu-selected-option:after{right:auto;left:0}@media (hover: none){.mat-nav-menu-option:not(.mat-nav-menu-selected-option):not(.mat-nav-menu-option-disabled):hover{background:none}}\n"], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavMenuList, decorators: [{
            type: Component,
            args: [{ selector: 'mat-nav-menu-list', exportAs: 'matNavMenuList', inputs: ['disableRipple'], host: {
                        role: 'listbox',
                        class: 'mat-nav-menu-list mat-nav-menu-base',
                        '(keydown)': '_keydown($event)',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '[attr.tabindex]': '_tabIndex'
                    }, template: '<div class="nav-menu-header" *ngIf="!!headerLabel">{{ headerLabel }}</div><ng-content></ng-content>', encapsulation: ViewEncapsulation.None, providers: [MAT_NAV_MENU_LIST_VALUE_ACCESSOR], changeDetection: ChangeDetectionStrategy.OnPush, styles: [".mat-nav-menu-base{padding-top:8px;display:block;-webkit-tap-highlight-color:transparent}.mat-nav-menu-base .mat-nav-menu-option{display:block;min-height:18px;-webkit-tap-highlight-color:transparent;width:100%;padding:6px 0}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-item-content{display:flex;flex-direction:row;align-items:center;box-sizing:border-box;position:relative;height:inherit}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-item-content-reverse{display:flex;align-items:center;flex-direction:row-reverse;justify-content:space-around}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-item-ripple{display:block;inset:0;position:absolute;pointer-events:none}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-text{display:flex;flex-direction:column;flex:auto;box-sizing:border-box;overflow:hidden;padding:0;white-space:normal}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-text>*{margin:0;padding:0;font-weight:400;font-size:inherit}.mat-nav-menu-base .mat-nav-menu-option .mat-nav-menu-text:empty{display:none}.mat-nav-menu-base .mat-nav-menu-option .mat-divider{position:absolute;bottom:0;left:0;width:100%;margin:0}[dir=rtl] .mat-nav-menu-base .mat-nav-menu-option .mat-divider{margin-left:auto;margin-right:0}.mat-nav-menu-base .mat-nav-menu-option .mat-divider.mat-divider-inset{position:absolute}.mat-nav-menu-base[dense]{padding-top:4px;display:block}.mat-nav-menu-base[dense] .mat-nav-menu-option{display:block;min-height:12px;-webkit-tap-highlight-color:transparent;width:100%;padding:6px 0}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-item-content{display:flex;flex-direction:row;align-items:center;box-sizing:border-box;position:relative;height:inherit}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-item-content-reverse{display:flex;align-items:center;flex-direction:row-reverse;justify-content:space-around}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-item-ripple{display:block;inset:0;position:absolute;pointer-events:none}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-text{display:flex;flex-direction:column;flex:auto;box-sizing:border-box;overflow:hidden;padding:0;white-space:normal}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-text>*{margin:0;padding:0;font-weight:400;font-size:inherit}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-nav-menu-text:empty{display:none}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-divider{position:absolute;bottom:0;left:0;width:100%;margin:0}[dir=rtl] .mat-nav-menu-base[dense] .mat-nav-menu-option .mat-divider{margin-left:auto;margin-right:0}.mat-nav-menu-base[dense] .mat-nav-menu-option .mat-divider.mat-divider-inset{position:absolute}.mat-nav-menu-option:not(.mat-nav-menu-option-disabled){cursor:pointer;outline:none}.mat-nav-menu-option-disabled{pointer-events:none}.cdk-high-contrast-active .mat-nav-menu-option-disabled{opacity:.5}.cdk-high-contrast-active :host .mat-nav-menu-option-disabled{opacity:.5}.cdk-high-contrast-active .mat-nav-menu-list:focus{outline-style:dotted}.cdk-high-contrast-active .mat-nav-menu-option:hover,.cdk-high-contrast-active .mat-nav-menu-option:focus{outline:dotted 1px;z-index:1}.cdk-high-contrast-active .mat-nav-menu-selected-option:after{content:\"\";position:absolute;top:50%;right:0;transform:translateY(-50%);width:10px;height:0;border-bottom:solid 10px;border-radius:10px}.cdk-high-contrast-active [dir=rtl] .mat-nav-menu-selected-option:after{right:auto;left:0}@media (hover: none){.mat-nav-menu-option:not(.mat-nav-menu-selected-option):not(.mat-nav-menu-option-disabled):hover{background:none}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: undefined, decorators: [{
                    type: Attribute,
                    args: ['tabindex']
                }] }, { type: i0.ChangeDetectorRef }, { type: i2$1.FocusMonitor }]; }, propDecorators: { headerLabel: [{
                type: Input
            }], options: [{
                type: ContentChildren,
                args: [MatNavMenuOption, { descendants: true }]
            }], selectionChange: [{
                type: Output
            }], focusChange: [{
                type: Output
            }], tabIndex: [{
                type: Input
            }], compareWith: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });
/**
 * Nav Menu List - Nav Menu
 */
class MatNavMenu {
}
MatNavMenu.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavMenu, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatNavMenu.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatNavMenu, selector: "mat-nav-menu-list[mat-nav-menu]", host: { classAttribute: "mat-nav-menu" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavMenu, decorators: [{
            type: Directive,
            args: [{
                    selector: `mat-nav-menu-list[mat-nav-menu]`,
                    host: {
                        class: 'mat-nav-menu'
                    }
                }]
        }] });
/**
 * Nav Menu List - Nav Submenu
 */
class MatNavSubmenu {
}
MatNavSubmenu.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavSubmenu, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatNavSubmenu.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatNavSubmenu, selector: "mat-nav-menu-list[mat-nav-submenu]", host: { classAttribute: "mat-nav-submenu" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavSubmenu, decorators: [{
            type: Directive,
            args: [{
                    selector: `mat-nav-menu-list[mat-nav-submenu]`,
                    host: {
                        class: 'mat-nav-submenu'
                    }
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatNavPanelMenu {
    constructor() {
        /** Whether the submenu should display items in multiple columns */
        this.submenuMultipleColumns = false;
    }
}
MatNavPanelMenu.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavPanelMenu, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatNavPanelMenu.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatNavPanelMenu, selector: "mat-nav-panel-menu, [mat-nav-panel-menu]", inputs: { submenuMultipleColumns: "submenuMultipleColumns" }, host: { properties: { "class.has-submenu": "!!submenu", "class.submenu-multiple-columns": "!!submenu && submenuMultipleColumns" }, classAttribute: "mat-nav-panel-menu" }, queries: [{ propertyName: "submenu", first: true, predicate: MatNavSubmenu, descendants: true, read: MatNavMenuList }], ngImport: i0, template: "<div class=\"nav-menu-content panel-scrollbar\">\n  <ng-content select=\"mat-nav-menu-list[mat-nav-menu]\"></ng-content>\n</div>\n\n<div class=\"nav-submenu-content panel-scrollbar\"\n     *ngIf=\"!!submenu\">\n  <ng-content select=\"mat-nav-menu-list[mat-nav-submenu]\"></ng-content>\n</div>", styles: [".mat-nav-panel-menu{display:flex;justify-content:stretch;position:relative;height:100%}.mat-nav-panel-menu.has-submenu .nav-menu-content .mat-nav-menu-list{width:234px}.mat-nav-panel-menu .nav-menu-content{flex:0 0 auto;padding:0 22px 0 50px;overflow-y:scroll;overflow-x:hidden;min-width:234px;margin:25px 2px 25px 0}.mat-nav-panel-menu .nav-menu-content .mat-nav-menu-item{padding-left:10px;overflow:hidden;white-space:unset}.mat-nav-panel-menu .nav-submenu-content{flex:1 1 auto;padding:0 30px;border-left-width:1px;border-left-style:solid;margin:25px 2px 25px 0;width:240px;height:calc(100% - 50px);overflow-y:scroll;overflow-x:hidden}.mat-nav-panel-menu .nav-submenu-content .nav-menu-header{margin-bottom:10px;column-span:all}.mat-nav-panel-menu .nav-submenu-content .mat-nav-menu-item,.mat-nav-panel-menu .nav-submenu-content .mat-divider{max-width:180px}.mat-nav-panel-menu.submenu-multiple-columns .nav-submenu-content{width:420px;overflow-y:hidden;overflow-x:scroll}.mat-nav-panel-menu.submenu-multiple-columns .nav-submenu-content>.mat-nav-menu-list{column-count:auto;column-fill:auto;column-gap:20px;column-width:180px;height:100%}.mat-nav-panel-menu .mat-divider{margin:11px 0}\n"], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavPanelMenu, decorators: [{
            type: Component,
            args: [{ selector: 'mat-nav-panel-menu, [mat-nav-panel-menu]', host: {
                        class: 'mat-nav-panel-menu',
                        '[class.has-submenu]': '!!submenu',
                        '[class.submenu-multiple-columns]': '!!submenu && submenuMultipleColumns'
                    }, changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, template: "<div class=\"nav-menu-content panel-scrollbar\">\n  <ng-content select=\"mat-nav-menu-list[mat-nav-menu]\"></ng-content>\n</div>\n\n<div class=\"nav-submenu-content panel-scrollbar\"\n     *ngIf=\"!!submenu\">\n  <ng-content select=\"mat-nav-menu-list[mat-nav-submenu]\"></ng-content>\n</div>", styles: [".mat-nav-panel-menu{display:flex;justify-content:stretch;position:relative;height:100%}.mat-nav-panel-menu.has-submenu .nav-menu-content .mat-nav-menu-list{width:234px}.mat-nav-panel-menu .nav-menu-content{flex:0 0 auto;padding:0 22px 0 50px;overflow-y:scroll;overflow-x:hidden;min-width:234px;margin:25px 2px 25px 0}.mat-nav-panel-menu .nav-menu-content .mat-nav-menu-item{padding-left:10px;overflow:hidden;white-space:unset}.mat-nav-panel-menu .nav-submenu-content{flex:1 1 auto;padding:0 30px;border-left-width:1px;border-left-style:solid;margin:25px 2px 25px 0;width:240px;height:calc(100% - 50px);overflow-y:scroll;overflow-x:hidden}.mat-nav-panel-menu .nav-submenu-content .nav-menu-header{margin-bottom:10px;column-span:all}.mat-nav-panel-menu .nav-submenu-content .mat-nav-menu-item,.mat-nav-panel-menu .nav-submenu-content .mat-divider{max-width:180px}.mat-nav-panel-menu.submenu-multiple-columns .nav-submenu-content{width:420px;overflow-y:hidden;overflow-x:scroll}.mat-nav-panel-menu.submenu-multiple-columns .nav-submenu-content>.mat-nav-menu-list{column-count:auto;column-fill:auto;column-gap:20px;column-width:180px;height:100%}.mat-nav-panel-menu .mat-divider{margin:11px 0}\n"] }]
        }], propDecorators: { submenuMultipleColumns: [{
                type: Input
            }], submenu: [{
                type: ContentChild,
                args: [MatNavSubmenu, { read: MatNavMenuList }]
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Icon - Status map */
const ICONS = [
    {
        status: 'error',
        icon: 'error'
    },
    {
        status: 'informational',
        icon: 'info'
    },
    {
        status: 'successful',
        icon: 'check_circle'
    },
    {
        status: 'warning',
        icon: 'warning'
    }
];
/** Notification list item for use in the profile panel notifications expansion panel */
class MatProfilePanelNotification extends MatListItem {
    constructor(_elementRef, _changeDetectorRef, _focusMonitor) {
        super(_elementRef, _changeDetectorRef);
        this._elementRef = _elementRef;
        this._focusMonitor = _focusMonitor;
        /** Notification Clicked event emitter */
        this.notificationClicked = new EventEmitter();
        /** Title Clicked event emitter */
        this.titleClicked = new EventEmitter();
    }
    ngAfterViewInit() {
        this._focusMonitor.monitor(this._elementRef.nativeElement);
    }
    /** returns icon name for the notification type */
    getStatusIcon() {
        const statusMap = ICONS.find((map) => {
            return map.status === this.notification.status;
        });
        return statusMap ? statusMap.icon : null;
    }
    /** Emits Notification Clicked event when list item clicked */
    notificationClickHandler(event, notification) {
        const notificationEvent = {
            event,
            notification
        };
        this.notificationClicked.emit(notificationEvent);
    }
    /** Emits Title Clicked event when Title on list item is clicked */
    titleClickHandler(event, notification) {
        const notificationEvent = {
            event,
            notification
        };
        this.titleClicked.emit(notificationEvent);
    }
}
MatProfilePanelNotification.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelNotification, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }, { token: i2$1.FocusMonitor }], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelNotification.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelNotification, selector: "mat-profile-panel-notification", inputs: { notification: "notification" }, outputs: { notificationClicked: "notificationClicked", titleClicked: "titleClicked" }, host: { listeners: { "focus": "_handleFocus()", "blur": "_handleBlur()", "click": "notificationClickHandler($event, notification)", "keydown.enter": "notificationClickHandler($event, notification)" }, properties: { "class.notification-read-only": "notification.readOnly", "attr.tabindex": "0" }, classAttribute: "mat-profile-panel-notification" }, usesInheritance: true, ngImport: i0, template: "<span class=\"mat-list-item-content\">\n  <span class=\"mat-list-item-ripple\"\n        mat-ripple\n        [matRippleTrigger]=\"_getHostElement()\"\n        [matRippleDisabled]=\"_isRippleDisabled()\">\n  </span>\n\n\n  <div *ngIf=\"!getStatusIcon()\"\n       mat-list-icon>\n    &nbsp;\n  </div>\n\n  <mat-icon *ngIf=\"notification.status\"\n            mat-list-icon\n            fontSet=\"material-symbols-outlined\"\n            class=\"mat-notification-icon\"\n            [ngClass]=\"notification.status + '-icon'\">{{ getStatusIcon() }}\n  </mat-icon>\n\n  <span class=\"mat-list-text\">\n\n\n    <!-- Use click and keydown.enter here for events on title only -->\n    <div mat-line\n         mat-focus-ring\n         role=\"link\"\n         class=\"mat-profile-notification-message\"\n         [ngClass]=\"{\n        'mat-global-notification-message-read': !notification.unread\n      }\"\n         (click)=\"titleClickHandler($event, notification)\"\n         (keydown.enter)=\"titleClickHandler($event, notification)\">\n      {{ notification.message }}\n    </div>\n\n    <div *ngIf=\"notification.description\"\n         mat-line\n         class=\"mat-profile-notification-description\"\n         [ngClass]=\"{\n        'mat-global-notification-description-read': !notification.unread\n      }\">\n      {{ notification.description }}\n    </div>\n  </span>\n\n  <ng-content></ng-content>\n</span>", styles: [".mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item{height:unset;min-height:45px;cursor:pointer;outline:none}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item.mat-2-line{min-height:60px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item.notification-read-only{cursor:default}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content{padding:13px 20px 15px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text{padding-left:10px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text .mat-line{white-space:normal}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text .mat-profile-notification-message{padding-bottom:0}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text .mat-profile-notification-description{margin-top:2px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon{flex:0 0 auto;align-self:flex-start}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-iconspan.mat-icon{margin-top:-5px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon.mat-icon{padding:0;margin-top:-2px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon.mat-icon,.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon .unknown-notification-icon{display:flex;justify-content:center}[dir=rtl] .mat-profile-panel .mat-profile-panel-notification .mat-list-item>.mat-list-item-content>.mat-list-text{padding-left:10px}\n"], components: [{ type: i2$2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i3$2.MatRipple, selector: "[mat-ripple], [matRipple]", inputs: ["matRippleColor", "matRippleUnbounded", "matRippleCentered", "matRippleRadius", "matRippleAnimation", "matRippleDisabled", "matRippleTrigger"], exportAs: ["matRipple"] }, { type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3$1.MatListIconCssMatStyler, selector: "[mat-list-icon], [matListIcon]" }, { type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i3$2.MatLine, selector: "[mat-line], [matLine]" }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelNotification, decorators: [{
            type: Component,
            args: [{ selector: 'mat-profile-panel-notification', encapsulation: ViewEncapsulation.None, host: {
                        class: 'mat-profile-panel-notification',
                        '[class.notification-read-only]': 'notification.readOnly',
                        '(focus)': '_handleFocus()',
                        '(blur)': '_handleBlur()',
                        '(click)': 'notificationClickHandler($event, notification)',
                        '(keydown.enter)': 'notificationClickHandler($event, notification)',
                        '[attr.tabindex]': '0'
                    }, template: "<span class=\"mat-list-item-content\">\n  <span class=\"mat-list-item-ripple\"\n        mat-ripple\n        [matRippleTrigger]=\"_getHostElement()\"\n        [matRippleDisabled]=\"_isRippleDisabled()\">\n  </span>\n\n\n  <div *ngIf=\"!getStatusIcon()\"\n       mat-list-icon>\n    &nbsp;\n  </div>\n\n  <mat-icon *ngIf=\"notification.status\"\n            mat-list-icon\n            fontSet=\"material-symbols-outlined\"\n            class=\"mat-notification-icon\"\n            [ngClass]=\"notification.status + '-icon'\">{{ getStatusIcon() }}\n  </mat-icon>\n\n  <span class=\"mat-list-text\">\n\n\n    <!-- Use click and keydown.enter here for events on title only -->\n    <div mat-line\n         mat-focus-ring\n         role=\"link\"\n         class=\"mat-profile-notification-message\"\n         [ngClass]=\"{\n        'mat-global-notification-message-read': !notification.unread\n      }\"\n         (click)=\"titleClickHandler($event, notification)\"\n         (keydown.enter)=\"titleClickHandler($event, notification)\">\n      {{ notification.message }}\n    </div>\n\n    <div *ngIf=\"notification.description\"\n         mat-line\n         class=\"mat-profile-notification-description\"\n         [ngClass]=\"{\n        'mat-global-notification-description-read': !notification.unread\n      }\">\n      {{ notification.description }}\n    </div>\n  </span>\n\n  <ng-content></ng-content>\n</span>", styles: [".mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item{height:unset;min-height:45px;cursor:pointer;outline:none}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item.mat-2-line{min-height:60px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item.notification-read-only{cursor:default}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content{padding:13px 20px 15px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text{padding-left:10px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text .mat-line{white-space:normal}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text .mat-profile-notification-message{padding-bottom:0}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content>.mat-list-text .mat-profile-notification-description{margin-top:2px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon{flex:0 0 auto;align-self:flex-start}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-iconspan.mat-icon{margin-top:-5px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon.mat-icon{padding:0;margin-top:-2px}.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon.mat-icon,.mat-profile-panel .mat-list-base .mat-profile-panel-notification.mat-list-item>.mat-list-item-content .mat-notification-icon .unknown-notification-icon{display:flex;justify-content:center}[dir=rtl] .mat-profile-panel .mat-profile-panel-notification .mat-list-item>.mat-list-item-content>.mat-list-text{padding-left:10px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i2$1.FocusMonitor }]; }, propDecorators: { notification: [{
                type: Input
            }], notificationClicked: [{
                type: Output
            }], titleClicked: [{
                type: Output
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatAppPanelsModule {
}
MatAppPanelsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppPanelsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MatAppPanelsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppPanelsModule, declarations: [MatNavMenu,
        MatNavSubmenu,
        MatNavMenuOption,
        MatNavMenuList,
        MatNavPanel,
        MatProfilePanelContent,
        MatNavPanelMenu,
        MatProfilePanel,
        MatProfilePanelExpansionBadge,
        MatProfilePanelFooter,
        MatProfilePanelSignOutButton,
        MatProfilePanelFooterContent,
        MatProfilePanelNotification,
        MatProfileExpansionPanelFooter,
        MatProfileNotificationsFooter,
        MatProfileHelpItem,
        MatProfileHelpHeader,
        MatProfileHelpFooter,
        MatProfileSettingItem,
        MatProfilePanelCustomerIdButton,
        MatAppContent,
        MatAppPanels], imports: [CommonModule,
        CdkScrollableModule,
        MatRippleModule,
        MatSidenavModule,
        MatDividerModule,
        MatButtonModule,
        MatExpansionModule,
        MatListModule,
        MatSlideToggleModule,
        MatIconModule,
        MatInputModule,
        MatDialogModule], exports: [MatNavMenu,
        MatNavSubmenu,
        MatNavMenuOption,
        MatNavMenuList,
        MatNavPanel,
        MatNavPanelMenu,
        MatProfilePanel,
        MatProfilePanelExpansionBadge,
        MatProfilePanelContent,
        MatProfilePanelFooter,
        MatProfilePanelSignOutButton,
        MatProfilePanelFooterContent,
        MatProfilePanelNotification,
        MatProfileExpansionPanelFooter,
        MatProfileNotificationsFooter,
        MatProfileHelpItem,
        MatProfileHelpHeader,
        MatProfileHelpFooter,
        MatProfileSettingItem,
        MatProfilePanelCustomerIdButton,
        MatAppContent,
        MatAppPanels] });
MatAppPanelsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppPanelsModule, imports: [[
            CommonModule,
            CdkScrollableModule,
            MatRippleModule,
            MatSidenavModule,
            MatDividerModule,
            MatButtonModule,
            MatExpansionModule,
            MatListModule,
            MatSlideToggleModule,
            MatIconModule,
            MatInputModule,
            MatDialogModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppPanelsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        CdkScrollableModule,
                        MatRippleModule,
                        MatSidenavModule,
                        MatDividerModule,
                        MatButtonModule,
                        MatExpansionModule,
                        MatListModule,
                        MatSlideToggleModule,
                        MatIconModule,
                        MatInputModule,
                        MatDialogModule
                    ],
                    exports: [
                        MatNavMenu,
                        MatNavSubmenu,
                        MatNavMenuOption,
                        MatNavMenuList,
                        MatNavPanel,
                        MatNavPanelMenu,
                        MatProfilePanel,
                        MatProfilePanelExpansionBadge,
                        MatProfilePanelContent,
                        MatProfilePanelFooter,
                        MatProfilePanelSignOutButton,
                        MatProfilePanelFooterContent,
                        MatProfilePanelNotification,
                        MatProfileExpansionPanelFooter,
                        MatProfileNotificationsFooter,
                        MatProfileHelpItem,
                        MatProfileHelpHeader,
                        MatProfileHelpFooter,
                        MatProfileSettingItem,
                        MatProfilePanelCustomerIdButton,
                        MatAppContent,
                        MatAppPanels
                    ],
                    declarations: [
                        MatNavMenu,
                        MatNavSubmenu,
                        MatNavMenuOption,
                        MatNavMenuList,
                        MatNavPanel,
                        MatProfilePanelContent,
                        MatNavPanelMenu,
                        MatProfilePanel,
                        MatProfilePanelExpansionBadge,
                        MatProfilePanelFooter,
                        MatProfilePanelSignOutButton,
                        MatProfilePanelFooterContent,
                        MatProfilePanelNotification,
                        MatProfileExpansionPanelFooter,
                        MatProfileNotificationsFooter,
                        MatProfileHelpItem,
                        MatProfileHelpHeader,
                        MatProfileHelpFooter,
                        MatProfileSettingItem,
                        MatProfilePanelCustomerIdButton,
                        MatAppContent,
                        MatAppPanels
                    ]
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MAT_DRAWER_CONTAINER, MAT_NAV_MENU_LIST_VALUE_ACCESSOR, MatAppContent, MatAppPanels, MatAppPanelsModule, MatNavMenu, MatNavMenuList, MatNavMenuListChange, MatNavMenuOption, MatNavPanel, MatNavPanelMenu, MatNavSubmenu, MatProfileExpansionPanelFooter, MatProfileHelpFooter, MatProfileHelpHeader, MatProfileHelpItem, MatProfileNotificationsFooter, MatProfilePanel, MatProfilePanelContent, MatProfilePanelCustomerIdButton, MatProfilePanelExpansionBadge, MatProfilePanelFooter, MatProfilePanelFooterContent, MatProfilePanelNotification, MatProfilePanelSignOutButton, MatProfileSettingItem };
//# sourceMappingURL=vdlx-vdl-angular-mat-app-panels.mjs.map
