import { ScrollDispatcher } from '@angular/cdk/scrolling';
import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, InjectionToken, NgZone, OnDestroy, QueryList } from '@angular/core';
import { MatDrawerContainer, MatDrawerContent } from '@vdlx/vdl-angular/mat/sidenav';
import { Subscription } from 'rxjs';
import { MatNavPanel } from './nav-panel/nav-panel';
import { MatProfilePanel } from './profile-panel/profile-panel';
import * as i0 from "@angular/core";
/**
 * Used to provide a drawer container to a drawer while avoiding circular references.
 * @docs-private
 */
export declare const MAT_DRAWER_CONTAINER: InjectionToken<unknown>;
/** Component that wraps page content */
export declare class MatAppContent extends MatDrawerContent {
    constructor(changeDetectorRef: ChangeDetectorRef, container: MatAppPanels, elementRef: ElementRef<HTMLElement>, scrollDispatcher: ScrollDispatcher, ngZone: NgZone);
    static ɵfac: i0.ɵɵFactoryDeclaration<MatAppContent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatAppContent, "mat-app-content", never, {}, {}, never, ["*"]>;
}
/** Component for layout of Nav panel, Profile panel and page content */
export declare class MatAppPanels extends MatDrawerContainer implements AfterContentInit, OnDestroy {
    contentSubscription: Subscription;
    /** Whether the backdrop is shown when a panel is open */
    _showBackdrop: boolean;
    profilePanelOpen: boolean;
    navPanelOpen: boolean;
    /** Enable backdrop to be shown when applicable */
    get enableBackdrop(): boolean;
    set enableBackdrop(value: boolean);
    _enableBackdrop: boolean;
    /** Emits pageScrolledChange event when App Content is scrolled */
    pageScrolledChange: EventEmitter<Event>;
    /** Nav Panel and Profile Panel drawer reference */
    _allDrawers: QueryList<MatProfilePanel | MatNavPanel>;
    /** Reference to the Nav Panel */
    matNavPanel: MatNavPanel;
    /** Reference to the Profile Panel */
    matProfilePanel: MatProfilePanel;
    /** Reference to the App Content */
    _content: MatAppContent;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    /** Shows backdrop when a panel is open and backdrop is enabled */
    _setShowBackdrop(): void;
    /** Checks to see if backdrop should be shown */
    _checkBackdrop(panel?: MatProfilePanel | MatNavPanel): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatAppPanels, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatAppPanels, "mat-app-panels", ["matAppPanels"], { "enableBackdrop": "enableBackdrop"; }, { "pageScrolledChange": "pageScrolledChange"; }, ["matNavPanel", "matProfilePanel", "_content", "_allDrawers"], ["mat-nav-panel, mat-profile-panel", "mat-app-content"]>;
}
