/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Clipboard } from '@angular/cdk/clipboard';
import { ElementRef, TemplateRef, ViewContainerRef } from '@angular/core';
import { MatDialog, MatDialogConfig, MatDialogRef } from '@vdlx/vdl-angular/mat/dialog';
import { MatProfilePanelIntl } from './profile-panel-intl';
import * as i0 from "@angular/core";
/** Profile Panel Sign Out button directive */
export declare class MatProfilePanelSignOutButton {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatProfilePanelSignOutButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatProfilePanelSignOutButton, "[mat-profile-panel-signout-button]", never, {}, {}, never>;
}
/** Profile Panel Additional Content directive */
export declare class MatProfilePanelFooterContent {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatProfilePanelFooterContent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatProfilePanelFooterContent, "[mat-profile-panel-footer-content]", never, {}, {}, never>;
}
/** Profile Panel Footer component */
export declare class MatProfilePanelFooter {
    /** Display Name for the user account */
    displayName: string;
    /** Version of the application */
    applicationVersion: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatProfilePanelFooter, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatProfilePanelFooter, "mat-profile-panel-footer", never, { "displayName": "displayName"; "applicationVersion": "applicationVersion"; }, {}, never, ["[mat-profile-panel-signout-button]", "mat-profile-customer-id", "[mat-profile-panel-footer-content]"]>;
}
export declare class MatProfilePanelCustomerIdButton {
    _intl: MatProfilePanelIntl;
    private clipboard;
    dialog: MatDialog;
    private _viewContainerRef;
    config: MatDialogConfig;
    /** Customer ID */
    customerId: string;
    /** ElementRef to the Customer ID Button */
    trigger: ElementRef;
    customerIdTemplate: TemplateRef<any>;
    /** Reference to the Dialog component for Customer ID */
    popoverRef: MatDialogRef<any>;
    constructor(_intl: MatProfilePanelIntl, clipboard: Clipboard, dialog: MatDialog, _viewContainerRef: ViewContainerRef);
    /** Copies Customer ID to the users clipboard */
    copyCustomerId(): void;
    /** Opens the Customer ID Dialog */
    showCustomerIdPopover(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatProfilePanelCustomerIdButton, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatProfilePanelCustomerIdButton, "mat-profile-customer-id", never, { "customerId": "customerId"; }, {}, never, never>;
}
