import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, ViewEncapsulation, ChangeDetectionStrategy, Input, Output, NgModule } from '@angular/core';
import * as i1 from '@vdlx/vdl-angular/mat/button';
import { MatButtonModule } from '@vdlx/vdl-angular/mat/button';
import { MatCommonModule } from '@vdlx/vdl-angular/mat/core';

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatBreadcrumbs {
    constructor() {
        /** Array of display values to show in the breadcrumbs list. */
        this.breadcrumbs = [];
        /** Enables truncation for the breadcrumbs. Default is false */
        this.truncate = false;
        /** Shows/hides truncated crumbs */
        this.showTruncatedCrumbs = false;
        /** Custom event callback for a breadcrumb list element. */
        this.breadcrumbClicked = new EventEmitter();
    }
}
MatBreadcrumbs.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBreadcrumbs, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatBreadcrumbs.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatBreadcrumbs, selector: "mat-breadcrumbs", inputs: { breadcrumbs: "breadcrumbs", truncate: "truncate", showTruncatedCrumbs: "showTruncatedCrumbs" }, outputs: { breadcrumbClicked: "breadcrumbClicked" }, host: { listeners: { "mouseleave": "showTruncatedCrumbs = false" }, properties: { "class.truncation-enabled": "truncate", "class.show-truncated-breadcrumbs": "showTruncatedCrumbs" }, classAttribute: "mat-breadcrumbs" }, ngImport: i0, template: "<nav class=\"breadcrumb-list\">\n  <ol>\n\n    <ng-container *ngFor=\"\n        let crumb of breadcrumbs;\n        let isLast = last;\n        let isFirst = first;\n        let index = index\n      \">\n      <li class=\"breadcrumb\"\n          *ngIf=\"isFirst\">\n        <button mat-button\n                [class.last-breadcrumb]=\"isLast\"\n                [disabled]=\"isLast\"\n                [attr.aria-disabled]=\"isLast ? true : null\"\n                [attr.aria-current]=\"isLast ? 'page' : null\"\n                (click)=\"breadcrumbClicked.emit(crumb)\"\n                (keydown.enter)=\"breadcrumbClicked.emit(crumb)\">{{ crumb.displayName }}</button>\n      </li>\n    </ng-container>\n\n    <ng-container *ngIf=\"breadcrumbs.length > 3\">\n      <li class=\"truncation-menu\"\n          (click)=\"showTruncatedCrumbs = true\"><button mat-button>...</button></li>\n    </ng-container>\n\n    <ng-container *ngFor=\"let crumb of breadcrumbs; let isFirst = first; let index = index\">\n      <li class=\"breadcrumb truncated-breadcrumb\"\n          *ngIf=\"!isFirst && breadcrumbs.length > 3 && index < breadcrumbs.length - 2\">\n        <button mat-button\n                (click)=\"breadcrumbClicked.emit(crumb)\"\n                (keydown.enter)=\"breadcrumbClicked.emit(crumb)\">{{ crumb.displayName }}</button>\n      </li>\n    </ng-container>\n\n    <ng-container *ngFor=\"let crumb of breadcrumbs; let isLast = last; let index = index\">\n      <li class=\"breadcrumb\"\n          *ngIf=\"(breadcrumbs.length > 1 && isLast) || (breadcrumbs.length > 2 && index >= breadcrumbs.length - 2)\">\n        <button mat-button\n                [class.last-breadcrumb]=\"isLast\"\n                [disabled]=\"isLast\"\n                [attr.aria-disabled]=\"isLast ? true : null\"\n                [attr.aria-current]=\"isLast ? 'page' : null\"\n                (click)=\"breadcrumbClicked.emit(crumb)\"\n                (keydown.enter)=\"breadcrumbClicked.emit(crumb)\">{{ crumb.displayName }}</button>\n      </li>\n    </ng-container>\n\n  </ol>\n</nav>", styles: ["mat-breadcrumbs.mat-breadcrumbs{display:flex;flex-direction:row;align-items:center;overflow:hidden;height:1.5rem;background-color:transparent;font-size:1rem}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list{padding:0 25px 0 19px}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol{margin:0;padding-right:0;padding-left:0;list-style:none}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li{display:inline}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li button.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){text-decoration:none;padding:5px 8px;min-width:unset}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li button.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab):hover{text-decoration:underline}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li button.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab).last-breadcrumb{pointer-events:none;cursor:default;opacity:unset;text-decoration:none}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li+li:before{display:inline-block;transform:rotate(15deg);border-right-width:.085rem;border-right-style:solid;height:.8rem;pointer-events:none;content:\"\"}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol .truncation-menu{display:none}mat-breadcrumbs.mat-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncation-menu{display:inline;cursor:pointer}mat-breadcrumbs.mat-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncated-breadcrumb{display:none}mat-breadcrumbs.mat-breadcrumbs.show-truncated-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncation-menu{display:none}mat-breadcrumbs.mat-breadcrumbs.show-truncated-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncated-breadcrumb{display:inline}[dir=rtl] mat-breadcrumbs.mat-breadcrumbs nav.mat-breadcrumb ol li+li:before{border-right:unset;border-left-width:.085rem;border-left-style:solid}\n"], components: [{ type: i1.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBreadcrumbs, decorators: [{
            type: Component,
            args: [{ selector: 'mat-breadcrumbs', host: {
                        class: 'mat-breadcrumbs',
                        '[class.truncation-enabled]': 'truncate',
                        '[class.show-truncated-breadcrumbs]': 'showTruncatedCrumbs',
                        '(mouseleave)': 'showTruncatedCrumbs = false'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<nav class=\"breadcrumb-list\">\n  <ol>\n\n    <ng-container *ngFor=\"\n        let crumb of breadcrumbs;\n        let isLast = last;\n        let isFirst = first;\n        let index = index\n      \">\n      <li class=\"breadcrumb\"\n          *ngIf=\"isFirst\">\n        <button mat-button\n                [class.last-breadcrumb]=\"isLast\"\n                [disabled]=\"isLast\"\n                [attr.aria-disabled]=\"isLast ? true : null\"\n                [attr.aria-current]=\"isLast ? 'page' : null\"\n                (click)=\"breadcrumbClicked.emit(crumb)\"\n                (keydown.enter)=\"breadcrumbClicked.emit(crumb)\">{{ crumb.displayName }}</button>\n      </li>\n    </ng-container>\n\n    <ng-container *ngIf=\"breadcrumbs.length > 3\">\n      <li class=\"truncation-menu\"\n          (click)=\"showTruncatedCrumbs = true\"><button mat-button>...</button></li>\n    </ng-container>\n\n    <ng-container *ngFor=\"let crumb of breadcrumbs; let isFirst = first; let index = index\">\n      <li class=\"breadcrumb truncated-breadcrumb\"\n          *ngIf=\"!isFirst && breadcrumbs.length > 3 && index < breadcrumbs.length - 2\">\n        <button mat-button\n                (click)=\"breadcrumbClicked.emit(crumb)\"\n                (keydown.enter)=\"breadcrumbClicked.emit(crumb)\">{{ crumb.displayName }}</button>\n      </li>\n    </ng-container>\n\n    <ng-container *ngFor=\"let crumb of breadcrumbs; let isLast = last; let index = index\">\n      <li class=\"breadcrumb\"\n          *ngIf=\"(breadcrumbs.length > 1 && isLast) || (breadcrumbs.length > 2 && index >= breadcrumbs.length - 2)\">\n        <button mat-button\n                [class.last-breadcrumb]=\"isLast\"\n                [disabled]=\"isLast\"\n                [attr.aria-disabled]=\"isLast ? true : null\"\n                [attr.aria-current]=\"isLast ? 'page' : null\"\n                (click)=\"breadcrumbClicked.emit(crumb)\"\n                (keydown.enter)=\"breadcrumbClicked.emit(crumb)\">{{ crumb.displayName }}</button>\n      </li>\n    </ng-container>\n\n  </ol>\n</nav>", styles: ["mat-breadcrumbs.mat-breadcrumbs{display:flex;flex-direction:row;align-items:center;overflow:hidden;height:1.5rem;background-color:transparent;font-size:1rem}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list{padding:0 25px 0 19px}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol{margin:0;padding-right:0;padding-left:0;list-style:none}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li{display:inline}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li button.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab){text-decoration:none;padding:5px 8px;min-width:unset}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li button.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab):hover{text-decoration:underline}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li button.mat-button:not(.mat-flat-button):not(.mat-stroked-button):not(.mat-raised-button):not(.mat-icon-button):not(.mat-fab):not(.mat-mini-fab).last-breadcrumb{pointer-events:none;cursor:default;opacity:unset;text-decoration:none}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol li+li:before{display:inline-block;transform:rotate(15deg);border-right-width:.085rem;border-right-style:solid;height:.8rem;pointer-events:none;content:\"\"}mat-breadcrumbs.mat-breadcrumbs nav.breadcrumb-list ol .truncation-menu{display:none}mat-breadcrumbs.mat-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncation-menu{display:inline;cursor:pointer}mat-breadcrumbs.mat-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncated-breadcrumb{display:none}mat-breadcrumbs.mat-breadcrumbs.show-truncated-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncation-menu{display:none}mat-breadcrumbs.mat-breadcrumbs.show-truncated-breadcrumbs.truncation-enabled nav.breadcrumb-list ol .truncated-breadcrumb{display:inline}[dir=rtl] mat-breadcrumbs.mat-breadcrumbs nav.mat-breadcrumb ol li+li:before{border-right:unset;border-left-width:.085rem;border-left-style:solid}\n"] }]
        }], propDecorators: { breadcrumbs: [{
                type: Input
            }], truncate: [{
                type: Input
            }], showTruncatedCrumbs: [{
                type: Input
            }], breadcrumbClicked: [{
                type: Output
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatBreadcrumbsModule {
}
MatBreadcrumbsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBreadcrumbsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MatBreadcrumbsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBreadcrumbsModule, declarations: [MatBreadcrumbs], imports: [CommonModule, MatCommonModule, MatButtonModule], exports: [MatBreadcrumbs] });
MatBreadcrumbsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBreadcrumbsModule, imports: [[CommonModule, MatCommonModule, MatButtonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBreadcrumbsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, MatCommonModule, MatButtonModule],
                    exports: [MatBreadcrumbs],
                    declarations: [MatBreadcrumbs]
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MatBreadcrumbs, MatBreadcrumbsModule };
//# sourceMappingURL=vdlx-vdl-angular-mat-breadcrumbs.mjs.map
