/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { EventEmitter } from '@angular/core';
import * as i0 from "@angular/core";
export interface Breadcrumb {
    id?: number;
    displayName: string;
}
export declare class MatBreadcrumbs {
    /** Array of display values to show in the breadcrumbs list. */
    breadcrumbs: Array<Breadcrumb>;
    /** Enables truncation for the breadcrumbs. Default is false */
    truncate: boolean;
    /** Shows/hides truncated crumbs */
    showTruncatedCrumbs: boolean;
    /** Custom event callback for a breadcrumb list element. */
    breadcrumbClicked: EventEmitter<Breadcrumb>;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatBreadcrumbs, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatBreadcrumbs, "mat-breadcrumbs", never, { "breadcrumbs": "breadcrumbs"; "truncate": "truncate"; "showTruncatedCrumbs": "showTruncatedCrumbs"; }, { "breadcrumbClicked": "breadcrumbClicked"; }, never, never>;
}
