import { ElementRef, EventEmitter, TemplateRef, ViewContainerRef } from '@angular/core';
import { MatIconRegistry } from '@vdlx/vdl-angular/mat/icon';
import { MatDialog } from '../dialog';
import { MatDialogConfig, PopoverPosition } from '../dialog-config';
import { MatDialogRef } from '../dialog-ref';
import * as i0 from "@angular/core";
export declare class MatPopoverPredefined {
    private _viewContainerRef;
    popoverService: MatDialog;
    /** Type of the popover. Accepts: `'info'` | `'error'` | `'custom'`. */
    matPredefinedPopoverType: 'info' | 'error' | 'custom';
    /** Used with `custom` type is a string which should contain a valid font awesome icon. */
    matPredefinedPopoverIcon: string;
    /** Position of a popover. Accepts: `'left'`, `'right'`, `'above'`, `'below'`, `'before'`, `'after'` */
    matPopoverPosition: PopoverPosition;
    /** Specify the 'aria-label' attribute on the popover predefined's trigger button. */
    ariaLabel: string;
    /** Aria Label for the opened popover component. */
    matPopoverPredefinedAriaLabel: string;
    /** Disable the popover predefined button when true, otherwise enabled. */
    disabled: boolean;
    /** Alternative content using mat-dialog-content and required if the appliction wants to use mat-dialog-actions. */
    matPopoverTemplate: TemplateRef<any>;
    /** Emitter to return mat-dialog-action result from the popover. */
    readonly afterClosed: EventEmitter<any>;
    /** Whether popover is open or not */
    _popoverOpen: boolean;
    popoverRef: MatDialogRef<any>;
    config: MatDialogConfig;
    anchorButton: ElementRef;
    predefinedContentTemplate: TemplateRef<any>;
    constructor(matIconRegistry: MatIconRegistry, _viewContainerRef: ViewContainerRef, popoverService: MatDialog);
    show(event: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatPopoverPredefined, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatPopoverPredefined, "mat-popover-predefined", never, { "matPredefinedPopoverType": "matPredefinedPopoverType"; "matPredefinedPopoverIcon": "matPredefinedPopoverIcon"; "matPopoverPosition": "matPopoverPosition"; "ariaLabel": "ariaLabel"; "matPopoverPredefinedAriaLabel": "matPopoverPredefinedAriaLabel"; "disabled": "disabled"; "matPopoverTemplate": "matPopoverTemplate"; }, { "afterClosed": "afterClosed"; }, never, ["*"]>;
}
