import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ViewEncapsulation, Input, Injectable, Optional, SkipSelf, EventEmitter, Output, ElementRef, ViewChild, ContentChild, ContentChildren, NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i2 from '@vdlx/vdl-angular/mat/button';
import { MatButtonModule } from '@vdlx/vdl-angular/mat/button';
import { MatCommonModule } from '@vdlx/vdl-angular/mat/core';
import * as i3 from '@vdlx/vdl-angular/mat/icon';
import { MatIconModule } from '@vdlx/vdl-angular/mat/icon';
import * as i4 from '@vdlx/vdl-angular/mat/tooltip';
import { MAT_TOOLTIP_DEFAULT_OPTIONS, MatTooltipModule } from '@vdlx/vdl-angular/mat/tooltip';
import { Subject } from 'rxjs';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { trigger, state, style, transition, animate, group } from '@angular/animations';

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** App Banner */
class MatAppBanner {
    /** Returns the class used for the banner type */
    getClasses() {
        return `mat-app-banner mat-app-banner-${this.type}`;
    }
    getIcon() {
        switch (this.type) {
            case 'success':
                return 'check_circle';
                break;
            case 'warning':
                return 'warning';
                break;
            case 'error':
                return 'error';
                break;
            default:
                return 'info';
        }
    }
}
MatAppBanner.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBanner, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatAppBanner.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatAppBanner, selector: "mat-app-banner", inputs: { ariaLabel: ["aria-label", "ariaLabel"], type: "type" }, host: { attributes: { "role": "alert" }, properties: { "class": "getClasses()", "attr.aria-label": "ariaLabel ? ariaLabel : type", "attr.aria-live": "type === \"warning\" || type === \"error\" ? \"assertive\" : \"polite\"" } }, ngImport: i0, template: "<div class=\"app-banner-content\">\n  <mat-icon class=\"app-banner-icon\"\n            fontSet=\"material-symbols-outlined\">{{ getIcon() }}</mat-icon>\n  <div class=\"app-banner-message\"><ng-content></ng-content></div>\n</div>", styles: [".mat-app-banner{display:flex;align-items:center;padding:0;overflow:hidden}.mat-app-banner>.app-banner-content{display:flex;flex:1 1 auto;align-items:baseline;justify-content:center;margin-left:15px}.mat-app-banner>.app-banner-content>.app-banner-message{max-width:570px;overflow:hidden;flex:0 1 auto;margin-left:15px;align-self:center}\n"], components: [{ type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBanner, decorators: [{
            type: Component,
            args: [{ selector: 'mat-app-banner', host: {
                        role: 'alert',
                        '[class]': 'getClasses()',
                        '[attr.aria-label]': 'ariaLabel ? ariaLabel : type',
                        '[attr.aria-live]': 'type === "warning" || type === "error" ? "assertive" : "polite"'
                    }, encapsulation: ViewEncapsulation.None, template: "<div class=\"app-banner-content\">\n  <mat-icon class=\"app-banner-icon\"\n            fontSet=\"material-symbols-outlined\">{{ getIcon() }}</mat-icon>\n  <div class=\"app-banner-message\"><ng-content></ng-content></div>\n</div>", styles: [".mat-app-banner{display:flex;align-items:center;padding:0;overflow:hidden}.mat-app-banner>.app-banner-content{display:flex;flex:1 1 auto;align-items:baseline;justify-content:center;margin-left:15px}.mat-app-banner>.app-banner-content>.app-banner-message{max-width:570px;overflow:hidden;flex:0 1 auto;margin-left:15px;align-self:center}\n"] }]
        }], propDecorators: { ariaLabel: [{
                type: Input,
                args: ['aria-label']
            }], type: [{
                type: Input
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Product Name */
class MatProductName {
    constructor() {
        /** Whether to show the Veritas company name or not */
        this.showVeritas = true;
        /** Whether to show the TM with the Veritas company name */
        this.showVeritasTM = false;
    }
}
MatProductName.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProductName, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatProductName.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProductName, selector: "mat-product-name", inputs: { showVeritas: "showVeritas", showVeritasTM: "showVeritasTM" }, host: { properties: { "class.mat-product-name": "true" } }, ngImport: i0, template: "<span class=\"app-bar-veritas\"\n      *ngIf=\"showVeritas\">Veritas<span class=\"trademark\"\n        *ngIf=\"showVeritasTM\">&trade;</span>\n</span>\n<span class=\"app-bar-product-name\">\n  <ng-content></ng-content>\n</span>", directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProductName, decorators: [{
            type: Component,
            args: [{ selector: 'mat-product-name', host: {
                        '[class.mat-product-name]': 'true'
                    }, encapsulation: ViewEncapsulation.None, template: "<span class=\"app-bar-veritas\"\n      *ngIf=\"showVeritas\">Veritas<span class=\"trademark\"\n        *ngIf=\"showVeritasTM\">&trade;</span>\n</span>\n<span class=\"app-bar-product-name\">\n  <ng-content></ng-content>\n</span>" }]
        }], propDecorators: { showVeritas: [{
                type: Input
            }], showVeritasTM: [{
                type: Input
            }] } });
/** Additional Content for the App Bar */
class MatAppBarContent {
}
MatAppBarContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBarContent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatAppBarContent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatAppBarContent, selector: "mat-app-bar-content, [mat-app-bar-content]", host: { properties: { "class.mat-app-bar-content": "true" } }, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBarContent, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-app-bar-content, [mat-app-bar-content]',
                    template: `<ng-content></ng-content>`,
                    host: {
                        '[class.mat-app-bar-content]': 'true'
                    },
                    encapsulation: ViewEncapsulation.None
                }]
        }] });
/** Product Icon */
class MatProductIcon {
}
MatProductIcon.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProductIcon, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatProductIcon.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProductIcon, selector: "mat-product-icon", host: { properties: { "class.mat-product-icon": "true" } }, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProductIcon, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-product-icon',
                    template: `<ng-content></ng-content>`,
                    host: {
                        '[class.mat-product-icon]': 'true'
                    }
                }]
        }] });
/** Profile User Initials */
class MatProfilePanelUserInitialsButton {
}
MatProfilePanelUserInitialsButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelUserInitialsButton, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelUserInitialsButton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelUserInitialsButton, selector: "mat-profile-user-initials", host: { properties: { "class.mat-profile-user-initials-container": "true" } }, ngImport: i0, template: `<div class="mat-profile-user-initials">
    <ng-content></ng-content>
  </div>`, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelUserInitialsButton, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-profile-user-initials',
                    template: `<div class="mat-profile-user-initials">
    <ng-content></ng-content>
  </div>`,
                    host: {
                        '[class.mat-profile-user-initials-container]': 'true'
                    }
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatAppBarSearch {
}
MatAppBarSearch.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBarSearch, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatAppBarSearch.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatAppBarSearch, selector: "mat-app-bar-search", host: { classAttribute: "mat-app-bar-search" }, ngImport: i0, template: "<div class=\"app-bar-search-content\">\n  <ng-content select=\"mat-form-field\"></ng-content>\n  <ng-content select=\"mat-select\"></ng-content>\n</div>", styles: [".mat-app-bar-search{display:flex;flex:0 0 auto;align-items:center;padding:0 15px}.mat-app-bar-search .app-bar-search-content{display:flex;border-radius:10px;height:34px;overflow:hidden}.mat-app-bar-search .app-bar-search-content .mat-form-field{padding:0 8px;margin:0;min-width:200px}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper{padding-bottom:0;height:100%}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex{height:100%;align-items:center}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix{border-top:0}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix .mat-form-field-label-wrapper{top:unset;padding-top:unset}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix .mat-form-field-label-wrapper .mat-form-field-label{top:0;font-size:1rem;transform:perspective(100px);width:100%}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix .mat-form-field-label-wrapper .mat-form-field-label:not(.mat-form-field-empty){display:none}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-underline{display:none}.mat-app-bar-search .app-bar-search-content .mat-select{padding:7px 4px 6px 8px}.mat-app-bar-search .app-bar-search-content .mat-select .mat-select-arrow-wrapper{padding-left:10px}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBarSearch, decorators: [{
            type: Component,
            args: [{ selector: 'mat-app-bar-search', encapsulation: ViewEncapsulation.None, host: {
                        class: 'mat-app-bar-search'
                    }, template: "<div class=\"app-bar-search-content\">\n  <ng-content select=\"mat-form-field\"></ng-content>\n  <ng-content select=\"mat-select\"></ng-content>\n</div>", styles: [".mat-app-bar-search{display:flex;flex:0 0 auto;align-items:center;padding:0 15px}.mat-app-bar-search .app-bar-search-content{display:flex;border-radius:10px;height:34px;overflow:hidden}.mat-app-bar-search .app-bar-search-content .mat-form-field{padding:0 8px;margin:0;min-width:200px}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper{padding-bottom:0;height:100%}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex{height:100%;align-items:center}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix{border-top:0}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix .mat-form-field-label-wrapper{top:unset;padding-top:unset}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix .mat-form-field-label-wrapper .mat-form-field-label{top:0;font-size:1rem;transform:perspective(100px);width:100%}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-wrapper .mat-form-field-flex .mat-form-field-infix .mat-form-field-label-wrapper .mat-form-field-label:not(.mat-form-field-empty){display:none}.mat-app-bar-search .app-bar-search-content .mat-form-field .mat-form-field-underline{display:none}.mat-app-bar-search .app-bar-search-content .mat-select{padding:7px 4px 6px 8px}.mat-app-bar-search .app-bar-search-content .mat-select .mat-select-arrow-wrapper{padding-left:10px}\n"] }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Datepicker data that requires internationalization. */
class MatHeaderIntl {
    constructor() {
        /**
         * Stream that emits whenever the labels here are changed. Use this to notify
         * components if the labels have changed after initialization.
         */
        this.changes = new Subject();
        /** A label for the button used to open the Nav Panel (used by screen readers). */
        this.openNavPanelButtonLabel = 'Open Nav Panel';
        /** Label for the button used to close the Nav Panel. */
        this.closeNavPanelButtonLabel = 'Close Nav Panel';
        /** A label for the button used to open the Profile Panel (used by screen readers). */
        this.openProfilePanelButtonLabel = 'Open Profile Panel';
        /** Label for the button used to close the Profile Panel. */
        this.closeProfilePanelButtonLabel = 'Close Profile Panel';
        /** Label for the back button on page bar */
        this.backButtonLabel = 'Go Back';
    }
}
MatHeaderIntl.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderIntl, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MatHeaderIntl.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderIntl, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderIntl, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });
/** @docs-private */
function MAT_HEADER_INTL_PROVIDER_FACTORY(parentIntl) {
    return parentIntl || new MatHeaderIntl();
}
/** @docs-private */
const MAT_HEADER_INTL_PROVIDER = {
    // If there is already an HeaderFormIntl available, use that. Otherwise, provide a new one.
    provide: MatHeaderIntl,
    deps: [[new Optional(), new SkipSelf(), MatHeaderIntl]],
    useFactory: MAT_HEADER_INTL_PROVIDER_FACTORY
};

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const tooltipDefaults$2 = {
    disableTooltipInteractivity: true,
    showDelay: 0,
    hideDelay: 0,
    touchendHideDelay: 1500
};
/** Page Bar Back Button */
class MatBackButton {
    constructor(_intl, _changeDetectorRef) {
        this._intl = _intl;
        this._changeDetectorRef = _changeDetectorRef;
        /** Back Button clicked event */
        this.backButtonEvent = new EventEmitter();
        this._intlChanges = _intl.changes.subscribe(() => this._changeDetectorRef.markForCheck());
    }
    ngOnDestroy() {
        this._intlChanges.unsubscribe();
    }
}
MatBackButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBackButton, deps: [{ token: MatHeaderIntl }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MatBackButton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatBackButton, selector: "mat-back-button", outputs: { backButtonEvent: "backButtonEvent" }, host: { properties: { "class.mat-back-button": "true" } }, providers: [
        MAT_HEADER_INTL_PROVIDER,
        {
            provide: MAT_TOOLTIP_DEFAULT_OPTIONS,
            useValue: tooltipDefaults$2
        }
    ], ngImport: i0, template: "<button mat-button\n        [attr.aria-label]=\"_intl.backButtonLabel\"\n        [matTooltip]=\"_intl.backButtonLabel\"\n        (click)=\"backButtonEvent.emit($event)\">\n  <mat-icon fontSet=\"material-symbols-outlined\">arrow_back</mat-icon>\n</button>", components: [{ type: i2.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i4.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBackButton, decorators: [{
            type: Component,
            args: [{ selector: `mat-back-button`, providers: [
                        MAT_HEADER_INTL_PROVIDER,
                        {
                            provide: MAT_TOOLTIP_DEFAULT_OPTIONS,
                            useValue: tooltipDefaults$2
                        }
                    ], host: {
                        '[class.mat-back-button]': 'true'
                    }, encapsulation: ViewEncapsulation.None, template: "<button mat-button\n        [attr.aria-label]=\"_intl.backButtonLabel\"\n        [matTooltip]=\"_intl.backButtonLabel\"\n        (click)=\"backButtonEvent.emit($event)\">\n  <mat-icon fontSet=\"material-symbols-outlined\">arrow_back</mat-icon>\n</button>" }]
        }], ctorParameters: function () { return [{ type: MatHeaderIntl }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { backButtonEvent: [{
                type: Output
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const ANIMATION_TIMING$1 = '250ms';
const EASING = 'ease-in-out';
/** Animations used by the VDL Header. */
const matHeaderAnimations = {
    /** Animation that shows and hides app bar. */
    appBarState: trigger('appBarState', [
        state('void, expanded', style({ height: '60px' })),
        state('collapsed', style({ height: '0' })),
        transition('collapsed => void, collapsed => expanded', animate(`${ANIMATION_TIMING$1} ${EASING}`)),
        transition('void => collapsed, expanded => collapsed', animate(`${ANIMATION_TIMING$1} ${ANIMATION_TIMING$1} ${EASING}`))
    ]),
    /** Animation that shows and hides page bar. */
    pageBarState: trigger('pageBarState', [
        state('void, expanded', style({ paddingLeft: '0' })),
        state('collapsed', style({
            paddingLeft: '60px'
        })),
        transition('collapsed => void, collapsed => expanded', animate(`${ANIMATION_TIMING$1} ${ANIMATION_TIMING$1} ${EASING}`)),
        transition('void => collapsed, expanded => collapsed', animate(`${ANIMATION_TIMING$1} ${EASING}`))
    ])
};

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Veritas design Header
 */
class MatHeader {
    constructor(_elementRef, _changeDetector) {
        this._elementRef = _elementRef;
        this._changeDetector = _changeDetector;
        this._disableAnimation = false;
        this._previousScrollDirection = null;
        this._prevScrollValue = 0;
        this._prevScrollValueChecked = 0;
        /** Buffer required before app bar collapses on scroll down */
        this.scrollBuffer = 60;
        this._appBarCollapsed = false;
        this._hidePageBar = false;
        /** App Bar Collapsed change event for two-way binding */
        this.appBarCollapsedChange = new EventEmitter();
        /** Animation Start Event */
        this.animationStart = new EventEmitter();
        /** Animation Complete Event */
        this.animationDone = new EventEmitter();
        /** Header Height Change Event */
        this.heightChange = new EventEmitter();
    }
    /** Whether the App Bar is Collapsed */
    get appBarCollapsed() {
        return this._appBarCollapsed;
    }
    set appBarCollapsed(value) {
        if (this.hidePageBar && value && !this._appBarCollapsed) {
            return;
        }
        if (!this._destroyed) {
            this._appBarCollapsed = coerceBooleanProperty(value);
            this.appBarCollapsedChange.emit(this._appBarCollapsed);
        }
    }
    /** Whether to show the Page Bar */
    get hidePageBar() {
        return this._hidePageBar;
    }
    set hidePageBar(value) {
        if (this.appBarCollapsed && value && !this._hidePageBar) {
            this._disableAnimation = true;
            this.appBarCollapsed = false;
        }
        if (!this._destroyed) {
            this._hidePageBar = coerceBooleanProperty(value);
            setTimeout(() => {
                this._disableAnimation = false;
            });
        }
        this._changeDetector.detectChanges();
    }
    ngOnDestroy() {
        this._destroyed = true;
    }
    /** Returns true if MatAppBarContent has been added to header */
    hasAppBarContent() {
        return this.appBarContent?.length > 0;
    }
    /** Returns height of header, including app bar and page bar */
    getHeight() {
        return this._elementRef.nativeElement.getBoundingClientRect().height;
    }
    /** Whether header has app banner */
    hasAppBanner() {
        return !!this.appBanner;
    }
    /** Returns the state of the app bar */
    getState() {
        return this.appBarCollapsed ? 'collapsed' : 'expanded';
    }
    /** App Bar animation started */
    appBarAnimationStarted() {
        if (!this._destroyed) {
            const headerState = {
                height: this.getHeight(),
                appBarCollapsed: this.appBarCollapsed
            };
            this._isAnimating = true;
            this.animationStart.emit(headerState);
        }
    }
    /** App Bar animation complete */
    appBarAnimationDone() {
        if (!this._destroyed) {
            const height = this.getHeight();
            const headerState = {
                height: height,
                appBarCollapsed: this.appBarCollapsed
            };
            this._isAnimating = false;
            this.animationDone.emit(headerState);
            this.heightChange.emit(height);
        }
    }
    /** Monitors the scrollElement for scroll changes and collapses or expands the App Bar */
    pageScrolledCheck(scrollElement) {
        let scrollDirection = null;
        if (this._prevScrollValue > scrollElement.scrollTop) {
            scrollDirection = 'up';
        }
        else if (this._prevScrollValue < scrollElement.scrollTop) {
            scrollDirection = 'down';
        }
        if (this.getState() === 'expanded' &&
            ((this._previousScrollDirection === 'down' &&
                scrollElement.scrollTop - this._prevScrollValueChecked >
                    this.scrollBuffer) ||
                (scrollDirection === 'down' &&
                    scrollElement.scrollTop - this._prevScrollValue >
                        this.scrollBuffer) ||
                scrollElement.scrollTop >= scrollElement.scrollHeight - 5)) {
            this.appBarCollapsed = true;
            this._changeDetector.detectChanges();
        }
        else if (this.getState() === 'collapsed' &&
            ((!this._isAnimating &&
                this._previousScrollDirection === 'up' &&
                this._prevScrollValueChecked - scrollElement.scrollTop > 5) ||
                scrollElement.scrollTop < 1)) {
            this.appBarCollapsed = false;
            this._changeDetector.detectChanges();
        }
        if (scrollDirection !== this._previousScrollDirection) {
            this._prevScrollValueChecked = scrollElement.scrollTop;
        }
        this._prevScrollValue = scrollElement.scrollTop;
        this._previousScrollDirection = scrollDirection;
    }
}
MatHeader.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeader, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MatHeader.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatHeader, selector: "mat-header", inputs: { scrollBuffer: "scrollBuffer", appBarCollapsed: "appBarCollapsed", hidePageBar: "hidePageBar" }, outputs: { appBarCollapsedChange: "appBarCollapsedChange", animationStart: "animationStart", animationDone: "animationDone", heightChange: "heightChange" }, host: { properties: { "class.app-bar-collapsed": "appBarCollapsed", "class.page-bar-hidden": "hidePageBar", "class.app-banner-visible": "hasAppBanner()" }, classAttribute: "mat-header" }, queries: [{ propertyName: "appBanner", first: true, predicate: MatAppBanner, descendants: true }, { propertyName: "appBarContent", predicate: MatAppBarContent }], viewQueries: [{ propertyName: "appBarRef", first: true, predicate: ["appBar"], descendants: true, read: ElementRef }], ngImport: i0, template: "<!-- App Notification Bar -->\n<ng-content select=\"mat-app-banner\"></ng-content>\n\n<!-- App Bar -->\n<div class=\"mat-app-bar-container\"\n     #appBar\n     [ngClass]=\"{'collapsed': appBarCollapsed}\"\n     [@appBarState]=\"getState()\"\n     (@appBarState.start)=\"appBarAnimationStarted()\"\n     (@appBarState.done)=\"appBarAnimationDone()\"\n     [@.disabled]=\"_disableAnimation\">\n\n  <ng-content select=\"mat-nav-panel-button, mat-product-icon\"></ng-content>\n\n  <ng-content select=\"mat-product-name\"></ng-content>\n\n  <ng-content select=\"mat-app-bar-search\"></ng-content>\n\n  <div class=\"mat-app-bar-content-container\"\n       *ngIf=\"hasAppBarContent()\">\n    <ng-content select=\"mat-app-bar-content, [mat-app-bar-content]\"></ng-content>\n  </div>\n\n  <ng-content select=\"[mat-app-bar-overflow]\"></ng-content>\n\n  <ng-content select=\"mat-profile-panel-button, mat-profile-user-initials\"></ng-content>\n</div>\n\n<!-- Page Bar-->\n<div class=\"mat-page-bar-container\"\n     [@pageBarState]=\"getState()\"\n     [@.disabled]=\"_disableAnimation\"\n     *ngIf=\"!hidePageBar\">\n  <ng-content select=\"mat-back-button\"></ng-content>\n\n  <ng-content select=\"mat-page-title, mat-breadcrumbs\"></ng-content>\n\n  <div class=\"mat-page-bar-content-container\">\n    <ng-content select=\"mat-page-bar-content\"></ng-content>\n  </div>\n\n  <div class=\"mat-page-actions\">\n    <ng-content select=\"[mat-page-actions-template], [mat-page-bar-overflow]\"></ng-content>\n  </div>\n</div>", styles: [".mat-header{display:block;position:relative;width:100%}.mat-header .mat-app-banner,.mat-header .mat-app-bar-container,.mat-header .mat-page-bar-container{height:60px}.mat-header .mat-app-bar-container{display:flex;padding-left:60px;overflow:hidden}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button,.mat-header .mat-app-bar-container .mat-product-icon{position:absolute;left:0;min-height:60px;min-width:60px;height:60px;width:60px}.mat-header .mat-app-bar-container .mat-product-icon{border:none;display:flex;align-items:center;justify-content:center;border-radius:0}.mat-header .mat-app-bar-container .mat-app-bar-search{height:60px}.mat-header .mat-app-bar-container .mat-app-bar-content-container{display:flex;flex:0 0 auto;align-items:center}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button{display:flex;align-items:center;justify-content:center;border-color:transparent;cursor:pointer;border-radius:0}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button:hover .mat-icon{opacity:.8}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button .mat-icon{font-size:1.625rem;height:1.625rem;width:1.625rem}.mat-header .mat-app-bar-container .mat-panel-button-open{z-index:999}.mat-header .mat-app-bar-container .mat-product-name{flex:auto;display:flex;align-items:center;min-height:60px}.mat-header .mat-app-bar-container .mat-product-name .app-bar-veritas{padding-left:15px}.mat-header .mat-app-bar-container .mat-product-name .app-bar-product-name{white-space:nowrap;margin-left:6px}.mat-header .mat-app-bar-container .mat-profile-user-initials-container,.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button{display:flex;align-items:center;justify-content:center;min-height:60px;height:60px;min-width:50px;width:50px;border-color:transparent;padding:0;border-radius:0}.mat-header .mat-app-bar-container .mat-profile-user-initials-container .mat-profile-panel-badge,.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-profile-panel-badge{display:block;position:absolute;width:8px;height:8px;bottom:0;right:0;border-radius:50%;border-style:solid;border-width:1px;pointer-events:none}.mat-header .mat-app-bar-container .mat-profile-user-initials{display:flex;align-items:center;justify-content:center;border-radius:50%;height:24px;width:24px;line-height:.875rem;padding:0;font-size:.625rem}.mat-header .mat-app-bar-container .mat-profile-panel-button-container{position:relative;min-height:60px;height:60px;min-width:50px;width:50px}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button{cursor:pointer;position:absolute}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button>.mat-button-wrapper{position:relative}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-icon{font-size:1.875rem;height:1.875rem;width:1.875rem}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-icon+.mat-profile-panel-badge{bottom:4px;right:1px}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-profile-user-initials+.mat-profile-panel-badge{bottom:-2px;right:-2px}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button:hover .mat-icon{opacity:.8}.mat-header .mat-app-banner~.mat-app-bar-container .mat-nav-panel-button-container .nav-panel-button,.mat-header .mat-app-banner~.mat-app-bar-container .mat-product-icon{top:60px}.mat-header .mat-page-bar-container{display:flex;align-items:center;max-height:60px;min-height:60px;height:60px}.mat-header .mat-page-bar-container .mat-back-button{min-height:100%;height:100%;min-width:60px;width:60px}.mat-header .mat-page-bar-container .mat-back-button .mat-button{height:100%;width:100%;min-width:100%;padding:0}.mat-header .mat-page-bar-container .mat-page-title,.mat-header .mat-page-bar-container .mat-page-bar-content-container{display:flex;align-items:center;height:1.5rem}.mat-header .mat-page-bar-container .mat-page-title{flex:0 0 auto;padding:0 25px 0 19px}.mat-header .mat-page-bar-container .mat-page-title .divider{padding:0 5px}.mat-header .mat-page-bar-container .mat-page-bar-content-container{flex:1 1 auto}.mat-header .mat-page-bar-container .mat-back-button+.mat-page-title,.mat-header .mat-page-bar-container .mat-back-button+.mat-breadcrumbs{border-left-width:1px;border-left-style:solid}.mat-header .mat-page-bar-container .mat-page-actions{padding-right:25px}[dir=rtl] .mat-header .mat-app-bar-container{padding-left:unset;padding-right:60px}[dir=rtl] .mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button,[dir=rtl] .mat-header .mat-app-bar-container .mat-product-icon{left:unset;right:0}[dir=rtl] .mat-header .mat-app-bar-container .mat-product-name .app-bar-veritas{padding-left:unset;padding-right:15px}[dir=rtl] .mat-header .mat-app-bar-container .mat-product-name .app-bar-product-name{margin-left:unset;margin-right:6px}[dir=rtl] .mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-icon+.mat-profile-panel-badge{right:unset;left:1px}[dir=rtl] .mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-profile-user-initials+.mat-profile-panel-badge{right:unset;left:-2px}[dir=rtl] .mat-header .mat-page-bar-container .mat-page-title{padding:0 19px 0 25px}[dir=rtl] .mat-header .mat-page-bar-container .mat-back-button+.mat-page-title,[dir=rtl] .mat-header .mat-page-bar-container .mat-back-button+.mat-breadcrumbs{border-left-width:unset;border-left-style:unset;border-right-width:1px;border-right-style:solid}\n"], directives: [{ type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [
        matHeaderAnimations.appBarState,
        matHeaderAnimations.pageBarState
    ], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeader, decorators: [{
            type: Component,
            args: [{ selector: `mat-header`, animations: [
                        matHeaderAnimations.appBarState,
                        matHeaderAnimations.pageBarState
                    ], host: {
                        class: 'mat-header',
                        '[class.app-bar-collapsed]': 'appBarCollapsed',
                        '[class.page-bar-hidden]': 'hidePageBar',
                        '[class.app-banner-visible]': 'hasAppBanner()'
                    }, encapsulation: ViewEncapsulation.None, template: "<!-- App Notification Bar -->\n<ng-content select=\"mat-app-banner\"></ng-content>\n\n<!-- App Bar -->\n<div class=\"mat-app-bar-container\"\n     #appBar\n     [ngClass]=\"{'collapsed': appBarCollapsed}\"\n     [@appBarState]=\"getState()\"\n     (@appBarState.start)=\"appBarAnimationStarted()\"\n     (@appBarState.done)=\"appBarAnimationDone()\"\n     [@.disabled]=\"_disableAnimation\">\n\n  <ng-content select=\"mat-nav-panel-button, mat-product-icon\"></ng-content>\n\n  <ng-content select=\"mat-product-name\"></ng-content>\n\n  <ng-content select=\"mat-app-bar-search\"></ng-content>\n\n  <div class=\"mat-app-bar-content-container\"\n       *ngIf=\"hasAppBarContent()\">\n    <ng-content select=\"mat-app-bar-content, [mat-app-bar-content]\"></ng-content>\n  </div>\n\n  <ng-content select=\"[mat-app-bar-overflow]\"></ng-content>\n\n  <ng-content select=\"mat-profile-panel-button, mat-profile-user-initials\"></ng-content>\n</div>\n\n<!-- Page Bar-->\n<div class=\"mat-page-bar-container\"\n     [@pageBarState]=\"getState()\"\n     [@.disabled]=\"_disableAnimation\"\n     *ngIf=\"!hidePageBar\">\n  <ng-content select=\"mat-back-button\"></ng-content>\n\n  <ng-content select=\"mat-page-title, mat-breadcrumbs\"></ng-content>\n\n  <div class=\"mat-page-bar-content-container\">\n    <ng-content select=\"mat-page-bar-content\"></ng-content>\n  </div>\n\n  <div class=\"mat-page-actions\">\n    <ng-content select=\"[mat-page-actions-template], [mat-page-bar-overflow]\"></ng-content>\n  </div>\n</div>", styles: [".mat-header{display:block;position:relative;width:100%}.mat-header .mat-app-banner,.mat-header .mat-app-bar-container,.mat-header .mat-page-bar-container{height:60px}.mat-header .mat-app-bar-container{display:flex;padding-left:60px;overflow:hidden}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button,.mat-header .mat-app-bar-container .mat-product-icon{position:absolute;left:0;min-height:60px;min-width:60px;height:60px;width:60px}.mat-header .mat-app-bar-container .mat-product-icon{border:none;display:flex;align-items:center;justify-content:center;border-radius:0}.mat-header .mat-app-bar-container .mat-app-bar-search{height:60px}.mat-header .mat-app-bar-container .mat-app-bar-content-container{display:flex;flex:0 0 auto;align-items:center}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button{display:flex;align-items:center;justify-content:center;border-color:transparent;cursor:pointer;border-radius:0}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button:hover .mat-icon{opacity:.8}.mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button .mat-icon{font-size:1.625rem;height:1.625rem;width:1.625rem}.mat-header .mat-app-bar-container .mat-panel-button-open{z-index:999}.mat-header .mat-app-bar-container .mat-product-name{flex:auto;display:flex;align-items:center;min-height:60px}.mat-header .mat-app-bar-container .mat-product-name .app-bar-veritas{padding-left:15px}.mat-header .mat-app-bar-container .mat-product-name .app-bar-product-name{white-space:nowrap;margin-left:6px}.mat-header .mat-app-bar-container .mat-profile-user-initials-container,.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button{display:flex;align-items:center;justify-content:center;min-height:60px;height:60px;min-width:50px;width:50px;border-color:transparent;padding:0;border-radius:0}.mat-header .mat-app-bar-container .mat-profile-user-initials-container .mat-profile-panel-badge,.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-profile-panel-badge{display:block;position:absolute;width:8px;height:8px;bottom:0;right:0;border-radius:50%;border-style:solid;border-width:1px;pointer-events:none}.mat-header .mat-app-bar-container .mat-profile-user-initials{display:flex;align-items:center;justify-content:center;border-radius:50%;height:24px;width:24px;line-height:.875rem;padding:0;font-size:.625rem}.mat-header .mat-app-bar-container .mat-profile-panel-button-container{position:relative;min-height:60px;height:60px;min-width:50px;width:50px}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button{cursor:pointer;position:absolute}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button>.mat-button-wrapper{position:relative}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-icon{font-size:1.875rem;height:1.875rem;width:1.875rem}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-icon+.mat-profile-panel-badge{bottom:4px;right:1px}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-profile-user-initials+.mat-profile-panel-badge{bottom:-2px;right:-2px}.mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button:hover .mat-icon{opacity:.8}.mat-header .mat-app-banner~.mat-app-bar-container .mat-nav-panel-button-container .nav-panel-button,.mat-header .mat-app-banner~.mat-app-bar-container .mat-product-icon{top:60px}.mat-header .mat-page-bar-container{display:flex;align-items:center;max-height:60px;min-height:60px;height:60px}.mat-header .mat-page-bar-container .mat-back-button{min-height:100%;height:100%;min-width:60px;width:60px}.mat-header .mat-page-bar-container .mat-back-button .mat-button{height:100%;width:100%;min-width:100%;padding:0}.mat-header .mat-page-bar-container .mat-page-title,.mat-header .mat-page-bar-container .mat-page-bar-content-container{display:flex;align-items:center;height:1.5rem}.mat-header .mat-page-bar-container .mat-page-title{flex:0 0 auto;padding:0 25px 0 19px}.mat-header .mat-page-bar-container .mat-page-title .divider{padding:0 5px}.mat-header .mat-page-bar-container .mat-page-bar-content-container{flex:1 1 auto}.mat-header .mat-page-bar-container .mat-back-button+.mat-page-title,.mat-header .mat-page-bar-container .mat-back-button+.mat-breadcrumbs{border-left-width:1px;border-left-style:solid}.mat-header .mat-page-bar-container .mat-page-actions{padding-right:25px}[dir=rtl] .mat-header .mat-app-bar-container{padding-left:unset;padding-right:60px}[dir=rtl] .mat-header .mat-app-bar-container .mat-nav-panel-button .nav-panel-button,[dir=rtl] .mat-header .mat-app-bar-container .mat-product-icon{left:unset;right:0}[dir=rtl] .mat-header .mat-app-bar-container .mat-product-name .app-bar-veritas{padding-left:unset;padding-right:15px}[dir=rtl] .mat-header .mat-app-bar-container .mat-product-name .app-bar-product-name{margin-left:unset;margin-right:6px}[dir=rtl] .mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-icon+.mat-profile-panel-badge{right:unset;left:1px}[dir=rtl] .mat-header .mat-app-bar-container .mat-profile-panel-button-container .profile-panel-button .mat-profile-user-initials+.mat-profile-panel-badge{right:unset;left:-2px}[dir=rtl] .mat-header .mat-page-bar-container .mat-page-title{padding:0 19px 0 25px}[dir=rtl] .mat-header .mat-page-bar-container .mat-back-button+.mat-page-title,[dir=rtl] .mat-header .mat-page-bar-container .mat-back-button+.mat-breadcrumbs{border-left-width:unset;border-left-style:unset;border-right-width:1px;border-right-style:solid}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { scrollBuffer: [{
                type: Input
            }], appBarCollapsed: [{
                type: Input
            }], hidePageBar: [{
                type: Input
            }], appBarCollapsedChange: [{
                type: Output
            }], animationStart: [{
                type: Output
            }], animationDone: [{
                type: Output
            }], heightChange: [{
                type: Output
            }], appBarRef: [{
                type: ViewChild,
                args: ['appBar', { read: ElementRef }]
            }], appBanner: [{
                type: ContentChild,
                args: [MatAppBanner]
            }], appBarContent: [{
                type: ContentChildren,
                args: [MatAppBarContent]
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const ANIMATION_TIMING = '300ms';
/** Animations used by the VDL Header Panel buttons. */
const matPanelAnimations = {
    /** Animation that animates Panel buttons. */
    panelState: trigger('state', [
        state('void, show', style({ opacity: '0', display: 'none' })),
        state('hide', style({ opacity: '1' })),
        transition('hide => show', group([
            animate(`0ms`, style({ display: 'flex' })),
            animate(`${ANIMATION_TIMING} ease-out`)
        ])),
        transition('show => hide', group([
            animate(`${ANIMATION_TIMING} 0ms`, style({ display: 'flex' })),
            animate(`${ANIMATION_TIMING} ease-out`)
        ]))
    ])
};

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const tooltipDefaults$1 = {
    disableTooltipInteractivity: true,
    showDelay: 0,
    hideDelay: 0,
    touchendHideDelay: 1500
};
/** Nav Menu Button for Application Bar */
class MatNavPanelButton {
    constructor(_intl, _changeDetectorRef) {
        this._intl = _intl;
        this._changeDetectorRef = _changeDetectorRef;
        /** Nav Panel toggled event */
        this.navPanelToggled = new EventEmitter();
        /** Animation Start event */
        this.animationStart = new EventEmitter();
        /** Animation End event */
        this.animationDone = new EventEmitter();
        this._intlChanges = _intl.changes.subscribe(() => this._changeDetectorRef.markForCheck());
    }
    /** Whether the panel button state is open/closed */
    get panelOpen() {
        return this._panelOpen;
    }
    set panelOpen(value) {
        this._panelOpen = coerceBooleanProperty(value);
        this.navPanelToggled.emit(this._panelOpen);
    }
    ngOnDestroy() {
        this._destroyed = true;
        this._intlChanges.unsubscribe();
    }
    /** Toggles the Nav Panel button open/closed states */
    togglePanel() {
        if (!this._destroyed) {
            this.panelOpen = !this._panelOpen;
        }
    }
    /** Emits animation start event when Nav Panel animation begins */
    navPanelAnimationStarted() {
        if (!this._destroyed) {
            this.animationStart.emit(this._panelOpen);
        }
    }
    /** Emits animation done event when Nav Panel animation ends */
    navPanelAnimationDone() {
        if (!this._destroyed) {
            this.animationDone.emit(this._panelOpen);
        }
    }
}
MatNavPanelButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavPanelButton, deps: [{ token: MatHeaderIntl }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MatNavPanelButton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatNavPanelButton, selector: "mat-nav-panel-button", inputs: { panelOpen: "panelOpen" }, outputs: { navPanelToggled: "navPanelToggled", animationStart: "animationStart", animationDone: "animationDone" }, host: { properties: { "class.mat-nav-panel-button": "true", "class.mat-panel-button-open": "panelOpen" } }, providers: [
        MAT_HEADER_INTL_PROVIDER,
        {
            provide: MAT_TOOLTIP_DEFAULT_OPTIONS,
            useValue: tooltipDefaults$1
        }
    ], ngImport: i0, template: "<button mat-button\n        class=\"nav-panel-button nav-panel-open-button\"\n        [attr.aria-label]=\"_intl.openNavPanelButtonLabel\"\n        [matTooltip]=\"_intl.openNavPanelButtonLabel\"\n        [disableRipple]=\"true\"\n        (click)=\"togglePanel()\"\n        [@state]=\"_panelOpen ? 'show' : 'hide'\"\n        (@state.start)=\"navPanelAnimationStarted()\"\n        (@state.done)=\"navPanelAnimationDone()\">\n  <mat-icon fontSet=\"material-symbols-outlined\">menu</mat-icon>\n</button>\n<button mat-button\n        class=\"nav-panel-button nav-panel-close-button\"\n        [attr.aria-label]=\"_intl.closeNavPanelButtonLabel\"\n        [matTooltip]=\"_intl.closeNavPanelButtonLabel\"\n        [disableRipple]=\"true\"\n        (click)=\"togglePanel()\"\n        [@state]=\"_panelOpen ? 'hide' : 'show'\">\n  <mat-icon fontSet=\"material-symbols-outlined\">close</mat-icon>\n</button>", components: [{ type: i2.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i4.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }], animations: [matPanelAnimations.panelState], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatNavPanelButton, decorators: [{
            type: Component,
            args: [{ selector: `mat-nav-panel-button`, animations: [matPanelAnimations.panelState], providers: [
                        MAT_HEADER_INTL_PROVIDER,
                        {
                            provide: MAT_TOOLTIP_DEFAULT_OPTIONS,
                            useValue: tooltipDefaults$1
                        }
                    ], host: {
                        '[class.mat-nav-panel-button]': 'true',
                        '[class.mat-panel-button-open]': 'panelOpen'
                    }, encapsulation: ViewEncapsulation.None, template: "<button mat-button\n        class=\"nav-panel-button nav-panel-open-button\"\n        [attr.aria-label]=\"_intl.openNavPanelButtonLabel\"\n        [matTooltip]=\"_intl.openNavPanelButtonLabel\"\n        [disableRipple]=\"true\"\n        (click)=\"togglePanel()\"\n        [@state]=\"_panelOpen ? 'show' : 'hide'\"\n        (@state.start)=\"navPanelAnimationStarted()\"\n        (@state.done)=\"navPanelAnimationDone()\">\n  <mat-icon fontSet=\"material-symbols-outlined\">menu</mat-icon>\n</button>\n<button mat-button\n        class=\"nav-panel-button nav-panel-close-button\"\n        [attr.aria-label]=\"_intl.closeNavPanelButtonLabel\"\n        [matTooltip]=\"_intl.closeNavPanelButtonLabel\"\n        [disableRipple]=\"true\"\n        (click)=\"togglePanel()\"\n        [@state]=\"_panelOpen ? 'hide' : 'show'\">\n  <mat-icon fontSet=\"material-symbols-outlined\">close</mat-icon>\n</button>" }]
        }], ctorParameters: function () { return [{ type: MatHeaderIntl }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { panelOpen: [{
                type: Input
            }], navPanelToggled: [{
                type: Output
            }], animationStart: [{
                type: Output
            }], animationDone: [{
                type: Output
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Additional Content for the Page Bar */
class MatPageBarContent {
}
MatPageBarContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatPageBarContent, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatPageBarContent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatPageBarContent, selector: "mat-page-bar-content", host: { properties: { "class.mat-page-bar-content": "true" } }, ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatPageBarContent, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-page-bar-content',
                    template: `<ng-content></ng-content>`,
                    host: {
                        '[class.mat-page-bar-content]': 'true'
                    },
                    encapsulation: ViewEncapsulation.None
                }]
        }] });
/** Page Title */
class MatPageTitle {
}
MatPageTitle.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatPageTitle, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatPageTitle.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatPageTitle, selector: "mat-page-title", inputs: { categoryName: "categoryName", pageName: "pageName" }, host: { classAttribute: "mat-page-title" }, ngImport: i0, template: `<div *ngIf="!!categoryName" class="category-name">
      {{ categoryName }}
    </div>
    <span *ngIf="!!categoryName" class="divider">:</span>
    <div class="page-name">{{ pageName }}</div>`, isInline: true, directives: [{ type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatPageTitle, decorators: [{
            type: Component,
            args: [{
                    selector: 'mat-page-title',
                    template: `<div *ngIf="!!categoryName" class="category-name">
      {{ categoryName }}
    </div>
    <span *ngIf="!!categoryName" class="divider">:</span>
    <div class="page-name">{{ pageName }}</div>`,
                    host: {
                        class: 'mat-page-title'
                    },
                    encapsulation: ViewEncapsulation.None
                }]
        }], propDecorators: { categoryName: [{
                type: Input
            }], pageName: [{
                type: Input
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const tooltipDefaults = {
    disableTooltipInteractivity: true,
    showDelay: 0,
    hideDelay: 0,
    touchendHideDelay: 1500
};
/** Profile Panel Button for Application Bar */
class MatProfilePanelButton {
    constructor(_intl, _changeDetectorRef) {
        this._intl = _intl;
        this._changeDetectorRef = _changeDetectorRef;
        /** Profile Panel button toggled event */
        this.profilePanelToggled = new EventEmitter();
        this._intlChanges = _intl.changes.subscribe(() => this._changeDetectorRef.markForCheck());
    }
    /** Whether the panel button state is open/closed */
    get panelOpen() {
        return this._panelOpen;
    }
    set panelOpen(value) {
        this._panelOpen = coerceBooleanProperty(value);
        this.profilePanelToggled.emit(this._panelOpen);
    }
    ngOnDestroy() {
        this._destroyed = true;
        this._intlChanges.unsubscribe();
    }
    /** Toggles the Profile Panel button open/closed states */
    togglePanel() {
        if (!this._destroyed) {
            this.panelOpen = !this._panelOpen;
        }
    }
}
MatProfilePanelButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelButton, deps: [{ token: MatHeaderIntl }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MatProfilePanelButton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatProfilePanelButton, selector: "mat-profile-panel-button", inputs: { panelOpen: "panelOpen", profileInitials: "profileInitials", showBadge: "showBadge" }, outputs: { profilePanelToggled: "profilePanelToggled" }, host: { properties: { "class.mat-profile-panel-button-container": "true", "class.mat-panel-button-open": "panelOpen" } }, providers: [
        MAT_HEADER_INTL_PROVIDER,
        {
            provide: MAT_TOOLTIP_DEFAULT_OPTIONS,
            useValue: tooltipDefaults
        }
    ], ngImport: i0, template: "<button mat-button\n        class=\"profile-panel-button\"\n        [attr.aria-label]=\"_panelOpen ? _intl.closeProfilePanelButtonLabel : _intl.openProfilePanelButtonLabel\"\n        [matTooltip]=\"_panelOpen ? _intl.closeProfilePanelButtonLabel : _intl.openProfilePanelButtonLabel\"\n        [disableRipple]=\"true\"\n        (click)=\"togglePanel()\">\n  <mat-icon *ngIf=\"!profileInitials\"\n            fontSet=\"material-symbols-outlined\">account_circle</mat-icon>\n  <div *ngIf=\"profileInitials\"\n       class=\"mat-profile-user-initials\">{{ profileInitials }}</div>\n  <span *ngIf=\"showBadge\"\n        class=\"mat-profile-panel-badge\">&nbsp;</span>\n</button>", components: [{ type: i2.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i4.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatProfilePanelButton, decorators: [{
            type: Component,
            args: [{ selector: `mat-profile-panel-button`, providers: [
                        MAT_HEADER_INTL_PROVIDER,
                        {
                            provide: MAT_TOOLTIP_DEFAULT_OPTIONS,
                            useValue: tooltipDefaults
                        }
                    ], host: {
                        '[class.mat-profile-panel-button-container]': 'true',
                        '[class.mat-panel-button-open]': 'panelOpen'
                    }, encapsulation: ViewEncapsulation.None, template: "<button mat-button\n        class=\"profile-panel-button\"\n        [attr.aria-label]=\"_panelOpen ? _intl.closeProfilePanelButtonLabel : _intl.openProfilePanelButtonLabel\"\n        [matTooltip]=\"_panelOpen ? _intl.closeProfilePanelButtonLabel : _intl.openProfilePanelButtonLabel\"\n        [disableRipple]=\"true\"\n        (click)=\"togglePanel()\">\n  <mat-icon *ngIf=\"!profileInitials\"\n            fontSet=\"material-symbols-outlined\">account_circle</mat-icon>\n  <div *ngIf=\"profileInitials\"\n       class=\"mat-profile-user-initials\">{{ profileInitials }}</div>\n  <span *ngIf=\"showBadge\"\n        class=\"mat-profile-panel-badge\">&nbsp;</span>\n</button>" }]
        }], ctorParameters: function () { return [{ type: MatHeaderIntl }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { panelOpen: [{
                type: Input
            }], profileInitials: [{
                type: Input
            }], showBadge: [{
                type: Input
            }], profilePanelToggled: [{
                type: Output
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatHeaderModule {
}
MatHeaderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MatHeaderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderModule, declarations: [MatAppBanner,
        MatNavPanelButton,
        MatProductIcon,
        MatAppBarContent,
        MatAppBarSearch,
        MatProfilePanelButton,
        MatProfilePanelUserInitialsButton,
        MatProductName,
        MatHeader,
        MatPageBarContent,
        MatPageTitle,
        MatBackButton], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        MatCommonModule,
        MatButtonModule,
        MatTooltipModule,
        MatIconModule], exports: [MatCommonModule,
        MatAppBanner,
        MatNavPanelButton,
        MatProductIcon,
        MatAppBarContent,
        MatAppBarSearch,
        MatProfilePanelButton,
        MatProfilePanelUserInitialsButton,
        MatProductName,
        MatHeader,
        MatPageBarContent,
        MatPageTitle,
        MatBackButton] });
MatHeaderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderModule, providers: [MAT_HEADER_INTL_PROVIDER], imports: [[
            CommonModule,
            FormsModule,
            ReactiveFormsModule,
            MatCommonModule,
            MatButtonModule,
            MatTooltipModule,
            MatIconModule
        ], MatCommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MatCommonModule,
                        MatButtonModule,
                        MatTooltipModule,
                        MatIconModule
                    ],
                    exports: [
                        MatCommonModule,
                        MatAppBanner,
                        MatNavPanelButton,
                        MatProductIcon,
                        MatAppBarContent,
                        MatAppBarSearch,
                        MatProfilePanelButton,
                        MatProfilePanelUserInitialsButton,
                        MatProductName,
                        MatHeader,
                        MatPageBarContent,
                        MatPageTitle,
                        MatBackButton
                    ],
                    declarations: [
                        MatAppBanner,
                        MatNavPanelButton,
                        MatProductIcon,
                        MatAppBarContent,
                        MatAppBarSearch,
                        MatProfilePanelButton,
                        MatProfilePanelUserInitialsButton,
                        MatProductName,
                        MatHeader,
                        MatPageBarContent,
                        MatPageTitle,
                        MatBackButton
                    ],
                    providers: [MAT_HEADER_INTL_PROVIDER]
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MAT_HEADER_INTL_PROVIDER, MAT_HEADER_INTL_PROVIDER_FACTORY, MatAppBanner, MatAppBarContent, MatAppBarSearch, MatBackButton, MatHeader, MatHeaderIntl, MatHeaderModule, MatNavPanelButton, MatPageBarContent, MatPageTitle, MatProductIcon, MatProductName, MatProfilePanelButton, MatProfilePanelUserInitialsButton, matHeaderAnimations, matPanelAnimations };
//# sourceMappingURL=vdlx-vdl-angular-mat-header.mjs.map
