/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Optional } from '@angular/core';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
/** Datepicker data that requires internationalization. */
export declare class MatHeaderIntl {
    /**
     * Stream that emits whenever the labels here are changed. Use this to notify
     * components if the labels have changed after initialization.
     */
    readonly changes: Subject<void>;
    /** A label for the button used to open the Nav Panel (used by screen readers). */
    openNavPanelButtonLabel: string;
    /** Label for the button used to close the Nav Panel. */
    closeNavPanelButtonLabel: string;
    /** A label for the button used to open the Profile Panel (used by screen readers). */
    openProfilePanelButtonLabel: string;
    /** Label for the button used to close the Profile Panel. */
    closeProfilePanelButtonLabel: string;
    /** Label for the back button on page bar */
    backButtonLabel: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatHeaderIntl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MatHeaderIntl>;
}
/** @docs-private */
export declare function MAT_HEADER_INTL_PROVIDER_FACTORY(parentIntl: MatHeaderIntl): MatHeaderIntl;
/** @docs-private */
export declare const MAT_HEADER_INTL_PROVIDER: {
    provide: typeof MatHeaderIntl;
    deps: Optional[][];
    useFactory: typeof MAT_HEADER_INTL_PROVIDER_FACTORY;
};
