import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { MatHeaderIntl } from './header-intl';
import * as i0 from "@angular/core";
/** Nav Menu Button for Application Bar */
export declare class MatNavPanelButton implements OnDestroy {
    _intl: MatHeaderIntl;
    private _changeDetectorRef;
    private _intlChanges;
    /** Whether the panel button state is open/closed */
    get panelOpen(): boolean;
    set panelOpen(value: boolean);
    _panelOpen: boolean;
    /** Whether the component has been destroyed. */
    private _destroyed;
    /** Nav Panel toggled event */
    readonly navPanelToggled: EventEmitter<boolean>;
    /** Animation Start event */
    readonly animationStart: EventEmitter<boolean>;
    /** Animation End event */
    readonly animationDone: EventEmitter<boolean>;
    constructor(_intl: MatHeaderIntl, _changeDetectorRef: ChangeDetectorRef);
    ngOnDestroy(): void;
    /** Toggles the Nav Panel button open/closed states */
    togglePanel(): void;
    /** Emits animation start event when Nav Panel animation begins */
    navPanelAnimationStarted(): void;
    /** Emits animation done event when Nav Panel animation ends */
    navPanelAnimationDone(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatNavPanelButton, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatNavPanelButton, "mat-nav-panel-button", never, { "panelOpen": "panelOpen"; }, { "navPanelToggled": "navPanelToggled"; "animationStart": "animationStart"; "animationDone": "animationDone"; }, never, never>;
}
