import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { MatHeaderIntl } from './header-intl';
import * as i0 from "@angular/core";
/** Profile Panel Button for Application Bar */
export declare class MatProfilePanelButton implements OnDestroy {
    _intl: MatHeaderIntl;
    private _changeDetectorRef;
    private _intlChanges;
    /** Whether the panel button state is open/closed */
    get panelOpen(): boolean;
    set panelOpen(value: boolean);
    _panelOpen: boolean;
    /** Initials to be used in profile panel button */
    profileInitials: string;
    /** Whether to show the notification badge on the profile panel button */
    showBadge: boolean;
    /** Whether the component has been destroyed. */
    private _destroyed;
    /** Profile Panel button toggled event */
    readonly profilePanelToggled: EventEmitter<boolean>;
    constructor(_intl: MatHeaderIntl, _changeDetectorRef: ChangeDetectorRef);
    ngOnDestroy(): void;
    /** Toggles the Profile Panel button open/closed states */
    togglePanel(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatProfilePanelButton, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatProfilePanelButton, "mat-profile-panel-button", never, { "panelOpen": "panelOpen"; "profileInitials": "profileInitials"; "showBadge": "showBadge"; }, { "profilePanelToggled": "profilePanelToggled"; }, never, never>;
}
