/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Optional } from '@angular/core';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
/** Datepicker data that requires internationalization. */
export declare class MatLoginIntl {
    /**
     * Stream that emits whenever the labels here are changed. Use this to notify
     * components if the labels have changed after initialization.
     */
    readonly changes: Subject<void>;
    /** Company Name */
    veritas: string;
    /** Login Form Divider OR label  */
    formDividerLabel: string;
    /** Login Footer Version Label  */
    footerVersionLabel: string;
    /** Veritas copyright notice */
    copyright: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatLoginIntl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MatLoginIntl>;
}
/** @docs-private */
export declare function MAT_LOGIN_INTL_PROVIDER_FACTORY(parentIntl: MatLoginIntl): MatLoginIntl;
/** @docs-private */
export declare const MAT_LOGIN_INTL_PROVIDER: {
    provide: typeof MatLoginIntl;
    deps: Optional[][];
    useFactory: typeof MAT_LOGIN_INTL_PROVIDER_FACTORY;
};
