/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { MatNotification, MatNotificationEvent, MatNotificationItem, MatNotificationType } from '@vdlx/vdl-angular/mat/notification';
import { MatLoginIntl } from './login-intl';
import * as i0 from "@angular/core";
/** Login Product Icon directive */
export declare class MatLoginProductIcon {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatLoginProductIcon, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatLoginProductIcon, "[mat-login-product-icon]", never, {}, {}, never>;
}
/** Login Product Name component */
export declare class MatLoginProductName {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatLoginProductName, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatLoginProductName, "mat-login-product-name", never, {}, {}, never, ["*"]>;
}
/** Login component */
export declare class MatLogin implements OnDestroy {
    _intl: MatLoginIntl;
    private _changeDetectorRef;
    private _intlChanges;
    /** Notifications that are being displayed */
    notificationOpen: {
        transient: boolean;
        persistent: boolean;
    };
    /** Handles queue of notifications */
    notificationQueue: {
        persistent: MatNotificationItem[];
        transient: MatNotificationItem[];
    };
    /** Product Version string */
    productVersion: string;
    /** Login form notification */
    matLoginNotification: MatNotification;
    /** Notification closed event */
    notificationClosedEvent: EventEmitter<string>;
    constructor(_intl: MatLoginIntl, _changeDetectorRef: ChangeDetectorRef);
    ngOnDestroy(): void;
    /** Add transient notification to queue. Default notification type is Transient */
    addNotification(type: MatNotificationType | undefined, notification: MatNotificationItem): void;
    /** Displays next notification in the queue */
    sendNotification(type: MatNotificationType): void;
    /** On notification closed handler */
    notificationClosedHandler(event: MatNotificationEvent): void;
    /** Clear alllnotifications */
    clearNotifications(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatLogin, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatLogin, "mat-login", never, { "productVersion": "productVersion"; }, { "notificationClosedEvent": "notificationClosedEvent"; }, never, ["[mat-login-product-icon]", "mat-login-product-name", "[mat-login-form]", "[mat-login-footer-buttons]"]>;
}
