/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Optional } from '@angular/core';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
/**
 * To modify the labels and text displayed, create a new instance of MatNotificationIntl and include it in a custom provider.
 */
export declare class MatNotificationIntl {
    /**
     * Stream that emits whenever the labels here are changed. Use this to notify
     * components if the labels have changed after initialization.
     */
    readonly changes: Subject<void>;
    /** Labels for notification states */
    stateLabel: {
        default: string;
        error: string;
        success: string;
        info: string;
        warning: string;
    };
    /** A label for the close notification button */
    closeNotificationButtonLabel: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatNotificationIntl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MatNotificationIntl>;
}
/** @docs-private */
export declare function MAT_NOTIFICATION_INTL_PROVIDER_FACTORY(parentIntl: MatNotificationIntl): MatNotificationIntl;
/** @docs-private */
export declare const MAT_NOTIFICATION_INTL_PROVIDER: {
    provide: typeof MatNotificationIntl;
    deps: Optional[][];
    useFactory: typeof MAT_NOTIFICATION_INTL_PROVIDER_FACTORY;
};
