import * as i5 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Injectable, Optional, SkipSelf, Directive, Component, ViewEncapsulation, ChangeDetectionStrategy, Input, ContentChildren, NgModule } from '@angular/core';
import * as i2 from '@vdlx/vdl-angular/mat/button';
import { MatButtonModule } from '@vdlx/vdl-angular/mat/button';
import * as i3 from '@vdlx/vdl-angular/mat/icon';
import { MatIconModule } from '@vdlx/vdl-angular/mat/icon';
import * as i4 from '@vdlx/vdl-angular/mat/menu';
import { MatMenuModule } from '@vdlx/vdl-angular/mat/menu';
import * as i6 from '@vdlx/vdl-angular/mat/tooltip';
import { MatTooltipModule } from '@vdlx/vdl-angular/mat/tooltip';
import { Subject } from 'rxjs';

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class OverflowBarIntl {
    constructor() {
        /**
         * Stream that emits whenever the labels here are changed. Use this to notify
         * components if the labels have changed after initialization.
         */
        this.changes = new Subject();
        /** Placeholder for Overflow Bar Tooltip  */
        this.overflowBarButtonTooltip = `App Button Overflow`;
        /** Placeholder for Overflow Bar AriaLabel  */
        this.overflowBarButtonAriaLabel = `Overflow Menu`;
    }
}
OverflowBarIntl.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: OverflowBarIntl, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
OverflowBarIntl.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: OverflowBarIntl, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: OverflowBarIntl, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });
/** @docs-private */
function ACTION_OVERFLOW_INTL_PROVIDER_FACTORY(parentIntl) {
    return parentIntl || new OverflowBarIntl();
}
/** @docs-private */
const ACTION_OVERFLOW_INTL_PROVIDER = {
    // If there is already an OverflowBarIntl available, use that. Otherwise, provide a new one.
    provide: OverflowBarIntl,
    deps: [[new Optional(), new SkipSelf(), OverflowBarIntl]],
    useFactory: ACTION_OVERFLOW_INTL_PROVIDER_FACTORY
};

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Overflow bar to be rendered within the App Bar.
 */
class MatAppBarOverflow {
    constructor() { }
}
MatAppBarOverflow.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBarOverflow, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatAppBarOverflow.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatAppBarOverflow, selector: "[mat-app-bar-overflow]", host: { properties: { "class.mat-app-bar-overflow": "true" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatAppBarOverflow, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-app-bar-overflow]',
                    host: {
                        '[class.mat-app-bar-overflow]': 'true'
                    }
                }]
        }], ctorParameters: function () { return []; } });
/**
 * Overflow bar to be rendered within the Page Bar.
 */
class MatPageBarOverflow {
    constructor() { }
}
MatPageBarOverflow.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatPageBarOverflow, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatPageBarOverflow.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatPageBarOverflow, selector: "[mat-page-bar-overflow]", host: { properties: { "class.mat-page-bar-overflow": "true" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatPageBarOverflow, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-page-bar-overflow]',
                    host: {
                        '[class.mat-page-bar-overflow]': 'true'
                    }
                }]
        }], ctorParameters: function () { return []; } });
/**
 * Directive applied to handle button, anchor and checkbox actions within the overflow bar.
 */
class MatBarItem {
    constructor(barItemElementRef) {
        this.barItemElementRef = barItemElementRef;
    }
}
MatBarItem.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBarItem, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
MatBarItem.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatBarItem, selector: "[mat-overflow-bar-action]", host: { properties: { "class.mat-overflow-bar-action": "true" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatBarItem, decorators: [{
            type: Directive,
            args: [{
                    selector: '[mat-overflow-bar-action]',
                    host: {
                        '[class.mat-overflow-bar-action]': 'true'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; } });
/**
 * Defines overflow bar contents to be rendered as both menu and non-menu actions
 */
class MatOverflowBarItem {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
MatOverflowBarItem.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBarItem, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
MatOverflowBarItem.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatOverflowBarItem, selector: "ng-template[mat-overflow-bar-item]", host: { properties: { "class.mat-overflow-bar-item": "true" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBarItem, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[mat-overflow-bar-item]',
                    host: {
                        '[class.mat-overflow-bar-item]': 'true'
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });
/**
 * Adds bar overflow button, checkbox, link and menu action
 */
class MatOverflowBar {
    constructor(_intl) {
        this._intl = _intl;
        this.showButtonText = true;
        this.disableOverflow = false;
        this._overflowBoundaries = [
            { width: 'default', buttonCount: 2 },
            { width: 500, buttonCount: 0 }
        ];
    }
    get overflowBoundaries() {
        return this._overflowBoundaries;
    }
    set overflowBoundaries(value) {
        if (value.length > 0) {
            this._overflowBoundaries = value;
        }
        else {
            this._overflowBoundaries = [
                { width: 'default', buttonCount: 2 },
                { width: 500, buttonCount: 0 }
            ];
        }
    }
    ngAfterContentInit() {
        this.actionItems = this.matOverflowBarItems.toArray();
    }
    matMenuItem(actionItem) {
        return actionItem.templateRef;
    }
    getWidth() {
        return window.innerWidth;
    }
    hasOverflowButtons() {
        let hasOverflow = false;
        this.overflowBoundaries.forEach((boundary) => {
            if (!this.disableOverflow &&
                ((boundary.width === 'default' &&
                    this.actionItems.length > boundary.buttonCount) ||
                    (this.getWidth() <= boundary.width &&
                        this.actionItems.length > boundary.buttonCount))) {
                hasOverflow = true;
            }
        });
        return hasOverflow;
    }
    isOverflowButton(index) {
        let isOverflowButton = false;
        this.overflowBoundaries.forEach((boundary) => {
            if (!this.disableOverflow &&
                ((boundary.width === 'default' && index >= boundary.buttonCount) ||
                    (this.getWidth() <= boundary.width && index >= boundary.buttonCount))) {
                isOverflowButton = true;
            }
        });
        return isOverflowButton;
    }
}
MatOverflowBar.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBar, deps: [{ token: OverflowBarIntl }], target: i0.ɵɵFactoryTarget.Component });
MatOverflowBar.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatOverflowBar, selector: "mat-overflow-bar", inputs: { showButtonText: "showButtonText", disableOverflow: "disableOverflow", overflowBoundaries: "overflowBoundaries" }, host: { listeners: { "window:resize": "hasOverflowButtons()" }, properties: { "class.mat-overflow-bar": "true", "class.show-action-button-text": "showButtonText" } }, queries: [{ propertyName: "matOverflowBarItems", predicate: MatOverflowBarItem }], ngImport: i0, template: "<ng-container *ngFor=\"let action of actionItems; index as i\">\n  <ng-template *ngIf=\"!isOverflowButton(i)\"\n               [ngTemplateOutlet]=\"matMenuItem(action)\"></ng-template>\n</ng-container>\n\n<button mat-button\n        [matMenuTriggerFor]=\"overflowBar\"\n        [matTooltip]=\"_intl.overflowBarButtonTooltip\"\n        [attr.aria-label]=\"_intl.overflowBarButtonAriaLabel\"\n        *ngIf=\"hasOverflowButtons()\">\n  <mat-icon fontSet=\"material-symbols-outlined\">more_vert</mat-icon>\n</button>\n\n<mat-menu #overflowBar=\"matMenu\">\n  <ng-container *ngFor=\"let action of actionItems; index as i\">\n    <div mat-menu-item\n         *ngIf=\"isOverflowButton(i)\">\n      <ng-template [ngTemplateOutlet]=\"matMenuItem(action)\"></ng-template>\n    </div>\n  </ng-container>\n</mat-menu>", styles: [".mat-overflow-bar{flex-direction:row;align-items:center;display:flex}.mat-overflow-bar .mat-menu-trigger{height:30px;width:30px;min-width:30px;margin-right:-13px}.mat-overflow-bar .mat-menu-trigger .mat-button-wrapper{display:flex;align-items:center;justify-content:center}.mat-overflow-bar>button+button,.mat-overflow-bar>a+button,.mat-overflow-bar>button+a{margin-left:8px}.mat-overflow-bar>a+a{margin-left:12px}.mat-overflow-bar>button.mat-overflow-bar-action{display:flex;align-items:center;justify-content:center;min-width:30px;width:unset;padding:0 10px}.mat-overflow-bar>button.mat-overflow-bar-action.mat-button{border-radius:3px;border:1px solid}.mat-overflow-bar>button.mat-overflow-bar-action .button-label{display:none}.mat-overflow-bar>button.mat-overflow-bar-action>.mat-overflow-bar-item-container{display:flex;align-items:center;justify-content:center;border-radius:4px}div[mat-menu-item] .mat-overflow-bar-action{display:contents}.mat-app-bar-container .mat-overflow-bar{margin-right:10px}.mat-page-bar-container .mat-checkbox{padding-left:25px}.mat-overflow-bar-action{display:inline-flex}.show-action-button-text>button.mat-overflow-bar-action{width:unset}.show-action-button-text>button.mat-overflow-bar-action>span.mat-button-wrapper{display:flex;justify-content:center}.show-action-button-text>button.mat-overflow-bar-action .mat-icon+.button-label{padding-left:4px;display:unset}.show-action-button-text>button.mat-overflow-bar-action [dir=rtl] .mat-icon+.button-label{padding-left:unset;padding-right:4px}[dir=rtl] .mat-app-bar-container .mat-overflow-bar{margin-left:-13px}[dir=rtl] .mat-page-bar-container .mat-overflow-bar .mat-menu-trigger{margin-right:-5px}[dir=rtl] .mat-page-bar-container .mat-overflow-bar>button+button,[dir=rtl] .mat-page-bar-container .mat-overflow-bar>a+button,[dir=rtl] .mat-page-bar-container .mat-overflow-bar>button+a{margin-right:8px}[dir=rtl] .mat-page-bar-container .mat-overflow-bar>a+a{margin-right:12px}\n"], components: [{ type: i2.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i4.MatMenu, selector: "mat-menu", exportAs: ["matMenu"] }, { type: i4.MatMenuItem, selector: "[mat-menu-item]", inputs: ["disabled", "disableRipple", "role"], exportAs: ["matMenuItem"] }], directives: [{ type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i4.MatMenuTrigger, selector: "[mat-menu-trigger-for], [matMenuTriggerFor]", exportAs: ["matMenuTrigger"] }, { type: i6.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBar, decorators: [{
            type: Component,
            args: [{ selector: 'mat-overflow-bar', host: {
                        '[class.mat-overflow-bar]': 'true',
                        '[class.show-action-button-text]': 'showButtonText',
                        '(window:resize)': 'hasOverflowButtons()'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngFor=\"let action of actionItems; index as i\">\n  <ng-template *ngIf=\"!isOverflowButton(i)\"\n               [ngTemplateOutlet]=\"matMenuItem(action)\"></ng-template>\n</ng-container>\n\n<button mat-button\n        [matMenuTriggerFor]=\"overflowBar\"\n        [matTooltip]=\"_intl.overflowBarButtonTooltip\"\n        [attr.aria-label]=\"_intl.overflowBarButtonAriaLabel\"\n        *ngIf=\"hasOverflowButtons()\">\n  <mat-icon fontSet=\"material-symbols-outlined\">more_vert</mat-icon>\n</button>\n\n<mat-menu #overflowBar=\"matMenu\">\n  <ng-container *ngFor=\"let action of actionItems; index as i\">\n    <div mat-menu-item\n         *ngIf=\"isOverflowButton(i)\">\n      <ng-template [ngTemplateOutlet]=\"matMenuItem(action)\"></ng-template>\n    </div>\n  </ng-container>\n</mat-menu>", styles: [".mat-overflow-bar{flex-direction:row;align-items:center;display:flex}.mat-overflow-bar .mat-menu-trigger{height:30px;width:30px;min-width:30px;margin-right:-13px}.mat-overflow-bar .mat-menu-trigger .mat-button-wrapper{display:flex;align-items:center;justify-content:center}.mat-overflow-bar>button+button,.mat-overflow-bar>a+button,.mat-overflow-bar>button+a{margin-left:8px}.mat-overflow-bar>a+a{margin-left:12px}.mat-overflow-bar>button.mat-overflow-bar-action{display:flex;align-items:center;justify-content:center;min-width:30px;width:unset;padding:0 10px}.mat-overflow-bar>button.mat-overflow-bar-action.mat-button{border-radius:3px;border:1px solid}.mat-overflow-bar>button.mat-overflow-bar-action .button-label{display:none}.mat-overflow-bar>button.mat-overflow-bar-action>.mat-overflow-bar-item-container{display:flex;align-items:center;justify-content:center;border-radius:4px}div[mat-menu-item] .mat-overflow-bar-action{display:contents}.mat-app-bar-container .mat-overflow-bar{margin-right:10px}.mat-page-bar-container .mat-checkbox{padding-left:25px}.mat-overflow-bar-action{display:inline-flex}.show-action-button-text>button.mat-overflow-bar-action{width:unset}.show-action-button-text>button.mat-overflow-bar-action>span.mat-button-wrapper{display:flex;justify-content:center}.show-action-button-text>button.mat-overflow-bar-action .mat-icon+.button-label{padding-left:4px;display:unset}.show-action-button-text>button.mat-overflow-bar-action [dir=rtl] .mat-icon+.button-label{padding-left:unset;padding-right:4px}[dir=rtl] .mat-app-bar-container .mat-overflow-bar{margin-left:-13px}[dir=rtl] .mat-page-bar-container .mat-overflow-bar .mat-menu-trigger{margin-right:-5px}[dir=rtl] .mat-page-bar-container .mat-overflow-bar>button+button,[dir=rtl] .mat-page-bar-container .mat-overflow-bar>a+button,[dir=rtl] .mat-page-bar-container .mat-overflow-bar>button+a{margin-right:8px}[dir=rtl] .mat-page-bar-container .mat-overflow-bar>a+a{margin-right:12px}\n"] }]
        }], ctorParameters: function () { return [{ type: OverflowBarIntl }]; }, propDecorators: { showButtonText: [{
                type: Input
            }], disableOverflow: [{
                type: Input
            }], overflowBoundaries: [{
                type: Input
            }], matOverflowBarItems: [{
                type: ContentChildren,
                args: [MatOverflowBarItem]
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatOverflowBarModule {
}
MatOverflowBarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MatOverflowBarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBarModule, declarations: [MatAppBarOverflow,
        MatBarItem,
        MatOverflowBar,
        MatOverflowBarItem,
        MatPageBarOverflow], imports: [CommonModule,
        MatIconModule,
        MatMenuModule,
        MatButtonModule,
        MatTooltipModule], exports: [MatAppBarOverflow,
        MatBarItem,
        MatOverflowBar,
        MatOverflowBarItem,
        MatPageBarOverflow] });
MatOverflowBarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBarModule, imports: [[
            CommonModule,
            MatIconModule,
            MatMenuModule,
            MatButtonModule,
            MatTooltipModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatOverflowBarModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatIconModule,
                        MatMenuModule,
                        MatButtonModule,
                        MatTooltipModule
                    ],
                    exports: [
                        MatAppBarOverflow,
                        MatBarItem,
                        MatOverflowBar,
                        MatOverflowBarItem,
                        MatPageBarOverflow
                    ],
                    declarations: [
                        MatAppBarOverflow,
                        MatBarItem,
                        MatOverflowBar,
                        MatOverflowBarItem,
                        MatPageBarOverflow
                    ]
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ACTION_OVERFLOW_INTL_PROVIDER, ACTION_OVERFLOW_INTL_PROVIDER_FACTORY, MatAppBarOverflow, MatBarItem, MatOverflowBar, MatOverflowBarItem, MatOverflowBarModule, MatPageBarOverflow, OverflowBarIntl };
//# sourceMappingURL=vdlx-vdl-angular-mat-overflow-bar.mjs.map
