/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Optional } from '@angular/core';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class OverflowBarIntl {
    /**
     * Stream that emits whenever the labels here are changed. Use this to notify
     * components if the labels have changed after initialization.
     */
    readonly changes: Subject<void>;
    /** Placeholder for Overflow Bar Tooltip  */
    overflowBarButtonTooltip: string;
    /** Placeholder for Overflow Bar AriaLabel  */
    overflowBarButtonAriaLabel: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<OverflowBarIntl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<OverflowBarIntl>;
}
/** @docs-private */
export declare function ACTION_OVERFLOW_INTL_PROVIDER_FACTORY(parentIntl: OverflowBarIntl): OverflowBarIntl;
/** @docs-private */
export declare const ACTION_OVERFLOW_INTL_PROVIDER: {
    provide: typeof OverflowBarIntl;
    deps: Optional[][];
    useFactory: typeof ACTION_OVERFLOW_INTL_PROVIDER_FACTORY;
};
