import * as i2$1 from '@angular/cdk/portal';
import { TemplatePortal, PortalModule } from '@angular/cdk/portal';
import { CdkStepLabel, CdkStepHeader, CdkStep, STEPPER_GLOBAL_OPTIONS, CdkStepper, CdkStepperNext, CdkStepperPrevious, CdkStepperModule } from '@angular/cdk/stepper';
import * as i5 from '@angular/common';
import { DOCUMENT, CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Directive, Injectable, Optional, SkipSelf, Component, ViewEncapsulation, ChangeDetectionStrategy, Input, forwardRef, Inject, ContentChild, QueryList, EventEmitter, ViewChildren, ContentChildren, Output, NgModule } from '@angular/core';
import * as i1$1 from '@vdlx/vdl-angular/mat/button';
import { MatButtonModule } from '@vdlx/vdl-angular/mat/button';
import * as i1 from '@vdlx/vdl-angular/mat/core';
import { mixinColor, ErrorStateMatcher, MatCommonModule, MatRippleModule } from '@vdlx/vdl-angular/mat/core';
import * as i3 from '@vdlx/vdl-angular/mat/icon';
import { MatIconModule } from '@vdlx/vdl-angular/mat/icon';
import { Subject, Subscription } from 'rxjs';
import * as i2 from '@angular/cdk/a11y';
import { switchMap, map, startWith, takeUntil, distinctUntilChanged } from 'rxjs/operators';
import { trigger, state, style, transition, animate } from '@angular/animations';
import * as i3$1 from '@angular/cdk/bidi';

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Content for a `mat-step` that will be rendered lazily.
 */
class MatStepContent {
    constructor(_template) {
        this._template = _template;
    }
}
MatStepContent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepContent, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
MatStepContent.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepContent, selector: "ng-template[matStepContent]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepContent, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[matStepContent]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatStepLabel extends CdkStepLabel {
}
MatStepLabel.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepLabel, deps: null, target: i0.ɵɵFactoryTarget.Directive });
MatStepLabel.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepLabel, selector: "[matStepLabel]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepLabel, decorators: [{
            type: Directive,
            args: [{
                    selector: '[matStepLabel]'
                }]
        }] });
// VDL Change: Adds step sublabel
class MatStepSubLabel extends CdkStepLabel {
}
MatStepSubLabel.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepSubLabel, deps: null, target: i0.ɵɵFactoryTarget.Directive });
MatStepSubLabel.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepSubLabel, selector: "[matStepSubLabel]", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepSubLabel, decorators: [{
            type: Directive,
            args: [{
                    selector: '[matStepSubLabel]'
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Stepper data that is required for internationalization. */
class MatStepperIntl {
    constructor() {
        /**
         * Stream that emits whenever the labels here are changed. Use this to notify
         * components if the labels have changed after initialization.
         */
        this.changes = new Subject();
        /** Label that is rendered below optional steps. */
        this.optionalLabel = 'Optional';
        /** Label that is used to indicate step as completed to screen readers. */
        this.completedLabel = 'Completed';
        /** Label that is used to indicate step as editable to screen readers. */
        this.editableLabel = 'Editable';
    }
}
MatStepperIntl.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperIntl, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MatStepperIntl.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperIntl, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperIntl, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });
/** @docs-private */
function MAT_STEPPER_INTL_PROVIDER_FACTORY(parentIntl) {
    return parentIntl || new MatStepperIntl();
}
/** @docs-private */
const MAT_STEPPER_INTL_PROVIDER = {
    provide: MatStepperIntl,
    deps: [[new Optional(), new SkipSelf(), MatStepperIntl]],
    useFactory: MAT_STEPPER_INTL_PROVIDER_FACTORY
};

// Boilerplate for applying mixins to MatStepHeader.
/** @docs-private */
const _MatStepHeaderBase = mixinColor(class MatStepHeaderBase extends CdkStepHeader {
    constructor(elementRef) {
        super(elementRef);
    }
}, 'primary');
class MatStepHeader extends _MatStepHeaderBase {
    constructor(_intl, _focusMonitor, _elementRef, changeDetectorRef) {
        super(_elementRef);
        this._intl = _intl;
        this._focusMonitor = _focusMonitor;
        this._intlSubscription = _intl.changes.subscribe(() => changeDetectorRef.markForCheck());
    }
    ngAfterViewInit() {
        this._focusMonitor.monitor(this._elementRef, true);
    }
    ngOnDestroy() {
        this._intlSubscription.unsubscribe();
        this._focusMonitor.stopMonitoring(this._elementRef);
    }
    /** Focuses the step header. */
    focus(origin, options) {
        if (origin) {
            this._focusMonitor.focusVia(this._elementRef, origin, options);
        }
        else {
            this._elementRef.nativeElement.focus(options);
        }
    }
    /** Returns string label of given step if it is a text label. */
    _stringLabel() {
        return this.label instanceof MatStepLabel ? null : this.label;
    }
    /** Returns MatStepLabel if the label of given step is a template label. */
    _templateLabel() {
        return this.label instanceof MatStepLabel ? this.label : null;
    }
    // VDL Change: Adds Step Sub-Label
    /** Returns string sub label of given step if it is a text sub label. */
    _stringSubLabel() {
        return this.subLabel instanceof MatStepSubLabel ? null : this.subLabel;
    }
    // VDL Change: Adds Step Sub-Label
    /** Returns MatStepLabel if the label of given step is a template sub label. */
    _templateSubLabel() {
        return this.subLabel instanceof MatStepSubLabel ? this.subLabel : null;
    }
    /** Returns the host HTML element. */
    _getHostElement() {
        return this._elementRef.nativeElement;
    }
    /** Template context variables that are exposed to the `matStepperIcon` instances. */
    _getIconContext() {
        return {
            index: this.index,
            active: this.active,
            optional: this.optional
        };
    }
    _getDefaultTextForState(state) {
        if (state == 'number') {
            return `${this.index + 1}`;
        }
        if (state == 'edit') {
            return 'edit';
        }
        if (state == 'error') {
            return 'error';
        }
        return state;
    }
}
MatStepHeader.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepHeader, deps: [{ token: MatStepperIntl }, { token: i2.FocusMonitor }, { token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MatStepHeader.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatStepHeader, selector: "mat-step-header", inputs: { color: "color", state: "state", label: "label", subLabel: "subLabel", errorMessage: "errorMessage", iconOverrides: "iconOverrides", index: "index", selected: "selected", active: "active", optional: "optional", disableRipple: "disableRipple" }, host: { attributes: { "role": "tab" }, classAttribute: "mat-step-header" }, usesInheritance: true, ngImport: i0, template: "<div class=\"mat-step-header-ripple mat-focus-indicator\"\n     matRipple\n     [matRippleTrigger]=\"_getHostElement()\"\n     [matRippleDisabled]=\"disableRipple\"></div>\n\n<div class=\"mat-step-icon-state-{{state}} mat-step-icon\"\n     [class.mat-step-icon-selected]=\"selected\">\n  <div class=\"mat-step-icon-content\"\n       [ngSwitch]=\"!!(iconOverrides && iconOverrides[state])\">\n    <ng-container *ngSwitchCase=\"true\"\n                  [ngTemplateOutlet]=\"iconOverrides[state]\"\n                  [ngTemplateOutletContext]=\"_getIconContext()\"></ng-container>\n    <ng-container *ngSwitchDefault\n                  [ngSwitch]=\"state\">\n      <span aria-hidden=\"true\"\n            *ngSwitchCase=\"'number'\">{{_getDefaultTextForState(state)}}</span>\n      <span class=\"cdk-visually-hidden\"\n            *ngIf=\"state === 'done'\">{{_intl.completedLabel}}</span>\n      <span class=\"cdk-visually-hidden\"\n            *ngIf=\"state === 'edit'\">{{_intl.editableLabel}}</span>\n      <mat-icon fontSet=\"material-symbols-outlined\"\n                class=\"mat-icon-filled\"\n                aria-hidden=\"true\"\n                *ngSwitchDefault>{{_getDefaultTextForState(state)}}</mat-icon>\n    </ng-container>\n  </div>\n</div>\n<div class=\"mat-step-label\"\n     [class.mat-step-label-active]=\"active\"\n     [class.mat-step-label-selected]=\"selected\"\n     [class.mat-step-label-error]=\"state === 'error'\">\n  <!-- If there is a label template, use it. -->\n  <div class=\"mat-step-text-label\"\n       *ngIf=\"_templateLabel()\">\n    <ng-container [ngTemplateOutlet]=\"_templateLabel()!.template\"></ng-container>\n  </div>\n  <!-- If there is no label template, fall back to the text label. -->\n  <div class=\"mat-step-text-label\"\n       *ngIf=\"_stringLabel()\">{{label}}</div>\n\n  <div class=\"mat-step-text-sublabel\"\n       *ngIf=\"_stringSubLabel() || _templateSubLabel()\">\n    <!-- If there is a sub label template, use it. -->\n    <ng-container *ngIf=\"_templateSubLabel()\"\n                  [ngTemplateOutlet]=\"_templateSubLabel()!.template\"></ng-container>\n    <!-- If there is no sub label template, fall back to the text sub label. -->\n\n    {{ _stringSubLabel() }}\n  </div>\n\n  <div class=\"mat-step-optional\"\n       *ngIf=\"optional && state !== 'error'\">{{_intl.optionalLabel}}</div>\n  <div class=\"mat-step-sub-label-error\"\n       *ngIf=\"state === 'error'\">{{errorMessage}}</div>\n</div>", styles: [".mat-step-header{overflow:hidden;outline:none;cursor:pointer;position:relative;box-sizing:content-box;-webkit-tap-highlight-color:transparent}.cdk-high-contrast-active .mat-step-header{outline:solid 1px}.cdk-high-contrast-active .mat-step-header.cdk-keyboard-focused,.cdk-high-contrast-active .mat-step-header.cdk-program-focused{outline:solid 3px}.cdk-high-contrast-active .mat-step-header[aria-selected=true] .mat-step-label{text-decoration:underline}.mat-step-optional,.mat-step-sub-label-error{font-size:12px}.mat-step-icon{border-radius:50%;height:24px;width:24px;flex-shrink:0;position:relative;border-width:1px;border-style:solid}.mat-step-icon-content{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);display:flex}.mat-step-icon .mat-icon{font-size:16px;height:16px;width:16px}.mat-step-icon-state-error .mat-icon{font-size:30px;height:30px;width:30px}.mat-step-label{display:inline-block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;min-width:50px;vertical-align:middle}.mat-step-text-label{text-overflow:ellipsis;overflow:hidden}.mat-step-header .mat-step-header-ripple{inset:0;position:absolute;pointer-events:none}\n"], components: [{ type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i1.MatRipple, selector: "[mat-ripple], [matRipple]", inputs: ["matRippleColor", "matRippleUnbounded", "matRippleCentered", "matRippleRadius", "matRippleAnimation", "matRippleDisabled", "matRippleTrigger"], exportAs: ["matRipple"] }, { type: i5.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i5.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i5.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i5.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepHeader, decorators: [{
            type: Component,
            args: [{ selector: 'mat-step-header', inputs: ['color'], host: {
                        class: 'mat-step-header',
                        role: 'tab'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"mat-step-header-ripple mat-focus-indicator\"\n     matRipple\n     [matRippleTrigger]=\"_getHostElement()\"\n     [matRippleDisabled]=\"disableRipple\"></div>\n\n<div class=\"mat-step-icon-state-{{state}} mat-step-icon\"\n     [class.mat-step-icon-selected]=\"selected\">\n  <div class=\"mat-step-icon-content\"\n       [ngSwitch]=\"!!(iconOverrides && iconOverrides[state])\">\n    <ng-container *ngSwitchCase=\"true\"\n                  [ngTemplateOutlet]=\"iconOverrides[state]\"\n                  [ngTemplateOutletContext]=\"_getIconContext()\"></ng-container>\n    <ng-container *ngSwitchDefault\n                  [ngSwitch]=\"state\">\n      <span aria-hidden=\"true\"\n            *ngSwitchCase=\"'number'\">{{_getDefaultTextForState(state)}}</span>\n      <span class=\"cdk-visually-hidden\"\n            *ngIf=\"state === 'done'\">{{_intl.completedLabel}}</span>\n      <span class=\"cdk-visually-hidden\"\n            *ngIf=\"state === 'edit'\">{{_intl.editableLabel}}</span>\n      <mat-icon fontSet=\"material-symbols-outlined\"\n                class=\"mat-icon-filled\"\n                aria-hidden=\"true\"\n                *ngSwitchDefault>{{_getDefaultTextForState(state)}}</mat-icon>\n    </ng-container>\n  </div>\n</div>\n<div class=\"mat-step-label\"\n     [class.mat-step-label-active]=\"active\"\n     [class.mat-step-label-selected]=\"selected\"\n     [class.mat-step-label-error]=\"state === 'error'\">\n  <!-- If there is a label template, use it. -->\n  <div class=\"mat-step-text-label\"\n       *ngIf=\"_templateLabel()\">\n    <ng-container [ngTemplateOutlet]=\"_templateLabel()!.template\"></ng-container>\n  </div>\n  <!-- If there is no label template, fall back to the text label. -->\n  <div class=\"mat-step-text-label\"\n       *ngIf=\"_stringLabel()\">{{label}}</div>\n\n  <div class=\"mat-step-text-sublabel\"\n       *ngIf=\"_stringSubLabel() || _templateSubLabel()\">\n    <!-- If there is a sub label template, use it. -->\n    <ng-container *ngIf=\"_templateSubLabel()\"\n                  [ngTemplateOutlet]=\"_templateSubLabel()!.template\"></ng-container>\n    <!-- If there is no sub label template, fall back to the text sub label. -->\n\n    {{ _stringSubLabel() }}\n  </div>\n\n  <div class=\"mat-step-optional\"\n       *ngIf=\"optional && state !== 'error'\">{{_intl.optionalLabel}}</div>\n  <div class=\"mat-step-sub-label-error\"\n       *ngIf=\"state === 'error'\">{{errorMessage}}</div>\n</div>", styles: [".mat-step-header{overflow:hidden;outline:none;cursor:pointer;position:relative;box-sizing:content-box;-webkit-tap-highlight-color:transparent}.cdk-high-contrast-active .mat-step-header{outline:solid 1px}.cdk-high-contrast-active .mat-step-header.cdk-keyboard-focused,.cdk-high-contrast-active .mat-step-header.cdk-program-focused{outline:solid 3px}.cdk-high-contrast-active .mat-step-header[aria-selected=true] .mat-step-label{text-decoration:underline}.mat-step-optional,.mat-step-sub-label-error{font-size:12px}.mat-step-icon{border-radius:50%;height:24px;width:24px;flex-shrink:0;position:relative;border-width:1px;border-style:solid}.mat-step-icon-content{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);display:flex}.mat-step-icon .mat-icon{font-size:16px;height:16px;width:16px}.mat-step-icon-state-error .mat-icon{font-size:30px;height:30px;width:30px}.mat-step-label{display:inline-block;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;min-width:50px;vertical-align:middle}.mat-step-text-label{text-overflow:ellipsis;overflow:hidden}.mat-step-header .mat-step-header-ripple{inset:0;position:absolute;pointer-events:none}\n"] }]
        }], ctorParameters: function () { return [{ type: MatStepperIntl }, { type: i2.FocusMonitor }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { state: [{
                type: Input
            }], label: [{
                type: Input
            }], subLabel: [{
                type: Input
            }], errorMessage: [{
                type: Input
            }], iconOverrides: [{
                type: Input
            }], index: [{
                type: Input
            }], selected: [{
                type: Input
            }], active: [{
                type: Input
            }], optional: [{
                type: Input
            }], disableRipple: [{
                type: Input
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Animations used by the Material steppers.
 * @docs-private
 */
const matStepperAnimations = {
    /** Animation that transitions the step along the X axis in a horizontal stepper. */
    horizontalStepTransition: trigger('horizontalStepTransition', [
        state('previous', style({ transform: 'translate3d(-100%, 0, 0)', visibility: 'hidden' })),
        // Transition to `inherit`, rather than `visible`,
        // because visibility on a child element the one from the parent,
        // making this element focusable inside of a `hidden` element.
        state('current', style({ transform: 'none', visibility: 'inherit' })),
        state('next', style({ transform: 'translate3d(100%, 0, 0)', visibility: 'hidden' })),
        transition('* => *', animate('500ms cubic-bezier(0.35, 0, 0.25, 1)'))
    ]),
    // VDL Change: VDLs vertical stepper requires a horizontal animation
    /** Animation that transitions the step along the X axis in a vertical stepper. */
    verticalStepTransition: trigger('verticalStepTransition', [
        state('previous', style({ transform: 'translate3d(-100%, 0, 0)', visibility: 'hidden' })),
        // Transition to `inherit`, rather than `visible`,
        // because visibility on a child element the one from the parent,
        // making this element focusable inside of a `hidden` element.
        state('current', style({ transform: 'none', visibility: 'inherit' })),
        state('next', style({ transform: 'translate3d(100%, 0, 0)', visibility: 'hidden' })),
        transition('* <=> current', animate('500ms cubic-bezier(0.35, 0, 0.25, 1)'))
    ])
};

/**
 * Template to be used to override the icons inside the step header.
 */
class MatStepperIcon {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
MatStepperIcon.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperIcon, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
MatStepperIcon.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperIcon, selector: "ng-template[matStepperIcon]", inputs: { name: ["matStepperIcon", "name"] }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperIcon, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[matStepperIcon]'
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { name: [{
                type: Input,
                args: ['matStepperIcon']
            }] } });

class MatStep extends CdkStep {
    constructor(stepper, _errorStateMatcher, _viewContainerRef, stepperOptions) {
        super(stepper, stepperOptions);
        this._errorStateMatcher = _errorStateMatcher;
        this._viewContainerRef = _viewContainerRef;
        this._isSelected = Subscription.EMPTY;
    }
    ngAfterContentInit() {
        this._isSelected = this._stepper.steps.changes
            .pipe(switchMap(() => {
            return this._stepper.selectionChange.pipe(map((event) => event.selectedStep === this), startWith(this._stepper.selected === this));
        }))
            .subscribe((isSelected) => {
            if (isSelected && this._lazyContent && !this._portal) {
                this._portal = new TemplatePortal(this._lazyContent._template, this._viewContainerRef);
            }
        });
    }
    ngOnDestroy() {
        this._isSelected.unsubscribe();
    }
    /** Custom error state matcher that additionally checks for validity of interacted form. */
    isErrorState(control, form) {
        const originalErrorState = this._errorStateMatcher.isErrorState(control, form);
        // Custom error state checks for the validity of form that is not submitted or touched
        // since user can trigger a form change by calling for another step without directly
        // interacting with the current form.
        const customErrorState = !!(control && control.invalid && this.interacted);
        return originalErrorState || customErrorState;
    }
}
MatStep.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStep, deps: [{ token: forwardRef(() => MatStepper) }, { token: i1.ErrorStateMatcher, skipSelf: true }, { token: i0.ViewContainerRef }, { token: STEPPER_GLOBAL_OPTIONS, optional: true }], target: i0.ɵɵFactoryTarget.Component });
MatStep.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatStep, selector: "mat-step", inputs: { subLabel: "subLabel", color: "color" }, providers: [
        { provide: ErrorStateMatcher, useExisting: MatStep },
        { provide: CdkStep, useExisting: MatStep }
    ], queries: [{ propertyName: "stepLabel", first: true, predicate: MatStepLabel, descendants: true }, { propertyName: "stepSubLabel", first: true, predicate: MatStepSubLabel, descendants: true }, { propertyName: "_lazyContent", first: true, predicate: MatStepContent, descendants: true }], exportAs: ["matStep"], usesInheritance: true, ngImport: i0, template: "<ng-template>\n  <ng-content></ng-content>\n  <ng-template [cdkPortalOutlet]=\"_portal\"></ng-template>\n</ng-template>\n", directives: [{ type: i2$1.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStep, decorators: [{
            type: Component,
            args: [{ selector: 'mat-step', providers: [
                        { provide: ErrorStateMatcher, useExisting: MatStep },
                        { provide: CdkStep, useExisting: MatStep }
                    ], encapsulation: ViewEncapsulation.None, exportAs: 'matStep', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-template>\n  <ng-content></ng-content>\n  <ng-template [cdkPortalOutlet]=\"_portal\"></ng-template>\n</ng-template>\n" }]
        }], ctorParameters: function () {
        return [{ type: MatStepper, decorators: [{
                        type: Inject,
                        args: [forwardRef(() => MatStepper)]
                    }] }, { type: i1.ErrorStateMatcher, decorators: [{
                        type: SkipSelf
                    }] }, { type: i0.ViewContainerRef }, { type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [STEPPER_GLOBAL_OPTIONS]
                    }] }];
    }, propDecorators: { stepLabel: [{
                type: ContentChild,
                args: [MatStepLabel]
            }], stepSubLabel: [{
                type: ContentChild,
                args: [MatStepSubLabel]
            }], subLabel: [{
                type: Input
            }], color: [{
                type: Input
            }], _lazyContent: [{
                type: ContentChild,
                args: [MatStepContent, { static: false }]
            }] } });
/**
 * Proxies the public APIs from `MatStepper` to the deprecated `MatHorizontalStepper` and
 * `MatVerticalStepper`.
 * @deprecated Use `MatStepper` instead.
 * @breaking-change 13.0.0
 * @docs-private
 */
class _MatProxyStepperBase extends CdkStepper {
}
_MatProxyStepperBase.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: _MatProxyStepperBase, deps: null, target: i0.ɵɵFactoryTarget.Directive });
_MatProxyStepperBase.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: _MatProxyStepperBase, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: _MatProxyStepperBase, decorators: [{
            type: Directive
        }] });
/**
 * @deprecated Use `MatStepper` instead.
 * @breaking-change 13.0.0
 */
class MatHorizontalStepper extends _MatProxyStepperBase {
}
MatHorizontalStepper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHorizontalStepper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
MatHorizontalStepper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatHorizontalStepper, selector: "mat-horizontal-stepper", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatHorizontalStepper, decorators: [{
            type: Directive,
            args: [{ selector: 'mat-horizontal-stepper' }]
        }] });
/**
 * @deprecated Use `MatStepper` instead.
 * @breaking-change 13.0.0
 */
class MatVerticalStepper extends _MatProxyStepperBase {
}
MatVerticalStepper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatVerticalStepper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
MatVerticalStepper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatVerticalStepper, selector: "mat-vertical-stepper", usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatVerticalStepper, decorators: [{
            type: Directive,
            args: [{ selector: 'mat-vertical-stepper' }]
        }] });
class MatStepper extends CdkStepper {
    constructor(dir, changeDetectorRef, elementRef, _document) {
        super(dir, changeDetectorRef, elementRef, _document);
        /** Steps that belong to the current stepper, excluding ones from nested steppers. */
        this.steps = new QueryList();
        /** Event emitted when the current step is done transitioning in. */
        this.animationDone = new EventEmitter();
        /**
         * Whether the label should display in bottom or end position.
         * Only applies in the `horizontal` orientation.
         */
        this.labelPosition = 'end';
        /** Consumer-specified template-refs to be used to override the header icons. */
        this._iconOverrides = {};
        /** Stream of animation `done` events when the body expands/collapses. */
        this._animationDone = new Subject();
        const nodeName = elementRef.nativeElement.nodeName.toLowerCase();
        this.orientation =
            nodeName === 'mat-vertical-stepper' ? 'vertical' : 'horizontal';
    }
    ngAfterContentInit() {
        super.ngAfterContentInit();
        this._icons.forEach(({ name, templateRef }) => (this._iconOverrides[name] = templateRef));
        // Mark the component for change detection whenever the content children query changes
        this.steps.changes.pipe(takeUntil(this._destroyed)).subscribe(() => {
            this._stateChanged();
        });
        this._animationDone
            .pipe(
        // This needs a `distinctUntilChanged` in order to avoid emitting the same event twice due
        // to a bug in animations where the `.done` callback gets invoked twice on some browsers.
        // See https://github.com/angular/angular/issues/24084
        distinctUntilChanged((x, y) => x.fromState === y.fromState && x.toState === y.toState), takeUntil(this._destroyed))
            .subscribe((event) => {
            if (event.toState === 'current') {
                this.animationDone.emit();
            }
        });
    }
    _stepIsNavigable(index, step) {
        return step.completed || this.selectedIndex === index || !this.linear;
    }
}
MatStepper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepper, deps: [{ token: i3$1.Directionality, optional: true }, { token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component });
MatStepper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatStepper, selector: "mat-stepper, mat-vertical-stepper, mat-horizontal-stepper, [matStepper]", inputs: { selectedIndex: "selectedIndex", disableRipple: "disableRipple", color: "color", labelPosition: "labelPosition" }, outputs: { animationDone: "animationDone" }, host: { attributes: { "role": "tablist" }, properties: { "class.mat-stepper-horizontal": "orientation === \"horizontal\"", "class.mat-stepper-vertical": "orientation === \"vertical\"", "class.mat-stepper-label-position-end": "orientation === \"horizontal\" && labelPosition == \"end\"", "class.mat-stepper-label-position-bottom": "orientation === \"horizontal\" && labelPosition == \"bottom\"", "attr.aria-orientation": "orientation" } }, providers: [
        { provide: CdkStepper, useExisting: MatStepper },
        { provide: MatHorizontalStepper, useExisting: MatStepper },
        { provide: MatVerticalStepper, useExisting: MatStepper }
    ], queries: [{ propertyName: "_steps", predicate: MatStep, descendants: true }, { propertyName: "_icons", predicate: MatStepperIcon, descendants: true }], viewQueries: [{ propertyName: "_stepHeader", predicate: MatStepHeader, descendants: true }], exportAs: ["matStepper", "matVerticalStepper", "matHorizontalStepper"], usesInheritance: true, ngImport: i0, template: "<!-- eslint-disable @angular-eslint/template/eqeqeq -->\n<ng-container [ngSwitch]=\"orientation\">\n\n  <div #matActionBar\n       class=\"mat-stepper-action-bar-container\">\n    <ng-content select=\"mat-stepper-action-bar\"></ng-content>\n  </div>\n\n  <!-- Horizontal stepper -->\n  <ng-container *ngSwitchCase=\"'horizontal'\">\n    <div class=\"mat-horizontal-stepper-container\">\n      <div class=\"mat-horizontal-stepper-header-container\">\n        <ng-container *ngFor=\"let step of steps; let i = index; let isLast = last\">\n          <ng-container [ngTemplateOutlet]=\"stepTemplate\"\n                        [ngTemplateOutletContext]=\"{step: step, i: i}\"></ng-container>\n          <div *ngIf=\"!isLast\"\n               class=\"mat-stepper-horizontal-line\"></div>\n        </ng-container>\n      </div>\n\n      <div class=\"mat-horizontal-content-container\">\n        <div *ngFor=\"let step of steps; let i = index\"\n             class=\"mat-horizontal-stepper-content\"\n             role=\"tabpanel\"\n             [@horizontalStepTransition]=\"_getAnimationDirection(i)\"\n             (@horizontalStepTransition.done)=\"_animationDone.next($event)\"\n             [id]=\"_getStepContentId(i)\"\n             [attr.aria-labelledby]=\"_getStepLabelId(i)\"\n             [attr.aria-expanded]=\"selectedIndex === i\">\n          <ng-container [ngTemplateOutlet]=\"step.content\"></ng-container>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n\n  <!-- Vertical stepper -->\n  <ng-container *ngSwitchCase=\"'vertical'\">\n    <div class=\"mat-vertical-stepper-container\">\n      <div class=\"mat-vertical-stepper-header-container\"\n           cdkScrollable>\n        <div class=\"mat-step\"\n             *ngFor=\"let step of steps; let i = index; let isLast = last\">\n          <ng-container [ngTemplateOutlet]=\"stepTemplate\"\n                        [ngTemplateOutletContext]=\"{step: step, i: i}\"></ng-container>\n          <div class=\"mat-vertical-content-container\"\n               [class.mat-stepper-vertical-line]=\"!isLast\"></div>\n        </div>\n      </div>\n\n      <div class=\"mat-vertical-content-container\">\n        <div class=\"mat-vertical-stepper-content\"\n             *ngFor=\"let step of steps; let i = index\"\n             role=\"tabpanel\"\n             [@verticalStepTransition]=\"_getAnimationDirection(i)\"\n             (@verticalStepTransition.done)=\"_animationDone.next($event)\"\n             [id]=\"_getStepContentId(i)\"\n             [attr.aria-labelledby]=\"_getStepLabelId(i)\"\n             [attr.aria-expanded]=\"selectedIndex === i\">\n          <div class=\"mat-vertical-content\">\n            <ng-container [ngTemplateOutlet]=\"step.content\"></ng-container>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n\n</ng-container>\n\n<!-- Common step templating -->\n<ng-template let-step=\"step\"\n             let-i=\"i\"\n             #stepTemplate>\n  <mat-step-header [class.mat-horizontal-stepper-header]=\"orientation === 'horizontal'\"\n                   [class.mat-vertical-stepper-header]=\"orientation === 'vertical'\"\n                   (click)=\"step.select()\"\n                   (keydown)=\"_onKeydown($event)\"\n                   [tabIndex]=\"_getFocusIndex() === i ? 0 : -1\"\n                   [id]=\"_getStepLabelId(i)\"\n                   [attr.aria-posinset]=\"i + 1\"\n                   [attr.aria-setsize]=\"steps.length\"\n                   [attr.aria-controls]=\"_getStepContentId(i)\"\n                   [attr.aria-selected]=\"selectedIndex == i\"\n                   [attr.aria-label]=\"step.ariaLabel || null\"\n                   [attr.aria-labelledby]=\"(!step.ariaLabel && step.ariaLabelledby) ? step.ariaLabelledby : null\"\n                   [attr.aria-disabled]=\"_stepIsNavigable(i, step) ? null : true\"\n                   [index]=\"i\"\n                   [state]=\"_getIndicatorType(i, step.state)\"\n                   [label]=\"step.stepLabel || step.label\"\n                   [subLabel]=\"step.stepSubLabel || step.subLabel\"\n                   [selected]=\"selectedIndex === i\"\n                   [active]=\"_stepIsNavigable(i, step)\"\n                   [optional]=\"step.optional\"\n                   [errorMessage]=\"step.errorMessage\"\n                   [iconOverrides]=\"_iconOverrides\"\n                   [disableRipple]=\"disableRipple || !_stepIsNavigable(i, step)\"\n                   [color]=\"step.color || color\"></mat-step-header>\n</ng-template>", styles: [".mat-stepper-vertical,.mat-stepper-horizontal{display:flex;flex-direction:column-reverse}.mat-horizontal-stepper-header-container{white-space:nowrap;display:flex;align-items:center}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header-container{align-items:flex-start}.mat-stepper-horizontal-line{border-top-width:1px;border-top-style:solid;flex:auto;height:0;margin:0 -7px;min-width:23px}.mat-stepper-label-position-bottom .mat-stepper-horizontal-line{margin:0;min-width:0;position:relative}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before,.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{border-top-width:1px;border-top-style:solid;content:\"\";display:inline-block;height:0;position:absolute;width:calc(50% - 15.5px)}.mat-horizontal-stepper-header{display:flex;height:72px;overflow:hidden;align-items:center;padding:0 15px}.mat-horizontal-stepper-header .mat-step-icon{margin-right:8px;flex:none}[dir=rtl] .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:8px}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header{box-sizing:border-box;flex-direction:column;height:auto}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{right:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before{left:0}[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:last-child:before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:first-child:after{display:none}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-label{padding:16px 0 0;text-align:center;width:100%}.mat-horizontal-stepper-container{flex:1 1 auto;flex-direction:column}.mat-horizontal-stepper-container,.mat-vertical-stepper-container{display:flex;height:100%}.mat-stepper-action-bar-container~.mat-horizontal-stepper-container,.mat-stepper-action-bar-container~.mat-vertical-stepper-container{height:calc(100% - 56px)}.mat-vertical-stepper-container{align-items:stretch}.mat-vertical-stepper-header{display:flex;align-items:center;height:24px}.mat-vertical-stepper-header .mat-step-icon{margin-right:21px}[dir=rtl] .mat-vertical-stepper-header .mat-step-icon{margin-right:0;margin-left:21px}.mat-horizontal-stepper-content,.mat-vertical-stepper-content{outline:0}.mat-horizontal-stepper-content[aria-expanded=false],.mat-vertical-stepper-content[aria-expanded=false]{height:0;overflow:hidden}.mat-horizontal-stepper-header-container+.mat-horizontal-content-container{border-top-width:1px;border-top-style:solid}.mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left:unset;border-right-width:1px;border-right-style:solid}.mat-horizontal-content-container{flex:1 1 auto;overflow-x:hidden;overflow-y:auto;padding:0 15px 15px}.cdk-high-contrast-active .mat-horizontal-content-container{outline:solid 1px}.mat-vertical-content-container{margin-left:36px;border:0;position:relative;flex:1 1 auto;width:100%;overflow-x:hidden;overflow-y:auto}.cdk-high-contrast-active .mat-vertical-content-container{outline:solid 1px}[dir=rtl] .mat-vertical-content-container{margin-left:0;margin-right:36px}.mat-stepper-vertical-line:before{content:\"\";position:absolute;left:0;border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-stepper-vertical-line:before{left:auto;right:0}.mat-vertical-stepper-content{outline:0}.mat-vertical-content{padding:0 15px 15px}.mat-step:last-child .mat-vertical-content-container{border:none}\n"], components: [{ type: MatStepHeader, selector: "mat-step-header", inputs: ["color", "state", "label", "subLabel", "errorMessage", "iconOverrides", "index", "selected", "active", "optional", "disableRipple"] }], directives: [{ type: i5.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i5.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [
        matStepperAnimations.horizontalStepTransition,
        matStepperAnimations.verticalStepTransition
    ], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepper, decorators: [{
            type: Component,
            args: [{ selector: 'mat-stepper, mat-vertical-stepper, mat-horizontal-stepper, [matStepper]', exportAs: 'matStepper, matVerticalStepper, matHorizontalStepper', inputs: ['selectedIndex'], host: {
                        '[class.mat-stepper-horizontal]': 'orientation === "horizontal"',
                        '[class.mat-stepper-vertical]': 'orientation === "vertical"',
                        '[class.mat-stepper-label-position-end]': 'orientation === "horizontal" && labelPosition == "end"',
                        '[class.mat-stepper-label-position-bottom]': 'orientation === "horizontal" && labelPosition == "bottom"',
                        '[attr.aria-orientation]': 'orientation',
                        role: 'tablist'
                    }, animations: [
                        matStepperAnimations.horizontalStepTransition,
                        matStepperAnimations.verticalStepTransition
                    ], providers: [
                        { provide: CdkStepper, useExisting: MatStepper },
                        { provide: MatHorizontalStepper, useExisting: MatStepper },
                        { provide: MatVerticalStepper, useExisting: MatStepper }
                    ], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<!-- eslint-disable @angular-eslint/template/eqeqeq -->\n<ng-container [ngSwitch]=\"orientation\">\n\n  <div #matActionBar\n       class=\"mat-stepper-action-bar-container\">\n    <ng-content select=\"mat-stepper-action-bar\"></ng-content>\n  </div>\n\n  <!-- Horizontal stepper -->\n  <ng-container *ngSwitchCase=\"'horizontal'\">\n    <div class=\"mat-horizontal-stepper-container\">\n      <div class=\"mat-horizontal-stepper-header-container\">\n        <ng-container *ngFor=\"let step of steps; let i = index; let isLast = last\">\n          <ng-container [ngTemplateOutlet]=\"stepTemplate\"\n                        [ngTemplateOutletContext]=\"{step: step, i: i}\"></ng-container>\n          <div *ngIf=\"!isLast\"\n               class=\"mat-stepper-horizontal-line\"></div>\n        </ng-container>\n      </div>\n\n      <div class=\"mat-horizontal-content-container\">\n        <div *ngFor=\"let step of steps; let i = index\"\n             class=\"mat-horizontal-stepper-content\"\n             role=\"tabpanel\"\n             [@horizontalStepTransition]=\"_getAnimationDirection(i)\"\n             (@horizontalStepTransition.done)=\"_animationDone.next($event)\"\n             [id]=\"_getStepContentId(i)\"\n             [attr.aria-labelledby]=\"_getStepLabelId(i)\"\n             [attr.aria-expanded]=\"selectedIndex === i\">\n          <ng-container [ngTemplateOutlet]=\"step.content\"></ng-container>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n\n  <!-- Vertical stepper -->\n  <ng-container *ngSwitchCase=\"'vertical'\">\n    <div class=\"mat-vertical-stepper-container\">\n      <div class=\"mat-vertical-stepper-header-container\"\n           cdkScrollable>\n        <div class=\"mat-step\"\n             *ngFor=\"let step of steps; let i = index; let isLast = last\">\n          <ng-container [ngTemplateOutlet]=\"stepTemplate\"\n                        [ngTemplateOutletContext]=\"{step: step, i: i}\"></ng-container>\n          <div class=\"mat-vertical-content-container\"\n               [class.mat-stepper-vertical-line]=\"!isLast\"></div>\n        </div>\n      </div>\n\n      <div class=\"mat-vertical-content-container\">\n        <div class=\"mat-vertical-stepper-content\"\n             *ngFor=\"let step of steps; let i = index\"\n             role=\"tabpanel\"\n             [@verticalStepTransition]=\"_getAnimationDirection(i)\"\n             (@verticalStepTransition.done)=\"_animationDone.next($event)\"\n             [id]=\"_getStepContentId(i)\"\n             [attr.aria-labelledby]=\"_getStepLabelId(i)\"\n             [attr.aria-expanded]=\"selectedIndex === i\">\n          <div class=\"mat-vertical-content\">\n            <ng-container [ngTemplateOutlet]=\"step.content\"></ng-container>\n          </div>\n        </div>\n      </div>\n    </div>\n  </ng-container>\n\n</ng-container>\n\n<!-- Common step templating -->\n<ng-template let-step=\"step\"\n             let-i=\"i\"\n             #stepTemplate>\n  <mat-step-header [class.mat-horizontal-stepper-header]=\"orientation === 'horizontal'\"\n                   [class.mat-vertical-stepper-header]=\"orientation === 'vertical'\"\n                   (click)=\"step.select()\"\n                   (keydown)=\"_onKeydown($event)\"\n                   [tabIndex]=\"_getFocusIndex() === i ? 0 : -1\"\n                   [id]=\"_getStepLabelId(i)\"\n                   [attr.aria-posinset]=\"i + 1\"\n                   [attr.aria-setsize]=\"steps.length\"\n                   [attr.aria-controls]=\"_getStepContentId(i)\"\n                   [attr.aria-selected]=\"selectedIndex == i\"\n                   [attr.aria-label]=\"step.ariaLabel || null\"\n                   [attr.aria-labelledby]=\"(!step.ariaLabel && step.ariaLabelledby) ? step.ariaLabelledby : null\"\n                   [attr.aria-disabled]=\"_stepIsNavigable(i, step) ? null : true\"\n                   [index]=\"i\"\n                   [state]=\"_getIndicatorType(i, step.state)\"\n                   [label]=\"step.stepLabel || step.label\"\n                   [subLabel]=\"step.stepSubLabel || step.subLabel\"\n                   [selected]=\"selectedIndex === i\"\n                   [active]=\"_stepIsNavigable(i, step)\"\n                   [optional]=\"step.optional\"\n                   [errorMessage]=\"step.errorMessage\"\n                   [iconOverrides]=\"_iconOverrides\"\n                   [disableRipple]=\"disableRipple || !_stepIsNavigable(i, step)\"\n                   [color]=\"step.color || color\"></mat-step-header>\n</ng-template>", styles: [".mat-stepper-vertical,.mat-stepper-horizontal{display:flex;flex-direction:column-reverse}.mat-horizontal-stepper-header-container{white-space:nowrap;display:flex;align-items:center}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header-container{align-items:flex-start}.mat-stepper-horizontal-line{border-top-width:1px;border-top-style:solid;flex:auto;height:0;margin:0 -7px;min-width:23px}.mat-stepper-label-position-bottom .mat-stepper-horizontal-line{margin:0;min-width:0;position:relative}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before,.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{border-top-width:1px;border-top-style:solid;content:\"\";display:inline-block;height:0;position:absolute;width:calc(50% - 15.5px)}.mat-horizontal-stepper-header{display:flex;height:72px;overflow:hidden;align-items:center;padding:0 15px}.mat-horizontal-stepper-header .mat-step-icon{margin-right:8px;flex:none}[dir=rtl] .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:8px}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header{box-sizing:border-box;flex-direction:column;height:auto}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{right:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before{left:0}[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:last-child:before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:first-child:after{display:none}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-label{padding:16px 0 0;text-align:center;width:100%}.mat-horizontal-stepper-container{flex:1 1 auto;flex-direction:column}.mat-horizontal-stepper-container,.mat-vertical-stepper-container{display:flex;height:100%}.mat-stepper-action-bar-container~.mat-horizontal-stepper-container,.mat-stepper-action-bar-container~.mat-vertical-stepper-container{height:calc(100% - 56px)}.mat-vertical-stepper-container{align-items:stretch}.mat-vertical-stepper-header{display:flex;align-items:center;height:24px}.mat-vertical-stepper-header .mat-step-icon{margin-right:21px}[dir=rtl] .mat-vertical-stepper-header .mat-step-icon{margin-right:0;margin-left:21px}.mat-horizontal-stepper-content,.mat-vertical-stepper-content{outline:0}.mat-horizontal-stepper-content[aria-expanded=false],.mat-vertical-stepper-content[aria-expanded=false]{height:0;overflow:hidden}.mat-horizontal-stepper-header-container+.mat-horizontal-content-container{border-top-width:1px;border-top-style:solid}.mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left:unset;border-right-width:1px;border-right-style:solid}.mat-horizontal-content-container{flex:1 1 auto;overflow-x:hidden;overflow-y:auto;padding:0 15px 15px}.cdk-high-contrast-active .mat-horizontal-content-container{outline:solid 1px}.mat-vertical-content-container{margin-left:36px;border:0;position:relative;flex:1 1 auto;width:100%;overflow-x:hidden;overflow-y:auto}.cdk-high-contrast-active .mat-vertical-content-container{outline:solid 1px}[dir=rtl] .mat-vertical-content-container{margin-left:0;margin-right:36px}.mat-stepper-vertical-line:before{content:\"\";position:absolute;left:0;border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-stepper-vertical-line:before{left:auto;right:0}.mat-vertical-stepper-content{outline:0}.mat-vertical-content{padding:0 15px 15px}.mat-step:last-child .mat-vertical-content-container{border:none}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i3$1.Directionality, decorators: [{
                        type: Optional
                    }] }, { type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }];
    }, propDecorators: { _stepHeader: [{
                type: ViewChildren,
                args: [MatStepHeader]
            }], _steps: [{
                type: ContentChildren,
                args: [MatStep, { descendants: true }]
            }], _icons: [{
                type: ContentChildren,
                args: [MatStepperIcon, { descendants: true }]
            }], animationDone: [{
                type: Output
            }], disableRipple: [{
                type: Input
            }], color: [{
                type: Input
            }], labelPosition: [{
                type: Input
            }] } });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Button bar used in Stepper to contain action buttons */
class MatStepperActionBar {
}
MatStepperActionBar.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperActionBar, deps: [], target: i0.ɵɵFactoryTarget.Component });
MatStepperActionBar.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperActionBar, selector: "mat-stepper-action-bar", host: { classAttribute: "mat-stepper-action-bar" }, exportAs: ["matStepperActionBar"], ngImport: i0, template: "<mat-button-bar class=\"mat-stepper-actions\">\n  <ng-content select=\"[mat-stepper-reset]\"></ng-content>\n  <ng-content select=\"[mat-stepper-cancel]\"></ng-content>\n  <ng-content select=\"[mat-stepper-close]\"></ng-content>\n  <ng-content select=\"[mat-stepper-previous], [matStepperPrevious]\"></ng-content>\n  <ng-content select=\"[mat-stepper-next], [matStepperNext]\"></ng-content>\n</mat-button-bar>", styles: [".mat-stepper-vertical,.mat-stepper-horizontal{display:flex;flex-direction:column-reverse}.mat-horizontal-stepper-header-container{white-space:nowrap;display:flex;align-items:center}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header-container{align-items:flex-start}.mat-stepper-horizontal-line{border-top-width:1px;border-top-style:solid;flex:auto;height:0;margin:0 -7px;min-width:23px}.mat-stepper-label-position-bottom .mat-stepper-horizontal-line{margin:0;min-width:0;position:relative}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before,.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{border-top-width:1px;border-top-style:solid;content:\"\";display:inline-block;height:0;position:absolute;width:calc(50% - 15.5px)}.mat-horizontal-stepper-header{display:flex;height:72px;overflow:hidden;align-items:center;padding:0 15px}.mat-horizontal-stepper-header .mat-step-icon{margin-right:8px;flex:none}[dir=rtl] .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:8px}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header{box-sizing:border-box;flex-direction:column;height:auto}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{right:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before{left:0}[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:last-child:before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:first-child:after{display:none}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-label{padding:16px 0 0;text-align:center;width:100%}.mat-horizontal-stepper-container{flex:1 1 auto;flex-direction:column}.mat-horizontal-stepper-container,.mat-vertical-stepper-container{display:flex;height:100%}.mat-stepper-action-bar-container~.mat-horizontal-stepper-container,.mat-stepper-action-bar-container~.mat-vertical-stepper-container{height:calc(100% - 56px)}.mat-vertical-stepper-container{align-items:stretch}.mat-vertical-stepper-header{display:flex;align-items:center;height:24px}.mat-vertical-stepper-header .mat-step-icon{margin-right:21px}[dir=rtl] .mat-vertical-stepper-header .mat-step-icon{margin-right:0;margin-left:21px}.mat-horizontal-stepper-content,.mat-vertical-stepper-content{outline:0}.mat-horizontal-stepper-content[aria-expanded=false],.mat-vertical-stepper-content[aria-expanded=false]{height:0;overflow:hidden}.mat-horizontal-stepper-header-container+.mat-horizontal-content-container{border-top-width:1px;border-top-style:solid}.mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left:unset;border-right-width:1px;border-right-style:solid}.mat-horizontal-content-container{flex:1 1 auto;overflow-x:hidden;overflow-y:auto;padding:0 15px 15px}.cdk-high-contrast-active .mat-horizontal-content-container{outline:solid 1px}.mat-vertical-content-container{margin-left:36px;border:0;position:relative;flex:1 1 auto;width:100%;overflow-x:hidden;overflow-y:auto}.cdk-high-contrast-active .mat-vertical-content-container{outline:solid 1px}[dir=rtl] .mat-vertical-content-container{margin-left:0;margin-right:36px}.mat-stepper-vertical-line:before{content:\"\";position:absolute;left:0;border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-stepper-vertical-line:before{left:auto;right:0}.mat-vertical-stepper-content{outline:0}.mat-vertical-content{padding:0 15px 15px}.mat-step:last-child .mat-vertical-content-container{border:none}\n"], components: [{ type: i1$1.MatButtonBar, selector: "mat-button-bar" }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperActionBar, decorators: [{
            type: Component,
            args: [{ selector: 'mat-stepper-action-bar', exportAs: 'matStepperActionBar', host: {
                        class: 'mat-stepper-action-bar'
                    }, encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-button-bar class=\"mat-stepper-actions\">\n  <ng-content select=\"[mat-stepper-reset]\"></ng-content>\n  <ng-content select=\"[mat-stepper-cancel]\"></ng-content>\n  <ng-content select=\"[mat-stepper-close]\"></ng-content>\n  <ng-content select=\"[mat-stepper-previous], [matStepperPrevious]\"></ng-content>\n  <ng-content select=\"[mat-stepper-next], [matStepperNext]\"></ng-content>\n</mat-button-bar>", styles: [".mat-stepper-vertical,.mat-stepper-horizontal{display:flex;flex-direction:column-reverse}.mat-horizontal-stepper-header-container{white-space:nowrap;display:flex;align-items:center}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header-container{align-items:flex-start}.mat-stepper-horizontal-line{border-top-width:1px;border-top-style:solid;flex:auto;height:0;margin:0 -7px;min-width:23px}.mat-stepper-label-position-bottom .mat-stepper-horizontal-line{margin:0;min-width:0;position:relative}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before,.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{border-top-width:1px;border-top-style:solid;content:\"\";display:inline-block;height:0;position:absolute;width:calc(50% - 15.5px)}.mat-horizontal-stepper-header{display:flex;height:72px;overflow:hidden;align-items:center;padding:0 15px}.mat-horizontal-stepper-header .mat-step-icon{margin-right:8px;flex:none}[dir=rtl] .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:8px}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header{box-sizing:border-box;flex-direction:column;height:auto}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):after,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):after{right:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:first-child):before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:not(:last-child):before{left:0}[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:last-child:before,[dir=rtl] .mat-stepper-label-position-bottom .mat-horizontal-stepper-header:first-child:after{display:none}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-icon{margin-right:0;margin-left:0}.mat-stepper-label-position-bottom .mat-horizontal-stepper-header .mat-step-label{padding:16px 0 0;text-align:center;width:100%}.mat-horizontal-stepper-container{flex:1 1 auto;flex-direction:column}.mat-horizontal-stepper-container,.mat-vertical-stepper-container{display:flex;height:100%}.mat-stepper-action-bar-container~.mat-horizontal-stepper-container,.mat-stepper-action-bar-container~.mat-vertical-stepper-container{height:calc(100% - 56px)}.mat-vertical-stepper-container{align-items:stretch}.mat-vertical-stepper-header{display:flex;align-items:center;height:24px}.mat-vertical-stepper-header .mat-step-icon{margin-right:21px}[dir=rtl] .mat-vertical-stepper-header .mat-step-icon{margin-right:0;margin-left:21px}.mat-horizontal-stepper-content,.mat-vertical-stepper-content{outline:0}.mat-horizontal-stepper-content[aria-expanded=false],.mat-vertical-stepper-content[aria-expanded=false]{height:0;overflow:hidden}.mat-horizontal-stepper-header-container+.mat-horizontal-content-container{border-top-width:1px;border-top-style:solid}.mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-vertical-stepper-header-container+.mat-vertical-content-container{border-left:unset;border-right-width:1px;border-right-style:solid}.mat-horizontal-content-container{flex:1 1 auto;overflow-x:hidden;overflow-y:auto;padding:0 15px 15px}.cdk-high-contrast-active .mat-horizontal-content-container{outline:solid 1px}.mat-vertical-content-container{margin-left:36px;border:0;position:relative;flex:1 1 auto;width:100%;overflow-x:hidden;overflow-y:auto}.cdk-high-contrast-active .mat-vertical-content-container{outline:solid 1px}[dir=rtl] .mat-vertical-content-container{margin-left:0;margin-right:36px}.mat-stepper-vertical-line:before{content:\"\";position:absolute;left:0;border-left-width:1px;border-left-style:solid}[dir=rtl] .mat-stepper-vertical-line:before{left:auto;right:0}.mat-vertical-stepper-content{outline:0}.mat-vertical-content{padding:0 15px 15px}.mat-step:last-child .mat-vertical-content-container{border:none}\n"] }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Button that moves to the next step in a stepper workflow. */
class MatStepperNext extends CdkStepperNext {
}
MatStepperNext.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperNext, deps: null, target: i0.ɵɵFactoryTarget.Directive });
MatStepperNext.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperNext, selector: "button[matStepperNext]", inputs: { type: "type" }, host: { properties: { "type": "type" }, classAttribute: "mat-stepper-next" }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperNext, decorators: [{
            type: Directive,
            args: [{
                    selector: 'button[matStepperNext]',
                    host: {
                        class: 'mat-stepper-next',
                        '[type]': 'type'
                    },
                    inputs: ['type']
                }]
        }] });
/** Button that moves to the previous step in a stepper workflow. */
class MatStepperPrevious extends CdkStepperPrevious {
}
MatStepperPrevious.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperPrevious, deps: null, target: i0.ɵɵFactoryTarget.Directive });
MatStepperPrevious.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperPrevious, selector: "button[matStepperPrevious]", inputs: { type: "type" }, host: { properties: { "type": "type" }, classAttribute: "mat-stepper-previous" }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperPrevious, decorators: [{
            type: Directive,
            args: [{
                    selector: 'button[matStepperPrevious]',
                    host: {
                        class: 'mat-stepper-previous',
                        '[type]': 'type'
                    },
                    inputs: ['type']
                }]
        }] });
// VDL Change: Adds directives for other button definitions which add classes and
// used for ordering within the stepper action bar
/**
 * Next Stepper button used for ordering within stepper action bar.
 * This is a styled button only, use `[matStepperNext]` if looking for built in next action
 */
class MatStepperNextButton {
}
MatStepperNextButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperNextButton, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatStepperNextButton.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperNextButton, selector: "button[mat-stepper-next]", host: { classAttribute: "mat-stepper-next" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperNextButton, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'button[mat-stepper-next]',
                    host: {
                        class: 'mat-stepper-next'
                    }
                }]
        }] });
/**
 * Previous Stepper button used for ordering within stepper action bar.
 * This is a styled button only, use `[matStepperPrevious]` if looking for built in previous action
 */
class MatStepperPreviousButton {
}
MatStepperPreviousButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperPreviousButton, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatStepperPreviousButton.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperPreviousButton, selector: "button[mat-stepper-previous]", host: { classAttribute: "mat-stepper-previous" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperPreviousButton, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'button[mat-stepper-previous]',
                    host: {
                        class: 'mat-stepper-previous'
                    }
                }]
        }] });
/** Reset Stepper button used for ordering within stepper action bar */
class MatStepperResetButton {
}
MatStepperResetButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperResetButton, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatStepperResetButton.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperResetButton, selector: "button[mat-stepper-reset]", host: { classAttribute: "mat-stepper-reset" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperResetButton, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'button[mat-stepper-reset]',
                    host: {
                        class: 'mat-stepper-reset'
                    }
                }]
        }] });
/** Close Stepper button used for ordering within stepper action bar */
class MatStepperCloseButton {
}
MatStepperCloseButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperCloseButton, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatStepperCloseButton.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperCloseButton, selector: "button[mat-stepper-close]", host: { classAttribute: "mat-stepper-close" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperCloseButton, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'button[mat-stepper-close]',
                    host: {
                        class: 'mat-stepper-close'
                    }
                }]
        }] });
/** Cancel Stepper button used for ordering within stepper action bar */
class MatStepperCancelButton {
}
MatStepperCancelButton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperCancelButton, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MatStepperCancelButton.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.11", type: MatStepperCancelButton, selector: "button[mat-stepper-cancel]", host: { classAttribute: "mat-stepper-cancel" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperCancelButton, decorators: [{
            type: Directive,
            args: [{
                    // eslint-disable-next-line @angular-eslint/directive-selector
                    selector: 'button[mat-stepper-cancel]',
                    host: {
                        class: 'mat-stepper-cancel'
                    }
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
class MatStepperModule {
}
MatStepperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MatStepperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperModule, declarations: [MatHorizontalStepper,
        MatVerticalStepper,
        MatStep,
        MatStepLabel,
        MatStepSubLabel,
        MatStepper,
        MatStepperNext,
        MatStepperPrevious,
        MatStepHeader,
        MatStepperIcon,
        MatStepContent,
        MatStepperActionBar,
        MatStepperNextButton,
        MatStepperPreviousButton,
        MatStepperResetButton,
        MatStepperCloseButton,
        MatStepperCancelButton], imports: [MatCommonModule,
        CommonModule,
        PortalModule,
        MatButtonModule,
        CdkStepperModule,
        MatIconModule,
        MatRippleModule], exports: [MatCommonModule,
        MatStep,
        MatStepLabel,
        MatStepSubLabel,
        MatStepper,
        MatStepperNext,
        MatStepperPrevious,
        MatStepHeader,
        MatStepperIcon,
        MatStepContent,
        MatStepperActionBar,
        MatStepperNextButton,
        MatStepperPreviousButton,
        MatStepperResetButton,
        MatStepperCloseButton,
        MatStepperCancelButton] });
MatStepperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperModule, providers: [MAT_STEPPER_INTL_PROVIDER, ErrorStateMatcher], imports: [[
            MatCommonModule,
            CommonModule,
            PortalModule,
            MatButtonModule,
            CdkStepperModule,
            MatIconModule,
            MatRippleModule
        ], MatCommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.11", ngImport: i0, type: MatStepperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        MatCommonModule,
                        CommonModule,
                        PortalModule,
                        MatButtonModule,
                        CdkStepperModule,
                        MatIconModule,
                        MatRippleModule
                    ],
                    exports: [
                        MatCommonModule,
                        MatStep,
                        MatStepLabel,
                        MatStepSubLabel,
                        MatStepper,
                        MatStepperNext,
                        MatStepperPrevious,
                        MatStepHeader,
                        MatStepperIcon,
                        MatStepContent,
                        MatStepperActionBar,
                        MatStepperNextButton,
                        MatStepperPreviousButton,
                        MatStepperResetButton,
                        MatStepperCloseButton,
                        MatStepperCancelButton
                    ],
                    declarations: [
                        MatHorizontalStepper,
                        MatVerticalStepper,
                        MatStep,
                        MatStepLabel,
                        MatStepSubLabel,
                        MatStepper,
                        MatStepperNext,
                        MatStepperPrevious,
                        MatStepHeader,
                        MatStepperIcon,
                        MatStepContent,
                        MatStepperActionBar,
                        MatStepperNextButton,
                        MatStepperPreviousButton,
                        MatStepperResetButton,
                        MatStepperCloseButton,
                        MatStepperCancelButton
                    ],
                    providers: [MAT_STEPPER_INTL_PROVIDER, ErrorStateMatcher]
                }]
        }] });

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MAT_STEPPER_INTL_PROVIDER, MAT_STEPPER_INTL_PROVIDER_FACTORY, MatHorizontalStepper, MatStep, MatStepContent, MatStepHeader, MatStepLabel, MatStepSubLabel, MatStepper, MatStepperActionBar, MatStepperCancelButton, MatStepperCloseButton, MatStepperIcon, MatStepperIntl, MatStepperModule, MatStepperNext, MatStepperNextButton, MatStepperPrevious, MatStepperPreviousButton, MatStepperResetButton, MatVerticalStepper, matStepperAnimations };
//# sourceMappingURL=vdlx-vdl-angular-mat-stepper.mjs.map
