/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
import { CdkStepperNext, CdkStepperPrevious } from '@angular/cdk/stepper';
import * as i0 from "@angular/core";
/** Button that moves to the next step in a stepper workflow. */
export declare class MatStepperNext extends CdkStepperNext {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperNext, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperNext, "button[matStepperNext]", never, { "type": "type"; }, {}, never>;
}
/** Button that moves to the previous step in a stepper workflow. */
export declare class MatStepperPrevious extends CdkStepperPrevious {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperPrevious, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperPrevious, "button[matStepperPrevious]", never, { "type": "type"; }, {}, never>;
}
/**
 * Next Stepper button used for ordering within stepper action bar.
 * This is a styled button only, use `[matStepperNext]` if looking for built in next action
 */
export declare class MatStepperNextButton {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperNextButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperNextButton, "button[mat-stepper-next]", never, {}, {}, never>;
}
/**
 * Previous Stepper button used for ordering within stepper action bar.
 * This is a styled button only, use `[matStepperPrevious]` if looking for built in previous action
 */
export declare class MatStepperPreviousButton {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperPreviousButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperPreviousButton, "button[mat-stepper-previous]", never, {}, {}, never>;
}
/** Reset Stepper button used for ordering within stepper action bar */
export declare class MatStepperResetButton {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperResetButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperResetButton, "button[mat-stepper-reset]", never, {}, {}, never>;
}
/** Close Stepper button used for ordering within stepper action bar */
export declare class MatStepperCloseButton {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperCloseButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperCloseButton, "button[mat-stepper-close]", never, {}, {}, never>;
}
/** Cancel Stepper button used for ordering within stepper action bar */
export declare class MatStepperCancelButton {
    static ɵfac: i0.ɵɵFactoryDeclaration<MatStepperCancelButton, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatStepperCancelButton, "button[mat-stepper-cancel]", never, {}, {}, never>;
}
