import * as i1$1 from '@angular/cdk/drag-drop';
import { DragDropModule } from '@angular/cdk/drag-drop';
import * as i6 from '@angular/cdk/observers';
import { ObserversModule } from '@angular/cdk/observers';
import * as i1$2 from '@angular/cdk/scrolling';
import { CdkScrollable, CdkScrollableModule } from '@angular/cdk/scrolling';
import * as i1 from '@angular/cdk/table';
import { CdkCellDef, CdkHeaderCellDef, CdkFooterCellDef, CdkColumnDef, CdkHeaderCell, CdkFooterCell, CdkCell, CdkTable, CDK_TABLE, _COALESCED_STYLE_SCHEDULER, _CoalescedStyleScheduler, STICKY_POSITIONING_LISTENER, CDK_TABLE_TEMPLATE, CdkHeaderRowDef, CdkFooterRowDef, CdkRowDef, CdkHeaderRow, CDK_ROW_TEMPLATE, CdkFooterRow, CdkRow, CdkNoDataRow, CdkTextColumn, CdkTableModule, DataSource } from '@angular/cdk/table';
import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Directive, Input, Injectable, Optional, SkipSelf, EventEmitter, Component, Output, ViewEncapsulation, ChangeDetectionStrategy, ViewChild, ContentChildren, NgModule } from '@angular/core';
import * as i3 from '@vdlx/vdl-angular/mat/button';
import { MatButtonModule } from '@vdlx/vdl-angular/mat/button';
import { MatCommonModule } from '@vdlx/vdl-angular/mat/core';
import * as i2 from '@vdlx/vdl-angular/mat/icon';
import { MatIconModule } from '@vdlx/vdl-angular/mat/icon';
import { coerceBooleanProperty, coerceNumberProperty, _isNumberValue } from '@angular/cdk/coercion';
import { Subject, Subscription, BehaviorSubject, merge, of, combineLatest } from 'rxjs';
import { trigger, state, style, transition, animate } from '@angular/animations';
import * as i3$1 from '@angular/cdk/bidi';
import { takeUntil, map } from 'rxjs/operators';
import { _VIEW_REPEATER_STRATEGY, _RecycleViewRepeaterStrategy, _DisposeViewRepeaterStrategy } from '@angular/cdk/collections';

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Cell definition for the mat-table.
 * Captures the template of a column's data row cell as well as cell-specific properties.
 */
class MatCellDef extends CdkCellDef {
}
MatCellDef.ɵfac = /*@__PURE__*/ function () { let ɵMatCellDef_BaseFactory; return function MatCellDef_Factory(t) { return (ɵMatCellDef_BaseFactory || (ɵMatCellDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatCellDef)))(t || MatCellDef); }; }();
MatCellDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatCellDef, selectors: [["", "matCellDef", ""]], features: [i0.ɵɵProvidersFeature([{ provide: CdkCellDef, useExisting: MatCellDef }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatCellDef, [{
        type: Directive,
        args: [{
                selector: '[matCellDef]',
                providers: [{ provide: CdkCellDef, useExisting: MatCellDef }]
            }]
    }], null, null); })();
/**
 * Header cell definition for the mat-table.
 * Captures the template of a column's header cell and as well as cell-specific properties.
 */
class MatHeaderCellDef extends CdkHeaderCellDef {
}
MatHeaderCellDef.ɵfac = /*@__PURE__*/ function () { let ɵMatHeaderCellDef_BaseFactory; return function MatHeaderCellDef_Factory(t) { return (ɵMatHeaderCellDef_BaseFactory || (ɵMatHeaderCellDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatHeaderCellDef)))(t || MatHeaderCellDef); }; }();
MatHeaderCellDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatHeaderCellDef, selectors: [["", "matHeaderCellDef", ""]], features: [i0.ɵɵProvidersFeature([{ provide: CdkHeaderCellDef, useExisting: MatHeaderCellDef }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatHeaderCellDef, [{
        type: Directive,
        args: [{
                selector: '[matHeaderCellDef]',
                providers: [{ provide: CdkHeaderCellDef, useExisting: MatHeaderCellDef }]
            }]
    }], null, null); })();
/**
 * Footer cell definition for the mat-table.
 * Captures the template of a column's footer cell and as well as cell-specific properties.
 */
class MatFooterCellDef extends CdkFooterCellDef {
}
MatFooterCellDef.ɵfac = /*@__PURE__*/ function () { let ɵMatFooterCellDef_BaseFactory; return function MatFooterCellDef_Factory(t) { return (ɵMatFooterCellDef_BaseFactory || (ɵMatFooterCellDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatFooterCellDef)))(t || MatFooterCellDef); }; }();
MatFooterCellDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatFooterCellDef, selectors: [["", "matFooterCellDef", ""]], features: [i0.ɵɵProvidersFeature([{ provide: CdkFooterCellDef, useExisting: MatFooterCellDef }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatFooterCellDef, [{
        type: Directive,
        args: [{
                selector: '[matFooterCellDef]',
                providers: [{ provide: CdkFooterCellDef, useExisting: MatFooterCellDef }]
            }]
    }], null, null); })();
/**
 * Column definition for the mat-table.
 * Defines a set of cells available for a table column.
 */
class MatColumnDef extends CdkColumnDef {
    constructor() {
        super(...arguments);
        // eslint-disable-next-line @typescript-eslint/member-ordering
        this._matActionsColumn = false;
        // eslint-disable-next-line @typescript-eslint/member-ordering
        this._matSelectionColumn = false;
    }
    /** Unique name for this column. */
    get name() {
        return this._name;
    }
    set name(name) {
        this._setNameInput(name);
    }
    /**
     * Add "mat-column-" prefix in addition to "cdk-column-" prefix.
     * In the future, this will only add "mat-column-" and columnCssClassName
     * will change from type string[] to string.
     * @docs-private
     */
    _updateColumnCssClassName() {
        super._updateColumnCssClassName();
        this._columnCssClassName.push(`mat-column-${this.cssClassFriendlyName}`);
    }
    //VDL Change: Adds column def types: Selection, Actions, and Expand
    /** Whether this column is an action column (single or menu) */
    get matActionsColumn() {
        return this._matActionsColumn;
    }
    set matActionsColumn(value) {
        this._matActionsColumn = coerceBooleanProperty(value);
        const className = 'mat-table-actions-column';
        if (this._matActionsColumn === !this._columnHasClassName(className)) {
            this._addRemoveClass(className);
        }
    }
    /** Whether this column is an selection column (single or menu) */
    get matSelectionColumn() {
        return this._matSelectionColumn;
    }
    set matSelectionColumn(value) {
        this._matSelectionColumn = coerceBooleanProperty(value);
        const className = 'mat-table-selection-column';
        if (this._matSelectionColumn === !this._columnHasClassName(className)) {
            this._addRemoveClass(className);
        }
    }
    /** returns true if class exists in columnCssClassName array */
    _columnHasClassName(className) {
        return this._columnCssClassName.indexOf(className) >= 0;
    }
    /** Adds/Removes class from columnCssClassName array */
    _addRemoveClass(className) {
        if (this._columnHasClassName(className)) {
            this._columnCssClassName.splice(this._columnCssClassName.indexOf(className), 1);
        }
        else {
            this._columnCssClassName.push(className);
        }
    }
}
MatColumnDef.ɵfac = /*@__PURE__*/ function () { let ɵMatColumnDef_BaseFactory; return function MatColumnDef_Factory(t) { return (ɵMatColumnDef_BaseFactory || (ɵMatColumnDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatColumnDef)))(t || MatColumnDef); }; }();
MatColumnDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatColumnDef, selectors: [["", "matColumnDef", ""]], inputs: { sticky: "sticky", name: ["matColumnDef", "name"], matActionsColumn: "matActionsColumn", matSelectionColumn: "matSelectionColumn" }, features: [i0.ɵɵProvidersFeature([
            { provide: CdkColumnDef, useExisting: MatColumnDef },
            { provide: 'MAT_SORT_HEADER_COLUMN_DEF', useExisting: MatColumnDef }
        ]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatColumnDef, [{
        type: Directive,
        args: [{
                selector: '[matColumnDef]',
                inputs: ['sticky'],
                providers: [
                    { provide: CdkColumnDef, useExisting: MatColumnDef },
                    { provide: 'MAT_SORT_HEADER_COLUMN_DEF', useExisting: MatColumnDef }
                ]
            }]
    }], null, { name: [{
            type: Input,
            args: ['matColumnDef']
        }], matActionsColumn: [{
            type: Input
        }], matSelectionColumn: [{
            type: Input
        }] }); })();
/** Header cell template container that adds the right classes and role. */
class MatHeaderCell extends CdkHeaderCell {
}
MatHeaderCell.ɵfac = /*@__PURE__*/ function () { let ɵMatHeaderCell_BaseFactory; return function MatHeaderCell_Factory(t) { return (ɵMatHeaderCell_BaseFactory || (ɵMatHeaderCell_BaseFactory = i0.ɵɵgetInheritedFactory(MatHeaderCell)))(t || MatHeaderCell); }; }();
MatHeaderCell.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatHeaderCell, selectors: [["mat-header-cell"], ["th", "mat-header-cell", ""]], hostAttrs: ["role", "columnheader", 1, "mat-header-cell"], features: [i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatHeaderCell, [{
        type: Directive,
        args: [{
                selector: 'mat-header-cell, th[mat-header-cell]',
                host: {
                    class: 'mat-header-cell',
                    role: 'columnheader'
                }
            }]
    }], null, null); })();
/** Footer cell template container that adds the right classes and role. */
class MatFooterCell extends CdkFooterCell {
}
MatFooterCell.ɵfac = /*@__PURE__*/ function () { let ɵMatFooterCell_BaseFactory; return function MatFooterCell_Factory(t) { return (ɵMatFooterCell_BaseFactory || (ɵMatFooterCell_BaseFactory = i0.ɵɵgetInheritedFactory(MatFooterCell)))(t || MatFooterCell); }; }();
MatFooterCell.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatFooterCell, selectors: [["mat-footer-cell"], ["td", "mat-footer-cell", ""]], hostAttrs: ["role", "gridcell", 1, "mat-footer-cell"], features: [i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatFooterCell, [{
        type: Directive,
        args: [{
                selector: 'mat-footer-cell, td[mat-footer-cell]',
                host: {
                    class: 'mat-footer-cell',
                    role: 'gridcell'
                }
            }]
    }], null, null); })();
/** Cell template container that adds the right classes and role. */
class MatCell extends CdkCell {
}
MatCell.ɵfac = /*@__PURE__*/ function () { let ɵMatCell_BaseFactory; return function MatCell_Factory(t) { return (ɵMatCell_BaseFactory || (ɵMatCell_BaseFactory = i0.ɵɵgetInheritedFactory(MatCell)))(t || MatCell); }; }();
MatCell.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatCell, selectors: [["mat-cell"], ["td", "mat-cell", ""]], hostAttrs: ["role", "gridcell", 1, "mat-cell"], features: [i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatCell, [{
        type: Directive,
        args: [{
                selector: 'mat-cell, td[mat-cell]',
                host: {
                    class: 'mat-cell',
                    role: 'gridcell'
                }
            }]
    }], null, null); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Table data that is required for internationalization. */
class MatTableIntl {
    constructor() {
        /**
         * Stream that emits whenever the labels here are changed. Use this to notify
         * components if the labels have changed after initialization.
         */
        this.changes = new Subject();
        /** Label used for the button in opening the expansion row. */
        this.rowOpenExpandedButtonLabel = 'Open Expansion Row';
        /** Label used for the button in closing the expansion row */
        this.rowCloseExpandedButtonLabel = 'Close Expansion Row';
    }
}
MatTableIntl.ɵfac = function MatTableIntl_Factory(t) { return new (t || MatTableIntl)(); };
MatTableIntl.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: MatTableIntl, factory: MatTableIntl.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTableIntl, [{
        type: Injectable,
        args: [{ providedIn: 'root' }]
    }], null, null); })();
/** @docs-private */
function MAT_TABLE_INTL_PROVIDER_FACTORY(parentIntl) {
    return parentIntl || new MatTableIntl();
}
/** @docs-private */
const MAT_TABLE_INTL_PROVIDER = {
    provide: MatTableIntl,
    deps: [[new Optional(), new SkipSelf(), MatTableIntl]],
    useFactory: MAT_TABLE_INTL_PROVIDER_FACTORY
};

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const _c0$3 = ["mat-expander-cell", ""];
const _c1$3 = ["*"];
/** Cell template container that adds the classes and template for row expansion. */
class MatExpansionCell extends CdkCell {
    constructor(_intl, _columnDef, _elementRef, changeDetectorRef) {
        super(_columnDef, _elementRef);
        this._intl = _intl;
        this._expanded = false;
        /** Emits an event when expansion changes */
        this.expandedChanged = new EventEmitter();
        this._intlSubscription = _intl.changes.subscribe(() => changeDetectorRef.markForCheck());
    }
    /** Whether the row is expanded */
    get expanded() {
        return this._expanded;
    }
    set expanded(value) {
        this._expanded = coerceBooleanProperty(value);
        this.expandedChanged.emit(this._expanded);
    }
    ngOnDestroy() {
        this._intlSubscription.unsubscribe();
    }
}
MatExpansionCell.ɵfac = function MatExpansionCell_Factory(t) { return new (t || MatExpansionCell)(i0.ɵɵdirectiveInject(MatTableIntl), i0.ɵɵdirectiveInject(i1.CdkColumnDef), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
MatExpansionCell.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatExpansionCell, selectors: [["mat-cell", "mat-expander-cell", ""], ["td", "mat-expander-cell", ""]], hostAttrs: ["role", "gridcell", 1, "mat-cell", "mat-table-column-expansion"], hostVars: 2, hostBindings: function MatExpansionCell_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵclassProp("mat-table-row-expanded", ctx.expanded);
    } }, inputs: { expanded: "expanded" }, outputs: { expandedChanged: "expandedChanged" }, features: [i0.ɵɵInheritDefinitionFeature], attrs: _c0$3, ngContentSelectors: _c1$3, decls: 4, vars: 2, consts: [["mat-icon-button", "", 1, "mat-row-expansion-button", 3, "click"], ["fontSet", "material-symbols-outlined"]], template: function MatExpansionCell_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "button", 0);
        i0.ɵɵlistener("click", function MatExpansionCell_Template_button_click_0_listener() { return ctx.expanded = !ctx.expanded; });
        i0.ɵɵelementStart(1, "mat-icon", 1);
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
        i0.ɵɵprojection(3);
    } if (rf & 2) {
        i0.ɵɵattribute("aria-label", ctx.expanded ? ctx._intl.rowCloseExpandedButtonLabel : ctx._intl.rowOpenExpandedButtonLabel);
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(ctx.expanded ? "expand_less" : "expand_more");
    } }, directives: [i3.MatButton, i2.MatIcon], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatExpansionCell, [{
        type: Component,
        args: [{
                selector: 'mat-cell[mat-expander-cell], td[mat-expander-cell]',
                template: `<button
      mat-icon-button
      class="mat-row-expansion-button"
      [attr.aria-label]="
        expanded
          ? _intl.rowCloseExpandedButtonLabel
          : _intl.rowOpenExpandedButtonLabel
      "
      (click)="expanded = !expanded"
    >
      <mat-icon fontSet="material-symbols-outlined">{{
        expanded ? 'expand_less' : 'expand_more'
      }}</mat-icon></button
    ><ng-content></ng-content>`,
                host: {
                    class: 'mat-cell mat-table-column-expansion',
                    '[class.mat-table-row-expanded]': 'expanded',
                    role: 'gridcell'
                }
            }]
    }], function () { return [{ type: MatTableIntl }, { type: i1.CdkColumnDef }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }]; }, { expanded: [{
            type: Input
        }], expandedChanged: [{
            type: Output
        }] }); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const _c0$2 = ["mat-cell-animated", ""];
const _c1$2 = ["*"];
function MatTableTreeExpander_div_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "div", 2);
} }
const _c2 = function (a0) { return { closedRotation: a0 }; };
const _c3 = function (a0, a1) { return { value: a0, params: a1 }; };
function MatTableTreeExpander_button_1_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 3);
    i0.ɵɵlistener("click", function MatTableTreeExpander_button_1_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r3); const ctx_r2 = i0.ɵɵnextContext(); return ctx_r2.expanderToggleEvent.emit({ isCollapsed: ctx_r2.isCollapsed }); });
    i0.ɵɵelementStart(1, "mat-icon", 4);
    i0.ɵɵtext(2, "chevron_right");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵattribute("aria-label", ctx_r1.ariaLabel ? ctx_r1.ariaLabel : ctx_r1.isCollapsed ? "Expand" : "Collapse");
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("@openClose", i0.ɵɵpureFunction2(4, _c3, ctx_r1.isCollapsed ? "closed" : "open", i0.ɵɵpureFunction1(2, _c2, ctx_r1.closedRotation)));
} }
const _c4 = ["cellWrapper"];
const _c5 = ["treeExpander"];
const _c6 = ["mat-tree-cell", ""];
function MatTreeCell_mat_table_tree_expander_2_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-table-tree-expander", 3, 4);
    i0.ɵɵlistener("expanderToggleEvent", function MatTreeCell_mat_table_tree_expander_2_Template_mat_table_tree_expander_expanderToggleEvent_0_listener() { i0.ɵɵrestoreView(_r4); const ctx_r3 = i0.ɵɵnextContext(); return ctx_r3.expanderToggledEvent(); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("aria-label", ctx_r1.expanderAriaLabel)("isCollapsed", ctx_r1.isCollapsed())("hasChildren", ctx_r1.hasChildren);
} }
/** Regex used to split a string on its CSS units. */
const cssUnitPattern = /([A-Za-z%]+)$/;
/** Adds wraps content within td cells so they can be animated when they are expanded or collapsed */
class MatCellAnimated extends MatCell {
    constructor(columnDef, elementRef) {
        super(columnDef, elementRef);
    }
}
MatCellAnimated.ɵfac = function MatCellAnimated_Factory(t) { return new (t || MatCellAnimated)(i0.ɵɵdirectiveInject(MatColumnDef), i0.ɵɵdirectiveInject(i0.ElementRef)); };
MatCellAnimated.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatCellAnimated, selectors: [["td", "mat-cell-animated", ""]], hostAttrs: ["role", "gridcell", 1, "mat-cell", "mat-cell-animated"], features: [i0.ɵɵInheritDefinitionFeature], attrs: _c0$2, ngContentSelectors: _c1$2, decls: 2, vars: 0, consts: [[1, "mat-cell-wrapper"]], template: function MatCellAnimated_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "span", 0);
        i0.ɵɵprojection(1);
        i0.ɵɵelementEnd();
    } }, encapsulation: 2, changeDetection: 0 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatCellAnimated, [{
        type: Component,
        args: [{
                // eslint-disable-next-line @angular-eslint/component-selector
                selector: 'td[mat-cell-animated]',
                host: {
                    class: 'mat-cell mat-cell-animated',
                    role: 'gridcell'
                },
                template: `
    <span class="mat-cell-wrapper">
      <ng-content></ng-content>
    </span>
  `,
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: MatColumnDef }, { type: i0.ElementRef }]; }, null); })();
/** Expander for table tree */
class MatTableTreeExpander {
    constructor(matIconRegistry, changeDetectorRef, _dir) {
        this.changeDetectorRef = changeDetectorRef;
        this._dir = _dir;
        /** Rotation in deg based on directionality context. Default is rotate(0deg) */
        this.closedRotation = 'rotate(0deg)';
        /** Emits when the component is destroyed. */
        this._destroyed = new Subject();
        /** Whether node is collapsed */
        this.isCollapsed = false;
        /** Whether node has child nodes */
        this.hasChildren = false;
        /** Emits event when expander is toggled */
        this.expanderToggleEvent = new EventEmitter();
        if (_dir) {
            _dir.change.pipe(takeUntil(this._destroyed)).subscribe(() => {
                this.closedRotation =
                    _dir.value === 'ltr' ? 'rotate(0deg)' : 'rotate(180deg)';
            });
        }
    }
}
MatTableTreeExpander.ɵfac = function MatTableTreeExpander_Factory(t) { return new (t || MatTableTreeExpander)(i0.ɵɵdirectiveInject(i2.MatIconRegistry), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i3$1.Directionality, 8)); };
MatTableTreeExpander.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatTableTreeExpander, selectors: [["mat-table-tree-expander"]], hostAttrs: [1, "mat-table-tree-expander"], hostVars: 2, hostBindings: function MatTableTreeExpander_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵclassProp("mat-tree-cell-expanded", ctx.hasChildren && !ctx.isCollapsed);
    } }, inputs: { ariaLabel: ["aria-label", "ariaLabel"], isCollapsed: "isCollapsed", hasChildren: "hasChildren" }, outputs: { expanderToggleEvent: "expanderToggleEvent" }, decls: 2, vars: 2, consts: [["class", "expander-placeholder", 4, "ngIf"], ["mat-icon-button", "", 3, "click", 4, "ngIf"], [1, "expander-placeholder"], ["mat-icon-button", "", 3, "click"], ["fontSet", "material-symbols-outlined"]], template: function MatTableTreeExpander_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵtemplate(0, MatTableTreeExpander_div_0_Template, 1, 0, "div", 0);
        i0.ɵɵtemplate(1, MatTableTreeExpander_button_1_Template, 3, 7, "button", 1);
    } if (rf & 2) {
        i0.ɵɵproperty("ngIf", !ctx.hasChildren);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", ctx.hasChildren);
    } }, directives: [i4.NgIf, i3.MatButton, i2.MatIcon], encapsulation: 2, data: { animation: [
            trigger('openClose', [
                state('open', style({
                    transform: 'rotate(90deg)'
                })),
                state('closed', style({
                    transform: '{{closedRotation}}'
                }), { params: { closedRotation: 'rotate(0deg)' } }),
                transition('open <=> closed', [animate('60ms')])
            ])
        ] }, changeDetection: 0 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTableTreeExpander, [{
        type: Component,
        args: [{
                selector: 'mat-table-tree-expander',
                host: {
                    class: 'mat-table-tree-expander',
                    '[class.mat-tree-cell-expanded]': 'hasChildren && !isCollapsed'
                },
                animations: [
                    trigger('openClose', [
                        state('open', style({
                            transform: 'rotate(90deg)'
                        })),
                        state('closed', style({
                            transform: '{{closedRotation}}'
                        }), { params: { closedRotation: 'rotate(0deg)' } }),
                        transition('open <=> closed', [animate('60ms')])
                    ])
                ],
                template: `
    <div *ngIf="!hasChildren" class="expander-placeholder"></div>
    <button
      mat-icon-button
      *ngIf="hasChildren"
      [attr.aria-label]="
        ariaLabel ? ariaLabel : isCollapsed ? 'Expand' : 'Collapse'
      "
      (click)="expanderToggleEvent.emit({ isCollapsed: isCollapsed })"
    >
      <mat-icon
        [@openClose]="{
          value: isCollapsed ? 'closed' : 'open',
          params: { closedRotation: closedRotation }
        }"
        fontSet="material-symbols-outlined"
        >chevron_right</mat-icon
      >
    </button>
  `,
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: i2.MatIconRegistry }, { type: i0.ChangeDetectorRef }, { type: i3$1.Directionality, decorators: [{
                type: Optional
            }] }]; }, { ariaLabel: [{
            type: Input,
            args: ['aria-label']
        }], isCollapsed: [{
            type: Input
        }], hasChildren: [{
            type: Input
        }], expanderToggleEvent: [{
            type: Output
        }] }); })();
/** Cell template container that adds the right classes and role. */
class MatTreeCell extends MatCell {
    constructor(columnDef, elementRef, changeDetectorRef, keyValueDiffers, _dir) {
        super(columnDef, elementRef);
        this.changeDetectorRef = changeDetectorRef;
        this.keyValueDiffers = keyValueDiffers;
        this._dir = _dir;
        /** Emits event when expander is toggled */
        this.expanderToggleEvent = new EventEmitter();
        /** Subject that emits when the component has been destroyed. */
        this._destroyed = new Subject();
        /** CSS units used for the indentation value. Default is 'px' */
        this.indentUnits = 'px';
        this._disableIndentation = false;
        /** Shows/Hides the expander. Default is true */
        this.isExpandable = true;
        /** Property name for the node level key in the Row Data. Defaults to '_nodeTreeLevel' */
        this.nodeTreeLevelPropertyName = '_nodeTreeLevel';
        /** Property name for the node collapsed key in the Row Data. Defaults to '_nodeCollapsed' */
        this.nodeCollapsedPropertyName = '_nodeCollapsed';
        /**
         * The max level of depth in the tree.
         */
        this.maxLevel = 0;
        /** Whether the node has children */
        this.hasChildren = false;
        this._indent = 35;
        /** Emits an event when the node expander has been triggered */
        // eslint-disable-next-line @angular-eslint/no-output-rename
        this.collapseNodeEvent = new EventEmitter();
        if (_dir) {
            _dir.change.pipe(takeUntil(this._destroyed)).subscribe(() => {
                this._setPadding(true);
            });
        }
    }
    /**
     * Whether data is displayed indented or not. For Example when sorting, the
     * data is no longer in a hierarchical structure.
     */
    get disableIndentation() {
        return this._disableIndentation;
    }
    set disableIndentation(value) {
        this._disableIndentation = coerceBooleanProperty(value);
        this._setPadding(true);
    }
    /** The indent for each level. Default is 35 from VDL design.
     * @docs-private
     */
    get indent() {
        return this._indent;
    }
    set indent(indent) {
        let value = indent;
        let units = 'px';
        if (typeof indent === 'string') {
            const parts = indent.split(cssUnitPattern);
            value = parts[0];
            units = parts[1] || units;
        }
        this.indentUnits = units;
        this._indent = coerceNumberProperty(value);
        this._setPadding();
    }
    ngOnInit() {
        this._setPadding();
        this.keyValueDiffer = this.keyValueDiffers
            .find(this.tableTreeNode)
            .create();
    }
    ngDoCheck() {
        const changes = this.keyValueDiffer.diff(this.tableTreeNode);
        if (changes) {
            changes.forEachChangedItem((item) => {
                if (item.key === this.nodeTreeLevelPropertyName) {
                    this._setPadding();
                }
                if (item.key === this.nodeCollapsedPropertyName ||
                    item.key === this.nodeTreeLevelPropertyName) {
                    this.changeDetectorRef.detectChanges();
                }
            });
        }
    }
    ngOnDestroy() {
        this._destroyed.next();
        this._destroyed.complete();
    }
    /** Toggles the tree node collapsed property on expander toggle event */
    expanderToggledEvent() {
        this.tableTreeNode[this.nodeCollapsedPropertyName] =
            !this.tableTreeNode[this.nodeCollapsedPropertyName];
        this.collapseNodeEvent.emit({
            node: this.tableTreeNode
        });
    }
    /** Resets indentation after content has changed */
    onContentChange() {
        this._setPadding();
    }
    /** Returns if node is collapsed */
    isCollapsed() {
        return this.tableTreeNode[this.nodeCollapsedPropertyName];
    }
    /** Returns the hierarhy level for the node else returns 0 */
    getLevel() {
        if (!this.tableTreeNode ||
            !this.tableTreeNode[this.nodeTreeLevelPropertyName] ||
            this.disableIndentation) {
            return 0;
        }
        return typeof this.tableTreeNode[this.nodeTreeLevelPropertyName] ===
            'number'
            ? this.tableTreeNode[this.nodeTreeLevelPropertyName]
            : 0;
    }
    /** Sets the indentation according to the hierarchy level for the node */
    _setPadding(forceChange = false) {
        if (this.cellWrapper) {
            const level = this.getLevel();
            const padding = level * this._indent;
            if (padding !== this._currentPadding || forceChange) {
                const element = this.cellWrapper.nativeElement;
                const paddingProp = this._dir && this._dir.value === 'rtl'
                    ? 'paddingRight'
                    : 'paddingLeft';
                const endPaddingProp = this._dir && this._dir.value === 'rtl'
                    ? 'paddingLeft'
                    : 'paddingRight';
                element.style[paddingProp] = `${padding}${this.indentUnits}` || '';
                element.style[endPaddingProp] =
                    `${(this.maxLevel - level) * this._indent}${this.indentUnits}` || '';
                this._currentPadding = padding;
            }
        }
    }
}
MatTreeCell.ɵfac = function MatTreeCell_Factory(t) { return new (t || MatTreeCell)(i0.ɵɵdirectiveInject(MatColumnDef), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i0.KeyValueDiffers), i0.ɵɵdirectiveInject(i3$1.Directionality, 8)); };
MatTreeCell.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatTreeCell, selectors: [["mat-cell", "mat-tree-cell", ""], ["td", "mat-tree-cell", ""]], viewQuery: function MatTreeCell_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(_c4, 7);
        i0.ɵɵviewQuery(_c5, 5);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.cellWrapper = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.treeExpander = _t.first);
    } }, hostAttrs: ["role", "gridcell", 1, "mat-cell", "mat-tree-cell"], hostVars: 3, hostBindings: function MatTreeCell_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("aria-level", ctx.getLevel() + 1);
        i0.ɵɵclassProp("mat-tree-cell-expanded", !ctx.isCollapsed());
    } }, inputs: { disableIndentation: "disableIndentation", isExpandable: "isExpandable", expanderAriaLabel: ["matNodeExpanderAriaLabel", "expanderAriaLabel"], tableTreeNode: ["matTableTreeNode", "tableTreeNode"], nodeTreeLevelPropertyName: "nodeTreeLevelPropertyName", nodeCollapsedPropertyName: "nodeCollapsedPropertyName", maxLevel: ["matTableTreeCellMaxLevel", "maxLevel"], hasChildren: "hasChildren", indent: ["matTableTreeCellIndent", "indent"] }, outputs: { expanderToggleEvent: "expanderToggleEvent", collapseNodeEvent: "matTableTreeNodeCollapseEvent" }, features: [i0.ɵɵInheritDefinitionFeature], attrs: _c6, ngContentSelectors: _c1$2, decls: 4, vars: 1, consts: [[1, "tree-cell-wrapper", 3, "cdkObserveContent"], ["cellWrapper", ""], [3, "aria-label", "isCollapsed", "hasChildren", "expanderToggleEvent", 4, "ngIf"], [3, "aria-label", "isCollapsed", "hasChildren", "expanderToggleEvent"], ["treeExpander", ""]], template: function MatTreeCell_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "div", 0, 1);
        i0.ɵɵlistener("cdkObserveContent", function MatTreeCell_Template_div_cdkObserveContent_0_listener() { return ctx.onContentChange(); });
        i0.ɵɵtemplate(2, MatTreeCell_mat_table_tree_expander_2_Template, 2, 3, "mat-table-tree-expander", 2);
        i0.ɵɵprojection(3);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", ctx.isExpandable && !ctx.disableIndentation);
    } }, directives: [i6.CdkObserveContent, i4.NgIf, MatTableTreeExpander], encapsulation: 2, changeDetection: 0 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTreeCell, [{
        type: Component,
        args: [{
                selector: 'mat-cell[mat-tree-cell], td[mat-tree-cell]',
                host: {
                    class: 'mat-cell mat-tree-cell',
                    '[class.mat-tree-cell-expanded]': '!isCollapsed()',
                    '[attr.aria-level]': 'getLevel() + 1',
                    role: 'gridcell'
                },
                template: `
    <div
      #cellWrapper
      class="tree-cell-wrapper"
      (cdkObserveContent)="onContentChange()"
    >
      <mat-table-tree-expander
        #treeExpander
        *ngIf="isExpandable && !disableIndentation"
        [aria-label]="expanderAriaLabel"
        [isCollapsed]="isCollapsed()"
        [hasChildren]="hasChildren"
        (expanderToggleEvent)="expanderToggledEvent()"
      ></mat-table-tree-expander>
      <ng-content></ng-content>
    </div>
  `,
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: MatColumnDef }, { type: i0.ElementRef }, { type: i0.ChangeDetectorRef }, { type: i0.KeyValueDiffers }, { type: i3$1.Directionality, decorators: [{
                type: Optional
            }] }]; }, { cellWrapper: [{
            type: ViewChild,
            args: ['cellWrapper', { static: true }]
        }], treeExpander: [{
            type: ViewChild,
            args: ['treeExpander']
        }], expanderToggleEvent: [{
            type: Output
        }], disableIndentation: [{
            type: Input
        }], isExpandable: [{
            type: Input
        }], expanderAriaLabel: [{
            type: Input,
            args: ['matNodeExpanderAriaLabel']
        }], tableTreeNode: [{
            type: Input,
            args: ['matTableTreeNode']
        }], nodeTreeLevelPropertyName: [{
            type: Input
        }], nodeCollapsedPropertyName: [{
            type: Input
        }], maxLevel: [{
            type: Input,
            args: ['matTableTreeCellMaxLevel']
        }], hasChildren: [{
            type: Input
        }], indent: [{
            type: Input,
            args: ['matTableTreeCellIndent']
        }], collapseNodeEvent: [{
            type: Output,
            args: ['matTableTreeNodeCollapseEvent']
        }] }); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const _c0$1 = [[["caption"]], [["colgroup"], ["col"]]];
const _c1$1 = ["caption", "colgroup, col"];
/**
 * Enables the recycle view repeater strategy, which reduces rendering latency. Not compatible with
 * tables that animate rows.
 */
class MatRecycleRows {
}
MatRecycleRows.ɵfac = function MatRecycleRows_Factory(t) { return new (t || MatRecycleRows)(); };
MatRecycleRows.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatRecycleRows, selectors: [["mat-table", "recycleRows", ""], ["table", "mat-table", "", "recycleRows", ""]], features: [i0.ɵɵProvidersFeature([
            { provide: _VIEW_REPEATER_STRATEGY, useClass: _RecycleViewRepeaterStrategy }
        ])] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatRecycleRows, [{
        type: Directive,
        args: [{
                selector: 'mat-table[recycleRows], table[mat-table][recycleRows]',
                providers: [
                    { provide: _VIEW_REPEATER_STRATEGY, useClass: _RecycleViewRepeaterStrategy }
                ]
            }]
    }], null, null); })();
/**
 * Wrapper for the CdkTable with Material design styles.
 */
class MatTable extends CdkTable {
    constructor() {
        super(...arguments);
        /** Overrides the sticky CSS class set by the `CdkTable`. */
        this.stickyCssClass = 'mat-table-sticky';
        /** Overrides the need to add position: sticky on every sticky cell element in `CdkTable`. */
        this.needsPositionStickyOnElement = false;
    }
}
MatTable.ɵfac = /*@__PURE__*/ function () { let ɵMatTable_BaseFactory; return function MatTable_Factory(t) { return (ɵMatTable_BaseFactory || (ɵMatTable_BaseFactory = i0.ɵɵgetInheritedFactory(MatTable)))(t || MatTable); }; }();
MatTable.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatTable, selectors: [["mat-table"], ["table", "mat-table", ""]], hostAttrs: [1, "mat-table"], hostVars: 2, hostBindings: function MatTable_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵclassProp("mat-table-fixed-layout", ctx.fixedLayout);
    } }, exportAs: ["matTable"], features: [i0.ɵɵProvidersFeature([
            // TODO(michaeljamesparsons) Abstract the view repeater strategy to a directive API so this code
            //  is only included in the build if used.
            {
                provide: _VIEW_REPEATER_STRATEGY,
                useClass: _DisposeViewRepeaterStrategy
            },
            { provide: CdkTable, useExisting: MatTable },
            { provide: CDK_TABLE, useExisting: MatTable },
            { provide: _COALESCED_STYLE_SCHEDULER, useClass: _CoalescedStyleScheduler },
            // Prevent nested tables from seeing this table's StickyPositioningListener.
            { provide: STICKY_POSITIONING_LISTENER, useValue: null }
        ]), i0.ɵɵInheritDefinitionFeature], ngContentSelectors: _c1$1, decls: 6, vars: 0, consts: [["headerRowOutlet", ""], ["rowOutlet", ""], ["noDataRowOutlet", ""], ["footerRowOutlet", ""]], template: function MatTable_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef(_c0$1);
        i0.ɵɵprojection(0);
        i0.ɵɵprojection(1, 1);
        i0.ɵɵelementContainer(2, 0)(3, 1)(4, 2)(5, 3);
    } }, directives: [i1.HeaderRowOutlet, i1.DataRowOutlet, i1.NoDataRowOutlet, i1.FooterRowOutlet], styles: ["mat-table{display:block}mat-header-row{min-height:46px}mat-row,mat-footer-row{min-height:48px}mat-row,mat-header-row,mat-footer-row{display:flex;border-width:0;border-bottom-width:1px;border-style:solid;align-items:center;box-sizing:border-box}mat-header-cell:first-of-type,mat-cell:first-of-type,mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}mat-header-cell:last-of-type,mat-cell:last-of-type,mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}mat-cell,mat-header-cell,mat-footer-cell{flex:1;display:flex;align-items:center;overflow:hidden;word-wrap:break-word;min-height:inherit}mat-cell:last-child:not(.mat-tree-cell).mat-table-actions-column,mat-header-cell:last-child:not(.mat-tree-cell).mat-table-actions-column,mat-footer-cell:last-child:not(.mat-tree-cell).mat-table-actions-column{padding-left:0;padding-right:0;width:45px;flex:0 0 auto}mat-cell:last-child:not(.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,mat-header-cell:last-child:not(.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,mat-footer-cell:last-child:not(.mat-tree-cell).mat-table-actions-column>button.mat-icon-button{width:45px;height:47px}table.mat-table{border-spacing:0}tr.mat-header-row{height:46px}tr.mat-row,tr.mat-footer-row{height:48px}tr.mat-row.mat-row-disabled>.mat-cell:not(.mat-column-selection-column):not(.mat-column-expand-column)>*{pointer-events:none;opacity:.5}th.mat-header-cell{text-align:left}[dir=rtl] th.mat-header-cell{text-align:right}th.mat-header-cell,td.mat-footer-cell{padding:0;border-bottom-width:1px;border-bottom-style:solid}th.mat-header-cell:first-of-type,td.mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] th.mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}th.mat-header-cell:last-of-type,td.mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] th.mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}td.mat-cell,td.mat-tree-cell{padding:0;border-bottom-width:1px;border-bottom-style:solid}td.mat-cell:first-child:not(.mat-table-column-expansion),td.mat-tree-cell:first-child:not(.mat-table-column-expansion){padding-left:24px}[dir=rtl] td.mat-cell:first-child:not(.mat-table-column-expansion),[dir=rtl] td.mat-tree-cell:first-child:not(.mat-table-column-expansion){padding-left:0;padding-right:24px}td.mat-cell:last-child:not(td.mat-tree-cell),td.mat-tree-cell:last-child:not(td.mat-tree-cell){padding-right:24px}[dir=rtl] td.mat-cell:last-child:not(td.mat-tree-cell),[dir=rtl] td.mat-tree-cell:last-child:not(td.mat-tree-cell){padding-right:0;padding-left:24px}.mat-table-sticky{position:sticky!important}.mat-table-fixed-layout{table-layout:fixed}.mat-scrollable-table-wrapper{position:relative;display:block}.mat-scrollable-table-wrapper div[cdk-scrollable]{height:100%;overflow:auto}.mat-scrollable-table-wrapper mat-table,.mat-scrollable-table-wrapper table.mat-table{width:-moz-fit-content;width:fit-content;min-width:100%}.mat-header-cell.mat-resizable-column:not(.mat-table-sticky),.mat-header-cell.mat-table-column-resizable:not(.mat-table-sticky){position:relative}.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-resizable-column .mat-table-resize-handle,.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-resizable-column .mat-table-column-resize-handle,.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-table-column-resizable .mat-table-resize-handle,.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle{border-right:none;visibility:hidden}.mat-header-cell.mat-resizable-column .mat-table-resize-handle,.mat-header-cell.mat-table-column-resizable .mat-table-resize-handle{width:5px;border-right-width:2px;border-right-style:solid;display:inline-block;position:absolute;right:0;top:0;bottom:0;padding:0;visibility:hidden;cursor:ew-resize}[dir=rtl] .mat-header-cell.mat-resizable-column .mat-table-resize-handle,[dir=rtl] .mat-header-cell.mat-table-column-resizable .mat-table-resize-handle{border-left-width:2px;border-left-style:solid;border-right:unset;left:0;right:unset}.mat-header-cell.mat-resizable-column .mat-table-column-resize-handle,.mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle{width:2px;border-left-width:2px;border-left-style:solid;border-right-width:2px;border-right-style:solid;display:inline-block;position:absolute;right:-2px;top:0;bottom:0;padding:0;visibility:hidden;cursor:ew-resize}[dir=rtl] .mat-header-cell.mat-resizable-column .mat-table-column-resize-handle,[dir=rtl] .mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle{left:-2px;right:unset}.mat-header-cell.mat-resizable-column .mat-table-column-resize-handle:last-child,.mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle:last-child{right:0;border-right:none}[dir=rtl] .mat-header-cell.mat-resizable-column .mat-table-column-resize-handle:last-child,[dir=rtl] .mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle:last-child{left:0;right:unset}.mat-header-cell.mat-resizable-column.mat-table-column-resizing .mat-table-resize-handle,.mat-header-cell.mat-resizable-column.mat-table-column-resizing .mat-table-column-resize-handle,.mat-header-cell.mat-resizable-column:hover .mat-table-resize-handle,.mat-header-cell.mat-resizable-column:hover .mat-table-column-resize-handle,.mat-header-cell.mat-table-column-resizable.mat-table-column-resizing .mat-table-resize-handle,.mat-header-cell.mat-table-column-resizable.mat-table-column-resizing .mat-table-column-resize-handle,.mat-header-cell.mat-table-column-resizable:hover .mat-table-resize-handle,.mat-header-cell.mat-table-column-resizable:hover .mat-table-column-resize-handle{visibility:visible}mat-column-selection-column,.mat-column-select{width:30px;max-width:30px}mat-column-selection-column>mat-radio-button,.mat-column-select>mat-radio-button{padding-top:unset;padding-bottom:unset}.mat-tree-cell>div.tree-cell-wrapper{display:flex;flex-direction:row;align-items:center}.mat-table-tree-expander>.mat-icon-button,.mat-table-tree-expander>.expander-placeholder{display:flex;justify-content:center;align-items:center;width:35px;height:35px;line-height:1}.mat-table-tree-expander>.mat-icon-button>.mat-button-wrapper>.mat-icon{transform:rotate(0)}.mat-table-tree-expander+.mat-checkbox .mat-checkbox-inner-container-no-side-margin{margin-left:0;margin-right:15px}[dir=rtl] .mat-table-tree-expander+.mat-checkbox .mat-checkbox-inner-container-no-side-margin{margin-left:15px;margin-right:0}mat-table mat-row.mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden{animation:flex-row-collapse 1 ease-in .3s forwards}mat-table mat-row.mat-tree-row.mat-tree-row-animating.mat-tree-row-visible{animation:flex-row-expand 1 ease .3s forwards}mat-table mat-row.mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden{display:none;visibility:none;min-height:0;height:0;border-bottom-width:0;opacity:0;line-height:0}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden{animation:tr-collapse 1 ease-in .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-cell-animated],table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-tree-cell]{border-bottom-width:0;animation:td-collapse 1 ease-in .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-cell-animated]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-cell-animated]>.tree-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-tree-cell]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-tree-cell]>.tree-cell-wrapper{animation:td-wrapper-collapse 1 ease-in .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible{animation:tr-expand 1 ease .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-cell-animated],table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-tree-cell]{animation:td-expand 1 ease .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-cell-animated]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-cell-animated]>.tree-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-tree-cell]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-tree-cell]>.tree-cell-wrapper{animation:td-wrapper-expand 1 ease .3s forwards}table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden{display:none;height:0}table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-cell-animated],table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-tree-cell]{height:0;border-bottom-width:0}table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-cell-animated]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-cell-animated]>.tree-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-tree-cell]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-tree-cell]>.tree-cell-wrapper{opacity:0;height:0}mat-header-row.mat-header-progress-bar-row,tr.mat-header-row.mat-header-progress-bar-row{min-height:auto;padding:0;border:none;height:2px}mat-header-row.mat-header-progress-bar-row:not(tr),tr.mat-header-row.mat-header-progress-bar-row:not(tr){display:flex}mat-header-row.mat-header-progress-bar-row th,mat-header-row.mat-header-progress-bar-row mat-header-cell,tr.mat-header-row.mat-header-progress-bar-row th,tr.mat-header-row.mat-header-progress-bar-row mat-header-cell{padding:0}mat-header-row.mat-header-progress-bar-row th .mat-progress-bar,mat-header-row.mat-header-progress-bar-row mat-header-cell .mat-progress-bar,tr.mat-header-row.mat-header-progress-bar-row th .mat-progress-bar,tr.mat-header-row.mat-header-progress-bar-row mat-header-cell .mat-progress-bar{height:3px}mat-header-row.mat-header-progress-bar-row th,tr.mat-header-row.mat-header-progress-bar-row th{border-width:0}mat-header-row.mat-header-progress-bar-row th:last-child:not(.mat-column-action-column),mat-header-row.mat-header-progress-bar-row .mat-header-cell:last-child:not(.mat-column-action-column),tr.mat-header-row.mat-header-progress-bar-row th:last-child:not(.mat-column-action-column),tr.mat-header-row.mat-header-progress-bar-row .mat-header-cell:last-child:not(.mat-column-action-column){padding-right:0}.mat-header-cell.cdk-drag-preview{box-sizing:border-box;padding:0 15px;position:relative;align-items:center;display:flex;opacity:.8}.mat-header-cell.cdk-drag-preview:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px;border-width:1px;border-style:solid}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled){cursor:pointer}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder{position:relative;transition:transform .25s cubic-bezier(0,0,.2,1)}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled).cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.mat-row.cdk-drag-preview{box-sizing:border-box;position:relative;opacity:.8}.mat-row.cdk-drag-preview:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px;border-width:1px;border-style:solid}tr.mat-row.cdk-drag-dragging+tr.mat-row.cdk-drag-preview{display:flex;align-items:stretch}tr.mat-row.cdk-drag-dragging+tr.mat-row.cdk-drag-preview td.mat-cell{display:flex;flex:1 1 auto;align-items:center}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled){cursor:pointer}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder{position:relative;transition:transform .25s cubic-bezier(0,0,.2,1)}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder .mat-cell{color:transparent}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}th.mat-header-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column,td.mat-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column,td.mat-footer-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column{padding-left:0;padding-right:0;width:45px}th.mat-header-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,td.mat-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,td.mat-footer-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column>button.mat-icon-button{width:45px;height:47px}td.mat-cell.mat-table-column-expansion{width:30px}@keyframes tr-expand{0%{display:none;height:0}1%{display:table-row}to{display:table-row;height:48px}}@keyframes tr-collapse{0%{height:48px;line-height:0;display:table-row}99%{display:table-row}to{display:none;height:0;line-height:0}}@keyframes td-expand{0%{border-bottom-width:0;overflow:hidden;line-height:0;height:0}50%{border-bottom-width:1px}to{border-bottom-width:1px;overflow:hidden;line-height:unset;height:48px}}@keyframes td-collapse{0%{border-bottom-width:1px;height:48px;line-height:0;overflow:hidden}50%{border-bottom-width:0}to{border-bottom-width:0;height:0;line-height:0;overflow:hidden}}@keyframes td-wrapper-expand{0%{opacity:0;overflow:hidden;height:0}99%{overflow:hidden}to{overflow:unset;opacity:1;height:1rem}}@keyframes td-wrapper-collapse{0%{opacity:1;overflow:hidden}1%{overflow:hidden;height:48px}to{opacity:0;overflow:unset;height:0}}@keyframes flex-row-expand{0%{display:none;min-height:0;line-height:0;height:0;opacity:0}1%{display:flex}99%{line-height:1.5rem;height:48px;min-height:48px}to{line-height:unset;height:unset;min-height:48px;opacity:1}}@keyframes flex-row-collapse{0%{min-height:48px;height:48px;visibility:visible;border-bottom-width:0;opacity:1;line-height:1.5rem}99%{display:flex}to{display:none;visibility:none;min-height:0;height:0;border-bottom-width:0;opacity:0;line-height:0}}\n"], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTable, [{
        type: Component,
        args: [{ selector: 'mat-table, table[mat-table]', exportAs: 'matTable', template: CDK_TABLE_TEMPLATE, host: {
                    class: 'mat-table',
                    '[class.mat-table-fixed-layout]': 'fixedLayout'
                }, providers: [
                    // TODO(michaeljamesparsons) Abstract the view repeater strategy to a directive API so this code
                    //  is only included in the build if used.
                    {
                        provide: _VIEW_REPEATER_STRATEGY,
                        useClass: _DisposeViewRepeaterStrategy
                    },
                    { provide: CdkTable, useExisting: MatTable },
                    { provide: CDK_TABLE, useExisting: MatTable },
                    { provide: _COALESCED_STYLE_SCHEDULER, useClass: _CoalescedStyleScheduler },
                    // Prevent nested tables from seeing this table's StickyPositioningListener.
                    { provide: STICKY_POSITIONING_LISTENER, useValue: null }
                ], encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.Default, styles: ["mat-table{display:block}mat-header-row{min-height:46px}mat-row,mat-footer-row{min-height:48px}mat-row,mat-header-row,mat-footer-row{display:flex;border-width:0;border-bottom-width:1px;border-style:solid;align-items:center;box-sizing:border-box}mat-header-cell:first-of-type,mat-cell:first-of-type,mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-cell:first-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}mat-header-cell:last-of-type,mat-cell:last-of-type,mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-cell:last-of-type:not(:only-of-type),[dir=rtl] mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}mat-cell,mat-header-cell,mat-footer-cell{flex:1;display:flex;align-items:center;overflow:hidden;word-wrap:break-word;min-height:inherit}mat-cell:last-child:not(.mat-tree-cell).mat-table-actions-column,mat-header-cell:last-child:not(.mat-tree-cell).mat-table-actions-column,mat-footer-cell:last-child:not(.mat-tree-cell).mat-table-actions-column{padding-left:0;padding-right:0;width:45px;flex:0 0 auto}mat-cell:last-child:not(.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,mat-header-cell:last-child:not(.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,mat-footer-cell:last-child:not(.mat-tree-cell).mat-table-actions-column>button.mat-icon-button{width:45px;height:47px}table.mat-table{border-spacing:0}tr.mat-header-row{height:46px}tr.mat-row,tr.mat-footer-row{height:48px}tr.mat-row.mat-row-disabled>.mat-cell:not(.mat-column-selection-column):not(.mat-column-expand-column)>*{pointer-events:none;opacity:.5}th.mat-header-cell{text-align:left}[dir=rtl] th.mat-header-cell{text-align:right}th.mat-header-cell,td.mat-footer-cell{padding:0;border-bottom-width:1px;border-bottom-style:solid}th.mat-header-cell:first-of-type,td.mat-footer-cell:first-of-type{padding-left:24px}[dir=rtl] th.mat-header-cell:first-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:first-of-type:not(:only-of-type){padding-left:0;padding-right:24px}th.mat-header-cell:last-of-type,td.mat-footer-cell:last-of-type{padding-right:24px}[dir=rtl] th.mat-header-cell:last-of-type:not(:only-of-type),[dir=rtl] td.mat-footer-cell:last-of-type:not(:only-of-type){padding-right:0;padding-left:24px}td.mat-cell,td.mat-tree-cell{padding:0;border-bottom-width:1px;border-bottom-style:solid}td.mat-cell:first-child:not(.mat-table-column-expansion),td.mat-tree-cell:first-child:not(.mat-table-column-expansion){padding-left:24px}[dir=rtl] td.mat-cell:first-child:not(.mat-table-column-expansion),[dir=rtl] td.mat-tree-cell:first-child:not(.mat-table-column-expansion){padding-left:0;padding-right:24px}td.mat-cell:last-child:not(td.mat-tree-cell),td.mat-tree-cell:last-child:not(td.mat-tree-cell){padding-right:24px}[dir=rtl] td.mat-cell:last-child:not(td.mat-tree-cell),[dir=rtl] td.mat-tree-cell:last-child:not(td.mat-tree-cell){padding-right:0;padding-left:24px}.mat-table-sticky{position:sticky!important}.mat-table-fixed-layout{table-layout:fixed}.mat-scrollable-table-wrapper{position:relative;display:block}.mat-scrollable-table-wrapper div[cdk-scrollable]{height:100%;overflow:auto}.mat-scrollable-table-wrapper mat-table,.mat-scrollable-table-wrapper table.mat-table{width:-moz-fit-content;width:fit-content;min-width:100%}.mat-header-cell.mat-resizable-column:not(.mat-table-sticky),.mat-header-cell.mat-table-column-resizable:not(.mat-table-sticky){position:relative}.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-resizable-column .mat-table-resize-handle,.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-resizable-column .mat-table-column-resize-handle,.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-table-column-resizable .mat-table-resize-handle,.mat-header-row.mat-table-row-resizing .mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle{border-right:none;visibility:hidden}.mat-header-cell.mat-resizable-column .mat-table-resize-handle,.mat-header-cell.mat-table-column-resizable .mat-table-resize-handle{width:5px;border-right-width:2px;border-right-style:solid;display:inline-block;position:absolute;right:0;top:0;bottom:0;padding:0;visibility:hidden;cursor:ew-resize}[dir=rtl] .mat-header-cell.mat-resizable-column .mat-table-resize-handle,[dir=rtl] .mat-header-cell.mat-table-column-resizable .mat-table-resize-handle{border-left-width:2px;border-left-style:solid;border-right:unset;left:0;right:unset}.mat-header-cell.mat-resizable-column .mat-table-column-resize-handle,.mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle{width:2px;border-left-width:2px;border-left-style:solid;border-right-width:2px;border-right-style:solid;display:inline-block;position:absolute;right:-2px;top:0;bottom:0;padding:0;visibility:hidden;cursor:ew-resize}[dir=rtl] .mat-header-cell.mat-resizable-column .mat-table-column-resize-handle,[dir=rtl] .mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle{left:-2px;right:unset}.mat-header-cell.mat-resizable-column .mat-table-column-resize-handle:last-child,.mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle:last-child{right:0;border-right:none}[dir=rtl] .mat-header-cell.mat-resizable-column .mat-table-column-resize-handle:last-child,[dir=rtl] .mat-header-cell.mat-table-column-resizable .mat-table-column-resize-handle:last-child{left:0;right:unset}.mat-header-cell.mat-resizable-column.mat-table-column-resizing .mat-table-resize-handle,.mat-header-cell.mat-resizable-column.mat-table-column-resizing .mat-table-column-resize-handle,.mat-header-cell.mat-resizable-column:hover .mat-table-resize-handle,.mat-header-cell.mat-resizable-column:hover .mat-table-column-resize-handle,.mat-header-cell.mat-table-column-resizable.mat-table-column-resizing .mat-table-resize-handle,.mat-header-cell.mat-table-column-resizable.mat-table-column-resizing .mat-table-column-resize-handle,.mat-header-cell.mat-table-column-resizable:hover .mat-table-resize-handle,.mat-header-cell.mat-table-column-resizable:hover .mat-table-column-resize-handle{visibility:visible}mat-column-selection-column,.mat-column-select{width:30px;max-width:30px}mat-column-selection-column>mat-radio-button,.mat-column-select>mat-radio-button{padding-top:unset;padding-bottom:unset}.mat-tree-cell>div.tree-cell-wrapper{display:flex;flex-direction:row;align-items:center}.mat-table-tree-expander>.mat-icon-button,.mat-table-tree-expander>.expander-placeholder{display:flex;justify-content:center;align-items:center;width:35px;height:35px;line-height:1}.mat-table-tree-expander>.mat-icon-button>.mat-button-wrapper>.mat-icon{transform:rotate(0)}.mat-table-tree-expander+.mat-checkbox .mat-checkbox-inner-container-no-side-margin{margin-left:0;margin-right:15px}[dir=rtl] .mat-table-tree-expander+.mat-checkbox .mat-checkbox-inner-container-no-side-margin{margin-left:15px;margin-right:0}mat-table mat-row.mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden{animation:flex-row-collapse 1 ease-in .3s forwards}mat-table mat-row.mat-tree-row.mat-tree-row-animating.mat-tree-row-visible{animation:flex-row-expand 1 ease .3s forwards}mat-table mat-row.mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden{display:none;visibility:none;min-height:0;height:0;border-bottom-width:0;opacity:0;line-height:0}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden{animation:tr-collapse 1 ease-in .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-cell-animated],table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-tree-cell]{border-bottom-width:0;animation:td-collapse 1 ease-in .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-cell-animated]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-cell-animated]>.tree-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-tree-cell]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-hidden>td[mat-tree-cell]>.tree-cell-wrapper{animation:td-wrapper-collapse 1 ease-in .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible{animation:tr-expand 1 ease .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-cell-animated],table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-tree-cell]{animation:td-expand 1 ease .3s forwards}table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-cell-animated]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-cell-animated]>.tree-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-tree-cell]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row.mat-tree-row-animating.mat-tree-row-visible>td[mat-tree-cell]>.tree-cell-wrapper{animation:td-wrapper-expand 1 ease .3s forwards}table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden{display:none;height:0}table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-cell-animated],table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-tree-cell]{height:0;border-bottom-width:0}table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-cell-animated]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-cell-animated]>.tree-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-tree-cell]>.mat-cell-wrapper,table[mat-table] tr[mat-row].mat-tree-row:not(.mat-tree-row-animating).mat-tree-row-hidden>td[mat-tree-cell]>.tree-cell-wrapper{opacity:0;height:0}mat-header-row.mat-header-progress-bar-row,tr.mat-header-row.mat-header-progress-bar-row{min-height:auto;padding:0;border:none;height:2px}mat-header-row.mat-header-progress-bar-row:not(tr),tr.mat-header-row.mat-header-progress-bar-row:not(tr){display:flex}mat-header-row.mat-header-progress-bar-row th,mat-header-row.mat-header-progress-bar-row mat-header-cell,tr.mat-header-row.mat-header-progress-bar-row th,tr.mat-header-row.mat-header-progress-bar-row mat-header-cell{padding:0}mat-header-row.mat-header-progress-bar-row th .mat-progress-bar,mat-header-row.mat-header-progress-bar-row mat-header-cell .mat-progress-bar,tr.mat-header-row.mat-header-progress-bar-row th .mat-progress-bar,tr.mat-header-row.mat-header-progress-bar-row mat-header-cell .mat-progress-bar{height:3px}mat-header-row.mat-header-progress-bar-row th,tr.mat-header-row.mat-header-progress-bar-row th{border-width:0}mat-header-row.mat-header-progress-bar-row th:last-child:not(.mat-column-action-column),mat-header-row.mat-header-progress-bar-row .mat-header-cell:last-child:not(.mat-column-action-column),tr.mat-header-row.mat-header-progress-bar-row th:last-child:not(.mat-column-action-column),tr.mat-header-row.mat-header-progress-bar-row .mat-header-cell:last-child:not(.mat-column-action-column){padding-right:0}.mat-header-cell.cdk-drag-preview{box-sizing:border-box;padding:0 15px;position:relative;align-items:center;display:flex;opacity:.8}.mat-header-cell.cdk-drag-preview:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px;border-width:1px;border-style:solid}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled){cursor:pointer}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder{position:relative;transition:transform .25s cubic-bezier(0,0,.2,1)}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px}.mat-table.cdk-drop-list .mat-header-cell.cdk-drag:not(.cdk-drag-disabled).cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}.mat-row.cdk-drag-preview{box-sizing:border-box;position:relative;opacity:.8}.mat-row.cdk-drag-preview:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px;border-width:1px;border-style:solid}tr.mat-row.cdk-drag-dragging+tr.mat-row.cdk-drag-preview{display:flex;align-items:stretch}tr.mat-row.cdk-drag-dragging+tr.mat-row.cdk-drag-preview td.mat-cell{display:flex;flex:1 1 auto;align-items:center}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled){cursor:pointer}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder{position:relative;transition:transform .25s cubic-bezier(0,0,.2,1)}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder .mat-cell{color:transparent}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-placeholder:after{content:\"\";position:absolute;inset:0 5px;border-radius:4px}.mat-table.cdk-drop-list .mat-row.cdk-drag:not(.cdk-drag-disabled).cdk-drag-animating{transition:transform .25s cubic-bezier(0,0,.2,1)}th.mat-header-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column,td.mat-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column,td.mat-footer-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column{padding-left:0;padding-right:0;width:45px}th.mat-header-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,td.mat-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column>button.mat-icon-button,td.mat-footer-cell:last-child:not(td.mat-tree-cell).mat-table-actions-column>button.mat-icon-button{width:45px;height:47px}td.mat-cell.mat-table-column-expansion{width:30px}@keyframes tr-expand{0%{display:none;height:0}1%{display:table-row}to{display:table-row;height:48px}}@keyframes tr-collapse{0%{height:48px;line-height:0;display:table-row}99%{display:table-row}to{display:none;height:0;line-height:0}}@keyframes td-expand{0%{border-bottom-width:0;overflow:hidden;line-height:0;height:0}50%{border-bottom-width:1px}to{border-bottom-width:1px;overflow:hidden;line-height:unset;height:48px}}@keyframes td-collapse{0%{border-bottom-width:1px;height:48px;line-height:0;overflow:hidden}50%{border-bottom-width:0}to{border-bottom-width:0;height:0;line-height:0;overflow:hidden}}@keyframes td-wrapper-expand{0%{opacity:0;overflow:hidden;height:0}99%{overflow:hidden}to{overflow:unset;opacity:1;height:1rem}}@keyframes td-wrapper-collapse{0%{opacity:1;overflow:hidden}1%{overflow:hidden;height:48px}to{opacity:0;overflow:unset;height:0}}@keyframes flex-row-expand{0%{display:none;min-height:0;line-height:0;height:0;opacity:0}1%{display:flex}99%{line-height:1.5rem;height:48px;min-height:48px}to{line-height:unset;height:unset;min-height:48px;opacity:1}}@keyframes flex-row-collapse{0%{min-height:48px;height:48px;visibility:visible;border-bottom-width:0;opacity:1;line-height:1.5rem}99%{display:flex}to{display:none;visibility:none;min-height:0;height:0;border-bottom-width:0;opacity:0;line-height:0}}\n"] }]
    }], null, null); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const RESIZEABLE_COLUMNS_DRAG_CONFIG = {
    dragStartThreshold: 0,
    pointerDirectionChangeThreshold: 5
};
// Increasing integer for generating unique ids.
let nextUniqueId = 0;
/**
 * Marks the column as resizable. Only those columns which are designated with
 * this directive are resizable.
 *
 * Columns marked with this directive will have a resize handle on hover allowing
 * them to be sized in either direction.
 */
class MatResizableTableColumn {
    constructor(elementRef, tableRef, dragDropService, columnDef, dir) {
        this.elementRef = elementRef;
        this.tableRef = tableRef;
        this.dragDropService = dragDropService;
        this.columnDef = columnDef;
        /** Subscription to the Directionality change EventEmitter. */
        this._dirChangeSubscription = Subscription.EMPTY;
        /** Minimum drag width for column */
        this.minDragWidth = 40;
        /** Column Resize started event */
        this.columnResizeStarted = new EventEmitter();
        /** Column Resize moved event */
        this.columnResizeMoved = new EventEmitter();
        /** Column Resize ended event */
        this.columnResizeEnded = new EventEmitter();
        this.columnResizeInit = new EventEmitter();
        this.isRtl = dir.value === 'rtl';
        this._dirChangeSubscription = dir.change.subscribe(() => {
            this.isRtl = dir.value === 'rtl';
            this.dragRef.data.isRtl = this.isRtl;
        });
    }
    ngAfterViewInit() {
        const element = this.elementRef.nativeElement;
        const node = document.createElement('span');
        node.classList.add('mat-table-column-resize-handle');
        // disable dragging when resizing the table header
        node.addEventListener('mousedown', function (event) {
            event.preventDefault();
            event.stopPropagation();
        });
        element.appendChild(node);
        this.dragRef = this.dragDropService.createDrag(node, RESIZEABLE_COLUMNS_DRAG_CONFIG);
        this.dragRef.lockAxis = 'x';
        this.dragRef.data = {
            columnDef: this.columnDef,
            columnElementRef: this.elementRef,
            direction: this.isRtl
        };
        this.dragRef.dragStartDelay = 0;
        // Drag Started subscribe
        this.dragRef.started.subscribe((data) => {
            this._isResizing = true;
            this._cellPadding = this.getCellPadding();
            this._previousWidth =
                this.elementRef.nativeElement.getBoundingClientRect().width -
                    this._cellPadding.left -
                    this._cellPadding.right;
            this.columnResizeStarted.emit({
                resizeColumnTableRef: this.tableRef,
                columnDef: this.columnDef,
                columnElementRef: this.elementRef,
                cellPadding: this._cellPadding,
                dragData: data,
                previousWidth: this._previousWidth
            });
        });
        // Drag Moving subscribe
        this.dragRef.moved.subscribe((data) => {
            if (this._isResizing) {
                const dragElement = data.source.getRootElement();
                // This is needed because cdk drag drop moves the element using transform, we don't actually want it to move.
                dragElement.style.transform = `translate3d(0, 0, 0)`;
                let newWidth = this.isRtl
                    ? this._previousWidth - data.distance.x
                    : this._previousWidth + data.distance.x;
                if (newWidth < this.minDragWidth) {
                    newWidth = this.minDragWidth;
                }
                this._newWidth = newWidth;
                this.columnResizeMoved.emit({
                    resizeColumnTableRef: this.tableRef,
                    columnDef: this.columnDef,
                    columnElementRef: this.elementRef,
                    cellPadding: this._cellPadding,
                    dragData: data,
                    previousWidth: this._previousWidth,
                    newWidth: newWidth
                });
            }
        });
        // Drag Ended subscribe
        this.dragRef.ended.subscribe((data) => {
            this._isResizing = false;
            this.columnResizeEnded.emit({
                resizeColumnTableRef: this.tableRef,
                columnDef: this.columnDef,
                columnElementRef: this.elementRef,
                cellPadding: this._cellPadding,
                dragData: data,
                previousWidth: this._previousWidth,
                newWidth: this._newWidth
            });
            this._newWidth = undefined;
        });
    }
    ngOnDestroy() {
        this.dragRef.dispose();
        this._dirChangeSubscription.unsubscribe();
    }
    /**
     * Gets the width of the column less the padding.
     */
    getCellPadding() {
        const styles = window.getComputedStyle(this.elementRef.nativeElement);
        return {
            left: parseFloat(styles.paddingLeft),
            right: parseFloat(styles.paddingRight)
        };
    }
    /** Returns elementRef for resizableColumn  */
    getElement() {
        return this.elementRef;
    }
}
MatResizableTableColumn.ɵfac = function MatResizableTableColumn_Factory(t) { return new (t || MatResizableTableColumn)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(MatResizableColumnsTable), i0.ɵɵdirectiveInject(i1$1.DragDrop), i0.ɵɵdirectiveInject(MatColumnDef), i0.ɵɵdirectiveInject(i3$1.Directionality)); };
MatResizableTableColumn.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatResizableTableColumn, selectors: [["", "matResizableTableColumn", ""]], hostVars: 4, hostBindings: function MatResizableTableColumn_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵclassProp("mat-table-column-resizable", true)("mat-table-column-resizing", ctx._isResizing);
    } }, inputs: { minDragWidth: "minDragWidth" }, outputs: { columnResizeStarted: "columnResizeStarted", columnResizeMoved: "columnResizeMoved", columnResizeEnded: "columnResizeEnded", columnResizeInit: "columnResizeInit" }, exportAs: ["matResizableTableColumn"] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatResizableTableColumn, [{
        type: Directive,
        args: [{
                selector: '[matResizableTableColumn]',
                exportAs: 'matResizableTableColumn',
                host: {
                    '[class.mat-table-column-resizable]': 'true',
                    '[class.mat-table-column-resizing]': '_isResizing'
                }
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: MatResizableColumnsTable }, { type: i1$1.DragDrop }, { type: MatColumnDef }, { type: i3$1.Directionality }]; }, { minDragWidth: [{
            type: Input
        }], columnResizeStarted: [{
            type: Output
        }], columnResizeMoved: [{
            type: Output
        }], columnResizeEnded: [{
            type: Output
        }], columnResizeInit: [{
            type: Output
        }] }); })();
/**
 * Directive added to VDL Table with resizable columns. Provides functions for managing
 * columns
 */
class MatResizableColumnsTable {
    constructor(tableElementRef, tableRef, renderer, dir) {
        this.tableElementRef = tableElementRef;
        this.tableRef = tableRef;
        this.renderer = renderer;
        this._stylesheetId = 'stylesheet-table-resizable-columns';
        this._specificityDepthsSet = [];
        /** Subscription to the Directionality change EventEmitter. */
        this._dirChangeSubscription = Subscription.EMPTY;
        this.uniqueId = nextUniqueId++;
        this.uniqueClassName = `mat-table-resizable-columns-${this.uniqueId}`;
        this.isRtl = dir.value === 'rtl';
        this._dirChangeSubscription = dir.change.subscribe(() => {
            this.isRtl = !this.isRtl;
        });
        this._isHtmlTable = tableElementRef.nativeElement.nodeName === 'TABLE';
        this.renderer.addClass(this.tableElementRef.nativeElement, this.uniqueClassName);
    }
    ngAfterViewInit() {
        this.setColumnStylesheet();
    }
    ngOnDestroy() {
        this._specificityDepthsSet.forEach((depth) => {
            this.resetStylesheetSpecificity(depth);
        });
        this._dirChangeSubscription.unsubscribe();
    }
    /**
     * Gets the width of the supplied element less the padding.
     *
     * @param columnName column name
     * @returns column width
     */
    getColumnWidth(columnName) {
        if (!columnName) {
            return undefined;
        }
        const colDef = this.columnDefs.find((column) => column.name === columnName);
        if (!colDef) {
            return undefined;
        }
        const columnClassName = `.mat-column-${colDef.cssClassFriendlyName}`;
        const columnElement = this.tableElementRef.nativeElement.querySelector(columnClassName);
        if (!columnElement) {
            return undefined;
        }
        const styles = window.getComputedStyle(columnElement);
        const padding = parseFloat(styles.paddingLeft) + parseFloat(styles.paddingRight);
        return columnElement.getBoundingClientRect().width - padding;
    }
    /**
     * Sets the column widths given an array of columns with widths
     *
     * @param specificityDepth specificity depth for css classes
     * @param columnWidths array that specifies the column and width changes
     */
    setColumnWidths(specificityDepth, columnWidths) {
        if (this._specificityDepthsSet.indexOf(specificityDepth) === -1) {
            this._specificityDepthsSet.push(specificityDepth);
        }
        columnWidths.forEach((column) => {
            const columnDef = this.columnDefs.find((colDef) => colDef.name === column.columnName);
            this.addOrReplaceRule(columnDef.cssClassFriendlyName, specificityDepth, column.width);
        });
    }
    /**
     * Creates or replaces a rule for the column in the stylesheet.
     *
     * SpecificityDepth values are as follows:
     *   1 - Used for setting the initial column widths in table (Not used for specifying set widths for columns)
     *   2 - Used for setting predefined set widths for columns
     *   3 - Used for column resizing
     *
     * @param columnName for component based tables, needed to set up the css class specification
     * @param specificityDepth specificity depth for css classes
     * @param width width in pixels for the supplied element
     */
    addOrReplaceRule(columnName, specificityDepth, width) {
        if (!this._stylesheet) {
            this.setColumnStylesheet();
        }
        const stylesheet = this._stylesheet.sheet;
        const tableMatch = `.${this.uniqueClassName}`.repeat(specificityDepth + 1);
        const columnMatch = `${this._isHtmlTable ? 'th' : ''}.mat-column-${columnName}`;
        const match = `${tableMatch} ${columnMatch}`;
        const index = Array.from(stylesheet.cssRules).findIndex((e) => e.selectorText === match);
        if (!width) {
            if (index >= 0) {
                stylesheet.deleteRule(index);
            }
            return;
        }
        const addFlex = this._isHtmlTable || specificityDepth < 2 ? '' : 'flex: 0 0 auto; ';
        const addWidth = this._isHtmlTable
            ? `width: ${width}px; min-width: ${width}px; max-width: ${width}px`
            : `width: ${width}px`;
        const newRule = `${match} { ${addFlex}${addWidth} }`;
        if (index === -1) {
            stylesheet.insertRule(newRule);
        }
        else {
            stylesheet.deleteRule(index);
            stylesheet.insertRule(newRule, index);
        }
    }
    /**
     * Deletes all classes in the stylesheet set at a given specificity
     *
     * @param specificityDepth Specificity depth of classes to delete
     */
    resetStylesheetSpecificity(specificityDepth) {
        if (this._specificityDepthsSet.indexOf(specificityDepth) === -1) {
            return;
        }
        if (!this._stylesheet) {
            return;
        }
        const stylesheet = this._stylesheet.sheet;
        const tableMatch = `.${this.uniqueClassName}`.repeat(specificityDepth + 1);
        const columnMatch = `${this._isHtmlTable ? 'th' : ''}.mat-column-`;
        const match = `${tableMatch} ${columnMatch}`;
        const styleArray = Array.from(stylesheet.cssRules);
        for (let i = styleArray.length - 1; i >= 0; i--) {
            if (styleArray[i].cssText.startsWith(match)) {
                stylesheet.deleteRule(i);
            }
        }
        this._specificityDepthsSet.splice(this._specificityDepthsSet.indexOf(specificityDepth), 1);
    }
    setColumnStylesheet() {
        const stylesheet = document.getElementById(this._stylesheetId);
        if (!!stylesheet && this._stylesheet !== stylesheet) {
            this._stylesheet = stylesheet;
        }
        else {
            this._stylesheet = document.createElement('style');
            this._stylesheet.id = this._stylesheetId;
            document.head.appendChild(this._stylesheet);
        }
    }
}
MatResizableColumnsTable.ɵfac = function MatResizableColumnsTable_Factory(t) { return new (t || MatResizableColumnsTable)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(MatTable), i0.ɵɵdirectiveInject(i0.Renderer2), i0.ɵɵdirectiveInject(i3$1.Directionality)); };
MatResizableColumnsTable.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatResizableColumnsTable, selectors: [["", "matResizableColumnsTable", ""]], contentQueries: function MatResizableColumnsTable_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
        i0.ɵɵcontentQuery(dirIndex, MatColumnDef, 4);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.columnDefs = _t);
    } }, hostVars: 2, hostBindings: function MatResizableColumnsTable_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵstyleProp("table-layout", ctx.isHtmlTable ? "fixed" : false);
    } }, exportAs: ["matResizableColumnsTable"], features: [i0.ɵɵProvidersFeature([CdkScrollable])] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatResizableColumnsTable, [{
        type: Directive,
        args: [{
                selector: '[matResizableColumnsTable]',
                exportAs: 'matResizableColumnsTable',
                host: {
                    '[style.table-layout]': 'isHtmlTable ? "fixed" : false'
                },
                providers: [CdkScrollable]
            }]
    }], function () { return [{ type: i0.ElementRef }, { type: MatTable }, { type: i0.Renderer2 }, { type: i3$1.Directionality }]; }, { columnDefs: [{
            type: ContentChildren,
            args: [MatColumnDef]
        }] }); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Header row definition for the mat-table.
 * Captures the header row's template and other header properties such as the columns to display.
 */
class MatHeaderRowDef extends CdkHeaderRowDef {
}
MatHeaderRowDef.ɵfac = /*@__PURE__*/ function () { let ɵMatHeaderRowDef_BaseFactory; return function MatHeaderRowDef_Factory(t) { return (ɵMatHeaderRowDef_BaseFactory || (ɵMatHeaderRowDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatHeaderRowDef)))(t || MatHeaderRowDef); }; }();
MatHeaderRowDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatHeaderRowDef, selectors: [["", "matHeaderRowDef", ""]], inputs: { columns: ["matHeaderRowDef", "columns"], sticky: ["matHeaderRowDefSticky", "sticky"] }, features: [i0.ɵɵProvidersFeature([{ provide: CdkHeaderRowDef, useExisting: MatHeaderRowDef }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatHeaderRowDef, [{
        type: Directive,
        args: [{
                selector: '[matHeaderRowDef]',
                providers: [{ provide: CdkHeaderRowDef, useExisting: MatHeaderRowDef }],
                inputs: ['columns: matHeaderRowDef', 'sticky: matHeaderRowDefSticky']
            }]
    }], null, null); })();
/**
 * Footer row definition for the mat-table.
 * Captures the footer row's template and other footer properties such as the columns to display.
 */
class MatFooterRowDef extends CdkFooterRowDef {
}
MatFooterRowDef.ɵfac = /*@__PURE__*/ function () { let ɵMatFooterRowDef_BaseFactory; return function MatFooterRowDef_Factory(t) { return (ɵMatFooterRowDef_BaseFactory || (ɵMatFooterRowDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatFooterRowDef)))(t || MatFooterRowDef); }; }();
MatFooterRowDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatFooterRowDef, selectors: [["", "matFooterRowDef", ""]], inputs: { columns: ["matFooterRowDef", "columns"], sticky: ["matFooterRowDefSticky", "sticky"] }, features: [i0.ɵɵProvidersFeature([{ provide: CdkFooterRowDef, useExisting: MatFooterRowDef }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatFooterRowDef, [{
        type: Directive,
        args: [{
                selector: '[matFooterRowDef]',
                providers: [{ provide: CdkFooterRowDef, useExisting: MatFooterRowDef }],
                inputs: ['columns: matFooterRowDef', 'sticky: matFooterRowDefSticky']
            }]
    }], null, null); })();
/**
 * Data row definition for the mat-table.
 * Captures the data row's template and other properties such as the columns to display and
 * a when predicate that describes when this row should be used.
 */
class MatRowDef extends CdkRowDef {
}
MatRowDef.ɵfac = /*@__PURE__*/ function () { let ɵMatRowDef_BaseFactory; return function MatRowDef_Factory(t) { return (ɵMatRowDef_BaseFactory || (ɵMatRowDef_BaseFactory = i0.ɵɵgetInheritedFactory(MatRowDef)))(t || MatRowDef); }; }();
MatRowDef.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatRowDef, selectors: [["", "matRowDef", ""]], inputs: { columns: ["matRowDefColumns", "columns"], when: ["matRowDefWhen", "when"] }, features: [i0.ɵɵProvidersFeature([{ provide: CdkRowDef, useExisting: MatRowDef }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatRowDef, [{
        type: Directive,
        args: [{
                selector: '[matRowDef]',
                providers: [{ provide: CdkRowDef, useExisting: MatRowDef }],
                inputs: ['columns: matRowDefColumns', 'when: matRowDefWhen']
            }]
    }], null, null); })();
/** Header template container that contains the cell outlet. Adds the right class and role. */
class MatHeaderRow extends CdkHeaderRow {
}
MatHeaderRow.ɵfac = /*@__PURE__*/ function () { let ɵMatHeaderRow_BaseFactory; return function MatHeaderRow_Factory(t) { return (ɵMatHeaderRow_BaseFactory || (ɵMatHeaderRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatHeaderRow)))(t || MatHeaderRow); }; }();
MatHeaderRow.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatHeaderRow, selectors: [["mat-header-row"], ["tr", "mat-header-row", ""]], hostAttrs: ["role", "row", 1, "mat-header-row"], exportAs: ["matHeaderRow"], features: [i0.ɵɵProvidersFeature([{ provide: CdkHeaderRow, useExisting: MatHeaderRow }]), i0.ɵɵInheritDefinitionFeature], decls: 1, vars: 0, consts: [["cdkCellOutlet", ""]], template: function MatHeaderRow_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementContainer(0, 0);
    } }, directives: [i1.CdkCellOutlet], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatHeaderRow, [{
        type: Component,
        args: [{
                selector: 'mat-header-row, tr[mat-header-row]',
                template: CDK_ROW_TEMPLATE,
                host: {
                    class: 'mat-header-row',
                    role: 'row'
                },
                // See note on CdkTable for explanation on why this uses the default change detection strategy.
                // tslint:disable-next-line:validate-decorators
                changeDetection: ChangeDetectionStrategy.Default,
                encapsulation: ViewEncapsulation.None,
                exportAs: 'matHeaderRow',
                providers: [{ provide: CdkHeaderRow, useExisting: MatHeaderRow }]
            }]
    }], null, null); })();
/** Footer template container that contains the cell outlet. Adds the right class and role. */
class MatFooterRow extends CdkFooterRow {
}
MatFooterRow.ɵfac = /*@__PURE__*/ function () { let ɵMatFooterRow_BaseFactory; return function MatFooterRow_Factory(t) { return (ɵMatFooterRow_BaseFactory || (ɵMatFooterRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatFooterRow)))(t || MatFooterRow); }; }();
MatFooterRow.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatFooterRow, selectors: [["mat-footer-row"], ["tr", "mat-footer-row", ""]], hostAttrs: ["role", "row", 1, "mat-footer-row"], exportAs: ["matFooterRow"], features: [i0.ɵɵProvidersFeature([{ provide: CdkFooterRow, useExisting: MatFooterRow }]), i0.ɵɵInheritDefinitionFeature], decls: 1, vars: 0, consts: [["cdkCellOutlet", ""]], template: function MatFooterRow_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementContainer(0, 0);
    } }, directives: [i1.CdkCellOutlet], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatFooterRow, [{
        type: Component,
        args: [{
                selector: 'mat-footer-row, tr[mat-footer-row]',
                template: CDK_ROW_TEMPLATE,
                host: {
                    class: 'mat-footer-row',
                    role: 'row'
                },
                // See note on CdkTable for explanation on why this uses the default change detection strategy.
                // tslint:disable-next-line:validate-decorators
                changeDetection: ChangeDetectionStrategy.Default,
                encapsulation: ViewEncapsulation.None,
                exportAs: 'matFooterRow',
                providers: [{ provide: CdkFooterRow, useExisting: MatFooterRow }]
            }]
    }], null, null); })();
/** Data row template container that contains the cell outlet. Adds the right class and role. */
class MatRow extends CdkRow {
    constructor() {
        super(...arguments);
        // VDL Change: VDL adds disabled, selected and expanded inputs
        /** Whether row is disabled */
        this.disabled = false;
        /** Whether row is selected */
        this.selected = false;
        /** Whether the row is hidden */
        this.hidden = false;
    }
}
MatRow.ɵfac = /*@__PURE__*/ function () { let ɵMatRow_BaseFactory; return function MatRow_Factory(t) { return (ɵMatRow_BaseFactory || (ɵMatRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatRow)))(t || MatRow); }; }();
MatRow.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatRow, selectors: [["mat-row"], ["tr", "mat-row", ""]], hostAttrs: ["role", "row", 1, "mat-row"], hostVars: 9, hostBindings: function MatRow_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("aria-disabled", ctx.disabled)("aria-selected", ctx.selected)("aria-hidden", ctx.hidden);
        i0.ɵɵclassProp("mat-row-disabled", ctx.disabled)("mat-row-selected", ctx.selected)("mat-row-hidden", ctx.hidden);
    } }, inputs: { disabled: "disabled", selected: "selected", hidden: "hidden" }, exportAs: ["matRow"], features: [i0.ɵɵProvidersFeature([{ provide: CdkRow, useExisting: MatRow }]), i0.ɵɵInheritDefinitionFeature], decls: 1, vars: 0, consts: [["cdkCellOutlet", ""]], template: function MatRow_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementContainer(0, 0);
    } }, directives: [i1.CdkCellOutlet], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatRow, [{
        type: Component,
        args: [{
                selector: 'mat-row, tr[mat-row]',
                template: CDK_ROW_TEMPLATE,
                host: {
                    class: 'mat-row',
                    role: 'row',
                    // VDL Change: adds disabled, selected and expanded classes
                    '[class.mat-row-disabled]': 'disabled',
                    '[class.mat-row-selected]': 'selected',
                    '[class.mat-row-hidden]': 'hidden',
                    '[attr.aria-disabled]': 'disabled',
                    '[attr.aria-selected]': 'selected',
                    '[attr.aria-hidden]': 'hidden'
                },
                // See note on CdkTable for explanation on why this uses the default change detection strategy.
                // tslint:disable-next-line:validate-decorators
                changeDetection: ChangeDetectionStrategy.Default,
                encapsulation: ViewEncapsulation.None,
                exportAs: 'matRow',
                providers: [{ provide: CdkRow, useExisting: MatRow }]
            }]
    }], null, { disabled: [{
            type: Input
        }], selected: [{
            type: Input
        }], hidden: [{
            type: Input
        }] }); })();
/** Row that can be used to display a message when no data is shown in the table. */
class MatNoDataRow extends CdkNoDataRow {
    constructor() {
        super(...arguments);
        this._contentClassName = 'mat-no-data-row';
    }
}
MatNoDataRow.ɵfac = /*@__PURE__*/ function () { let ɵMatNoDataRow_BaseFactory; return function MatNoDataRow_Factory(t) { return (ɵMatNoDataRow_BaseFactory || (ɵMatNoDataRow_BaseFactory = i0.ɵɵgetInheritedFactory(MatNoDataRow)))(t || MatNoDataRow); }; }();
MatNoDataRow.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatNoDataRow, selectors: [["ng-template", "matNoDataRow", ""]], features: [i0.ɵɵProvidersFeature([{ provide: CdkNoDataRow, useExisting: MatNoDataRow }]), i0.ɵɵInheritDefinitionFeature] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatNoDataRow, [{
        type: Directive,
        args: [{
                selector: 'ng-template[matNoDataRow]',
                providers: [{ provide: CdkNoDataRow, useExisting: MatNoDataRow }]
            }]
    }], null, null); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Progress Bar directive that applies proper styling to the header row and cells containing the progress bar */
class MatHeaderProgressBarRow {
}
MatHeaderProgressBarRow.ɵfac = function MatHeaderProgressBarRow_Factory(t) { return new (t || MatHeaderProgressBarRow)(); };
MatHeaderProgressBarRow.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatHeaderProgressBarRow, selectors: [["mat-header-row", "matHeaderProgressBarRow", ""], ["tr", "matHeaderProgressBarRow", ""], ["mat-header-row", "mat-header-progress-bar-row", ""], ["tr", "mat-header-progress-bar-row", ""]], hostAttrs: [1, "mat-header-progress-bar-row"], exportAs: ["matHeaderProgressBarRow"] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatHeaderProgressBarRow, [{
        type: Directive,
        args: [{
                selector: 'mat-header-row[matHeaderProgressBarRow], tr[matHeaderProgressBarRow],mat-header-row[mat-header-progress-bar-row], tr[mat-header-progress-bar-row]',
                host: {
                    class: 'mat-header-progress-bar-row'
                },
                exportAs: 'matHeaderProgressBarRow'
            }]
    }], null, null); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/** Tree Row directive that applies proper styling to the row containing a tree column definition */
class MatTreeRow {
    constructor() {
        /** Enabled when row is in process of animating */
        this._animating = false;
        this._hidden = false;
        /** Whether animation for row hide/show is enabled */
        this.matEnableTreeAnimation = true;
    }
    /**
     * Whether the row is visible or hidden
     */
    get hidden() {
        return this._hidden;
    }
    set hidden(value) {
        if (this._hidden !== value) {
            this._animating = true;
            this._hidden = coerceBooleanProperty(value);
            // Set animating to false after at least 300ms
            setTimeout(() => {
                this._animating = false;
            }, 300);
        }
    }
}
MatTreeRow.ɵfac = function MatTreeRow_Factory(t) { return new (t || MatTreeRow)(); };
MatTreeRow.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: MatTreeRow, selectors: [["mat-row", "mat-tree-row", ""], ["tr", "mat-tree-row", ""]], hostVars: 9, hostBindings: function MatTreeRow_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("aria-hidden", ctx.hidden);
        i0.ɵɵclassProp("mat-tree-row", true)("mat-tree-row-animating", ctx.matEnableTreeAnimation ? ctx._animating : false)("mat-tree-row-hidden", ctx.hidden)("mat-tree-row-visible", !ctx.hidden);
    } }, inputs: { hidden: "hidden", matEnableTreeAnimation: "matEnableTreeAnimation" }, exportAs: ["matTreeRow"] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTreeRow, [{
        type: Directive,
        args: [{
                selector: 'mat-row[mat-tree-row], tr[mat-tree-row]',
                host: {
                    '[class.mat-tree-row]': 'true',
                    '[class.mat-tree-row-animating]': 'matEnableTreeAnimation ? _animating : false',
                    '[class.mat-tree-row-hidden]': 'hidden',
                    '[class.mat-tree-row-visible]': '!hidden',
                    '[attr.aria-hidden]': 'hidden'
                },
                exportAs: 'matTreeRow'
            }]
    }], null, { hidden: [{
            type: Input
        }], matEnableTreeAnimation: [{
            type: Input
        }] }); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const _c0 = [[["mat-table"], ["table"]]];
const _c1 = ["mat-table, table"];
/**
 * Wrapper for a table where scrolling, particularly horizontal scrolling, is desired.
 * It wraps the table with a `cdk-scrollable` component and adds some styles to get
 * the desired scrolling behavior.
 */
class MatScrollableTableWrapper {
}
MatScrollableTableWrapper.ɵfac = function MatScrollableTableWrapper_Factory(t) { return new (t || MatScrollableTableWrapper)(); };
MatScrollableTableWrapper.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatScrollableTableWrapper, selectors: [["mat-scrollable-table-wrapper"]], viewQuery: function MatScrollableTableWrapper_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(CdkScrollable, 5);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.cdkScrollable = _t.first);
    } }, hostAttrs: [1, "mat-scrollable-table-wrapper"], ngContentSelectors: _c1, decls: 2, vars: 0, consts: [["cdk-scrollable", "", 1, "mat-scrolling-table-content-wrapper"]], template: function MatScrollableTableWrapper_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef(_c0);
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵprojection(1);
        i0.ɵɵelementEnd();
    } }, directives: [i1$2.CdkScrollable], encapsulation: 2, changeDetection: 0 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatScrollableTableWrapper, [{
        type: Component,
        args: [{
                selector: 'mat-scrollable-table-wrapper',
                template: `
    <div cdk-scrollable class="mat-scrolling-table-content-wrapper">
      <ng-content select="mat-table, table"></ng-content>
    </div>
  `,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                host: {
                    class: 'mat-scrollable-table-wrapper'
                }
            }]
    }], null, { cdkScrollable: [{
            type: ViewChild,
            args: [CdkScrollable]
        }] }); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
function MatTextColumn_th_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "th", 3);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵstyleProp("text-align", ctx_r0.justify);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate1(" ", ctx_r0.headerText, " ");
} }
function MatTextColumn_td_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "td", 4);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const data_r2 = ctx.$implicit;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵstyleProp("text-align", ctx_r1.justify);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate1(" ", ctx_r1.dataAccessor(data_r2, ctx_r1.name), " ");
} }
/**
 * Column that simply shows text content for the header and row cells. Assumes that the table
 * is using the native table implementation (`<table>`).
 *
 * By default, the name of this column will be the header text and data property accessor.
 * The header text can be overridden with the `headerText` input. Cell values can be overridden with
 * the `dataAccessor` input. Change the text justification to the start or end using the `justify`
 * input.
 */
class MatTextColumn extends CdkTextColumn {
}
MatTextColumn.ɵfac = /*@__PURE__*/ function () { let ɵMatTextColumn_BaseFactory; return function MatTextColumn_Factory(t) { return (ɵMatTextColumn_BaseFactory || (ɵMatTextColumn_BaseFactory = i0.ɵɵgetInheritedFactory(MatTextColumn)))(t || MatTextColumn); }; }();
MatTextColumn.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: MatTextColumn, selectors: [["mat-text-column"]], features: [i0.ɵɵInheritDefinitionFeature], decls: 3, vars: 0, consts: [["matColumnDef", ""], ["mat-header-cell", "", 3, "text-align", 4, "matHeaderCellDef"], ["mat-cell", "", 3, "text-align", 4, "matCellDef"], ["mat-header-cell", ""], ["mat-cell", ""]], template: function MatTextColumn_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementContainerStart(0, 0);
        i0.ɵɵtemplate(1, MatTextColumn_th_1_Template, 2, 3, "th", 1);
        i0.ɵɵtemplate(2, MatTextColumn_td_2_Template, 2, 3, "td", 2);
        i0.ɵɵelementContainerEnd();
    } }, directives: [MatColumnDef, MatHeaderCellDef, MatHeaderCell, MatCellDef, MatCell], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTextColumn, [{
        type: Component,
        args: [{
                selector: 'mat-text-column',
                template: `
    <ng-container matColumnDef>
      <th mat-header-cell *matHeaderCellDef [style.text-align]="justify">
        {{headerText}}
      </th>
      <td mat-cell *matCellDef="let data" [style.text-align]="justify">
        {{dataAccessor(data, name)}}
      </td>
    </ng-container>
  `,
                encapsulation: ViewEncapsulation.None,
                // Change detection is intentionally not set to OnPush. This component's template will be provided
                // to the table to be inserted into its view. This is problematic when change detection runs since
                // the bindings in this template will be evaluated _after_ the table's view is evaluated, which
                // mean's the template in the table's view will not have the updated value (and in fact will cause
                // an ExpressionChangedAfterItHasBeenCheckedError).
                // tslint:disable-next-line:validate-decorators
                changeDetection: ChangeDetectionStrategy.Default
            }]
    }], null, null); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
const EXPORTED_DECLARATIONS = [
    // Table
    MatTable,
    MatRecycleRows,
    // Template defs
    MatHeaderCellDef,
    MatHeaderRowDef,
    MatColumnDef,
    MatCellDef,
    MatRowDef,
    MatFooterCellDef,
    MatFooterRowDef,
    // Cell directives
    MatHeaderCell,
    MatCell,
    MatFooterCell,
    // Row directives
    MatHeaderRow,
    MatRow,
    MatFooterRow,
    MatNoDataRow,
    MatTextColumn,
    // VDL added components/directives
    MatTreeCell,
    MatTreeRow,
    MatTableTreeExpander,
    MatCellAnimated,
    MatResizableColumnsTable,
    MatResizableTableColumn,
    MatScrollableTableWrapper,
    MatHeaderProgressBarRow,
    MatExpansionCell
];
class MatTableModule {
}
MatTableModule.ɵfac = function MatTableModule_Factory(t) { return new (t || MatTableModule)(); };
MatTableModule.ɵmod = /*@__PURE__*/ i0.ɵɵdefineNgModule({ type: MatTableModule });
MatTableModule.ɵinj = /*@__PURE__*/ i0.ɵɵdefineInjector({ providers: [MAT_TABLE_INTL_PROVIDER], imports: [[
            CommonModule,
            CdkTableModule,
            MatCommonModule,
            ObserversModule,
            DragDropModule,
            CdkScrollableModule,
            MatIconModule,
            MatButtonModule
        ], MatCommonModule] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTableModule, [{
        type: NgModule,
        args: [{
                imports: [
                    CommonModule,
                    CdkTableModule,
                    MatCommonModule,
                    ObserversModule,
                    DragDropModule,
                    CdkScrollableModule,
                    MatIconModule,
                    MatButtonModule
                ],
                exports: [MatCommonModule, EXPORTED_DECLARATIONS],
                declarations: EXPORTED_DECLARATIONS,
                providers: [MAT_TABLE_INTL_PROVIDER]
            }]
    }], null, null); })();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(MatTableModule, { declarations: [
        // Table
        MatTable,
        MatRecycleRows,
        // Template defs
        MatHeaderCellDef,
        MatHeaderRowDef,
        MatColumnDef,
        MatCellDef,
        MatRowDef,
        MatFooterCellDef,
        MatFooterRowDef,
        // Cell directives
        MatHeaderCell,
        MatCell,
        MatFooterCell,
        // Row directives
        MatHeaderRow,
        MatRow,
        MatFooterRow,
        MatNoDataRow,
        MatTextColumn,
        // VDL added components/directives
        MatTreeCell,
        MatTreeRow,
        MatTableTreeExpander,
        MatCellAnimated,
        MatResizableColumnsTable,
        MatResizableTableColumn,
        MatScrollableTableWrapper,
        MatHeaderProgressBarRow,
        MatExpansionCell], imports: [CommonModule,
        CdkTableModule,
        MatCommonModule,
        ObserversModule,
        DragDropModule,
        CdkScrollableModule,
        MatIconModule,
        MatButtonModule], exports: [MatCommonModule, 
        // Table
        MatTable,
        MatRecycleRows,
        // Template defs
        MatHeaderCellDef,
        MatHeaderRowDef,
        MatColumnDef,
        MatCellDef,
        MatRowDef,
        MatFooterCellDef,
        MatFooterRowDef,
        // Cell directives
        MatHeaderCell,
        MatCell,
        MatFooterCell,
        // Row directives
        MatHeaderRow,
        MatRow,
        MatFooterRow,
        MatNoDataRow,
        MatTextColumn,
        // VDL added components/directives
        MatTreeCell,
        MatTreeRow,
        MatTableTreeExpander,
        MatCellAnimated,
        MatResizableColumnsTable,
        MatResizableTableColumn,
        MatScrollableTableWrapper,
        MatHeaderProgressBarRow,
        MatExpansionCell] }); })();

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
/**
 * Corresponds to `Number.MAX_SAFE_INTEGER`. Moved out into a variable here due to
 * flaky browser support and the value not being defined in Closure's typings.
 */
const MAX_SAFE_INTEGER = 9007199254740991;
/** Shared base class with MDC-based implementation. */
class _MatTableDataSource extends DataSource {
    constructor(initialData = []) {
        super();
        /** Stream emitting render data to the table (depends on ordered data changes). */
        this._renderData = new BehaviorSubject([]);
        /** Stream that emits when a new filter string is set on the data source. */
        this._filter = new BehaviorSubject('');
        /** Used to react to internal changes of the paginator that are made by the data source itself. */
        this._internalPageChanges = new Subject();
        /**
         * Subscription to the changes that should trigger an update to the table's rendered rows, such
         * as filtering, sorting, pagination, or base data changes.
         */
        this._renderChangesSubscription = null;
        /**
         * Data accessor function that is used for accessing data properties for sorting through
         * the default sortData function.
         * This default function assumes that the sort header IDs (which defaults to the column name)
         * matches the data's properties (e.g. column Xyz represents data['Xyz']).
         * May be set to a custom function for different behavior.
         * @param data Data object that is being accessed.
         * @param sortHeaderId The name of the column that represents the data.
         */
        this.sortingDataAccessor = (data, sortHeaderId) => {
            const value = data[sortHeaderId];
            if (_isNumberValue(value)) {
                const numberValue = Number(value);
                // Numbers beyond `MAX_SAFE_INTEGER` can't be compared reliably so we
                // leave them as strings. For more info: https://goo.gl/y5vbSg
                return numberValue < MAX_SAFE_INTEGER ? numberValue : value;
            }
            return value;
        };
        /**
         * Gets a sorted copy of the data array based on the state of the MatSort. Called
         * after changes are made to the filtered data or when sort changes are emitted from MatSort.
         * By default, the function retrieves the active sort and its direction and compares data
         * by retrieving data using the sortingDataAccessor. May be overridden for a custom implementation
         * of data ordering.
         * @param data The array of data that should be sorted.
         * @param sort The connected MatSort that holds the current sort state.
         */
        this.sortData = (data, sort) => {
            const active = sort.active;
            const direction = sort.direction;
            if (!active || direction == '') {
                return data;
            }
            return data.sort((a, b) => {
                let valueA = this.sortingDataAccessor(a, active);
                let valueB = this.sortingDataAccessor(b, active);
                // If there are data in the column that can be converted to a number,
                // it must be ensured that the rest of the data
                // is of the same type so as not to order incorrectly.
                const valueAType = typeof valueA;
                const valueBType = typeof valueB;
                if (valueAType !== valueBType) {
                    if (valueAType === 'number') {
                        valueA += '';
                    }
                    if (valueBType === 'number') {
                        valueB += '';
                    }
                }
                // If both valueA and valueB exist (truthy), then compare the two. Otherwise, check if
                // one value exists while the other doesn't. In this case, existing value should come last.
                // This avoids inconsistent results when comparing values to undefined/null.
                // If neither value exists, return 0 (equal).
                let comparatorResult = 0;
                if (valueA != null && valueB != null) {
                    // Check if one value is greater than the other; if equal, comparatorResult should remain 0.
                    if (valueA > valueB) {
                        comparatorResult = 1;
                    }
                    else if (valueA < valueB) {
                        comparatorResult = -1;
                    }
                }
                else if (valueA != null) {
                    comparatorResult = 1;
                }
                else if (valueB != null) {
                    comparatorResult = -1;
                }
                return comparatorResult * (direction == 'asc' ? 1 : -1);
            });
        };
        /**
         * Checks if a data object matches the data source's filter string. By default, each data object
         * is converted to a string of its properties and returns true if the filter has
         * at least one occurrence in that string. By default, the filter string has its whitespace
         * trimmed and the match is case-insensitive. May be overridden for a custom implementation of
         * filter matching.
         * @param data Data object used to check against the filter.
         * @param filter Filter string that has been set on the data source.
         * @returns Whether the filter matches against the data
         */
        this.filterPredicate = (data, filter) => {
            // Transform the data into a lowercase string of all property values.
            const dataStr = Object.keys(data)
                .reduce((currentTerm, key) => {
                // Use an obscure Unicode character to delimit the words in the concatenated string.
                // This avoids matches where the values of two columns combined will match the user's query
                // (e.g. `Flute` and `Stop` will match `Test`). The character is intended to be something
                // that has a very low chance of being typed in by somebody in a text field. This one in
                // particular is "White up-pointing triangle with dot" from
                // https://en.wikipedia.org/wiki/List_of_Unicode_characters
                return currentTerm + data[key] + '◬';
            }, '')
                .toLowerCase();
            // Transform the filter by converting it to lowercase and removing whitespace.
            const transformedFilter = filter.trim().toLowerCase();
            return dataStr.indexOf(transformedFilter) != -1;
        };
        this._data = new BehaviorSubject(initialData);
        this._updateChangeSubscription();
    }
    /** Array of data that should be rendered by the table, where each object represents one row. */
    get data() {
        return this._data.value;
    }
    set data(data) {
        data = Array.isArray(data) ? data : [];
        this._data.next(data);
        // Normally the `filteredData` is updated by the re-render
        // subscription, but that won't happen if it's inactive.
        if (!this._renderChangesSubscription) {
            this._filterData(data);
        }
    }
    /**
     * Filter term that should be used to filter out objects from the data array. To override how
     * data objects match to this filter string, provide a custom function for filterPredicate.
     */
    get filter() {
        return this._filter.value;
    }
    set filter(filter) {
        this._filter.next(filter);
        // Normally the `filteredData` is updated by the re-render
        // subscription, but that won't happen if it's inactive.
        if (!this._renderChangesSubscription) {
            this._filterData(this.data);
        }
    }
    /**
     * Instance of the MatSort directive used by the table to control its sorting. Sort changes
     * emitted by the MatSort will trigger an update to the table's rendered data.
     */
    get sort() {
        return this._sort;
    }
    set sort(sort) {
        this._sort = sort;
        this._updateChangeSubscription();
    }
    /**
     * Instance of the MatPaginator component used by the table to control what page of the data is
     * displayed. Page changes emitted by the MatPaginator will trigger an update to the
     * table's rendered data.
     *
     * Note that the data source uses the paginator's properties to calculate which page of data
     * should be displayed. If the paginator receives its properties as template inputs,
     * e.g. `[pageLength]=100` or `[pageIndex]=1`, then be sure that the paginator's view has been
     * initialized before assigning it to this data source.
     */
    get paginator() {
        return this._paginator;
    }
    set paginator(paginator) {
        this._paginator = paginator;
        this._updateChangeSubscription();
    }
    /**
     * Subscribe to changes that should trigger an update to the table's rendered rows. When the
     * changes occur, process the current state of the filter, sort, and pagination along with
     * the provided base data and send it to the table for rendering.
     */
    _updateChangeSubscription() {
        // Sorting and/or pagination should be watched if MatSort and/or MatPaginator are provided.
        // The events should emit whenever the component emits a change or initializes, or if no
        // component is provided, a stream with just a null event should be provided.
        // The `sortChange` and `pageChange` acts as a signal to the combineLatests below so that the
        // pipeline can progress to the next step. Note that the value from these streams are not used,
        // they purely act as a signal to progress in the pipeline.
        const sortChange = this._sort
            ? merge(this._sort.sortChange, this._sort.initialized)
            : of(null);
        const pageChange = this._paginator
            ? merge(this._paginator.page, this._internalPageChanges, this._paginator.initialized)
            : of(null);
        const dataStream = this._data;
        // Watch for base data or filter changes to provide a filtered set of data.
        const filteredData = combineLatest([dataStream, this._filter]).pipe(map(([data]) => this._filterData(data)));
        // Watch for filtered data or sort changes to provide an ordered set of data.
        const orderedData = combineLatest([filteredData, sortChange]).pipe(map(([data]) => this._orderData(data)));
        // Watch for ordered data or page changes to provide a paged set of data.
        const paginatedData = combineLatest([orderedData, pageChange]).pipe(map(([data]) => this._pageData(data)));
        // Watched for paged data changes and send the result to the table to render.
        this._renderChangesSubscription?.unsubscribe();
        this._renderChangesSubscription = paginatedData.subscribe((data) => this._renderData.next(data));
    }
    /**
     * Returns a filtered data array where each filter object contains the filter string within
     * the result of the filterTermAccessor function. If no filter is set, returns the data array
     * as provided.
     */
    _filterData(data) {
        // If there is a filter string, filter out data that does not contain it.
        // Each data object is converted to a string using the function defined by filterTermAccessor.
        // May be overridden for customization.
        this.filteredData =
            this.filter == null || this.filter === ''
                ? data
                : data.filter((obj) => this.filterPredicate(obj, this.filter));
        if (this.paginator) {
            this._updatePaginator(this.filteredData.length);
        }
        return this.filteredData;
    }
    /**
     * Returns a sorted copy of the data if MatSort has a sort applied, otherwise just returns the
     * data array as provided. Uses the default data accessor for data lookup, unless a
     * sortDataAccessor function is defined.
     */
    _orderData(data) {
        // If there is no active sort or direction, return the data without trying to sort.
        if (!this.sort) {
            return data;
        }
        return this.sortData(data.slice(), this.sort);
    }
    /**
     * Returns a paged slice of the provided data array according to the provided MatPaginator's page
     * index and length. If there is no paginator provided, returns the data array as provided.
     */
    _pageData(data) {
        if (!this.paginator) {
            return data;
        }
        const startIndex = this.paginator.pageIndex * this.paginator.pageSize;
        return data.slice(startIndex, startIndex + this.paginator.pageSize);
    }
    /**
     * Updates the paginator to reflect the length of the filtered data, and makes sure that the page
     * index does not exceed the paginator's last page. Values are changed in a resolved promise to
     * guard against making property changes within a round of change detection.
     */
    _updatePaginator(filteredDataLength) {
        Promise.resolve().then(() => {
            const paginator = this.paginator;
            if (!paginator) {
                return;
            }
            paginator.length = filteredDataLength;
            // If the page index is set beyond the page, reduce it to the last page.
            if (paginator.pageIndex > 0) {
                const lastPageIndex = Math.ceil(paginator.length / paginator.pageSize) - 1 || 0;
                const newPageIndex = Math.min(paginator.pageIndex, lastPageIndex);
                if (newPageIndex !== paginator.pageIndex) {
                    paginator.pageIndex = newPageIndex;
                    // Since the paginator only emits after user-generated changes,
                    // we need our own stream so we know to should re-render the data.
                    this._internalPageChanges.next();
                }
            }
        });
    }
    /**
     * Used by the MatTable. Called when it connects to the data source.
     * @docs-private
     */
    connect() {
        if (!this._renderChangesSubscription) {
            this._updateChangeSubscription();
        }
        return this._renderData;
    }
    /**
     * Used by the MatTable. Called when it disconnects from the data source.
     * @docs-private
     */
    disconnect() {
        this._renderChangesSubscription?.unsubscribe();
        this._renderChangesSubscription = null;
    }
}
/**
 * Data source that accepts a client-side data array and includes native support of filtering,
 * sorting (using MatSort), and pagination (using MatPaginator).
 *
 * Allows for sort customization by overriding sortingDataAccessor, which defines how data
 * properties are accessed. Also allows for filter customization by overriding filterTermAccessor,
 * which defines how row data is converted to a string for filter matching.
 *
 * **Note:** This class is meant to be a simple data source to help you get started. As such
 * it isn't equipped to handle some more advanced cases like robust i18n support or server-side
 * interactions. If your app needs to support more advanced use cases, consider implementing your
 * own `DataSource`.
 */
class MatTableDataSource extends _MatTableDataSource {
}

/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MAT_TABLE_INTL_PROVIDER, MAT_TABLE_INTL_PROVIDER_FACTORY, MatCell, MatCellAnimated, MatCellDef, MatColumnDef, MatExpansionCell, MatFooterCell, MatFooterCellDef, MatFooterRow, MatFooterRowDef, MatHeaderCell, MatHeaderCellDef, MatHeaderProgressBarRow, MatHeaderRow, MatHeaderRowDef, MatNoDataRow, MatRecycleRows, MatResizableColumnsTable, MatResizableTableColumn, MatRow, MatRowDef, MatScrollableTableWrapper, MatTable, MatTableDataSource, MatTableIntl, MatTableModule, MatTableTreeExpander, MatTextColumn, MatTreeCell, MatTreeRow, _MatTableDataSource };
//# sourceMappingURL=vdlx-vdl-angular-mat-table.mjs.map
