import { CdkCell, CdkColumnDef } from '@angular/cdk/table';
import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy } from '@angular/core';
import { MatTableIntl } from './table-intl';
import * as i0 from "@angular/core";
/** Cell template container that adds the classes and template for row expansion. */
export declare class MatExpansionCell extends CdkCell implements OnDestroy {
    _intl: MatTableIntl;
    private _intlSubscription;
    /** Whether the row is expanded */
    get expanded(): boolean;
    set expanded(value: boolean);
    _expanded: boolean;
    /** Emits an event when expansion changes */
    expandedChanged: EventEmitter<boolean>;
    constructor(_intl: MatTableIntl, _columnDef: CdkColumnDef, _elementRef: ElementRef<HTMLElement>, changeDetectorRef: ChangeDetectorRef);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatExpansionCell, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatExpansionCell, "mat-cell[mat-expander-cell], td[mat-expander-cell]", never, { "expanded": "expanded"; }, { "expandedChanged": "expandedChanged"; }, never, ["*"]>;
}
//# sourceMappingURL=cell-expansion.d.ts.map