/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Optional } from '@angular/core';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
/** Table data that is required for internationalization. */
export declare class MatTableIntl {
    /**
     * Stream that emits whenever the labels here are changed. Use this to notify
     * components if the labels have changed after initialization.
     */
    readonly changes: Subject<void>;
    /** Label used for the button in opening the expansion row. */
    rowOpenExpandedButtonLabel: string;
    /** Label used for the button in closing the expansion row */
    rowCloseExpandedButtonLabel: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatTableIntl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MatTableIntl>;
}
/** @docs-private */
export declare function MAT_TABLE_INTL_PROVIDER_FACTORY(parentIntl: MatTableIntl): MatTableIntl;
/** @docs-private */
export declare const MAT_TABLE_INTL_PROVIDER: {
    provide: typeof MatTableIntl;
    deps: Optional[][];
    useFactory: typeof MAT_TABLE_INTL_PROVIDER_FACTORY;
};
//# sourceMappingURL=table-intl.d.ts.map