/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { EventEmitter } from '@angular/core';
import { MatToolbarIntl } from '../toolbar-intl';
import * as i0 from "@angular/core";
export declare class MatToolbarSelectionList {
    _intl: MatToolbarIntl;
    /** Array of selected values from the menuItems array */
    get selected(): Array<any>;
    set selected(value: Array<any>);
    _selected: Array<any>;
    /** Selected array changed event */
    selectedChange: EventEmitter<any[]>;
    /** Array of items to list in the menu for selection */
    get menuItems(): Array<any>;
    set menuItems(value: Array<any>);
    _menuItems: Array<any>;
    /** Key within MenuItems Array for use as label in selection list. Default: 'name' */
    labelKey: string;
    /**
     * The order of the items in the selected array will be the same as the menuItems array,
     * otherwise it will be in order of selection
     */
    maintainOrder: boolean;
    constructor(_intl: MatToolbarIntl);
    /** Returns true if the given menuItem is selected */
    menuItemIsSelected(menuItem: any): boolean;
    /**
     * toggles the selection of an item from the menuItem array
     * @param menuItem Menu item from the menuItem array
     * @param event Event from Click, Change or Keyboard
     */
    toggleMenuItem(event: MouseEvent | KeyboardEvent | Event | any, menuItem: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatToolbarSelectionList, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatToolbarSelectionList, "mat-toolbar-selection-list", never, { "selected": "selected"; "menuItems": "menuItems"; "labelKey": "labelKey"; "maintainOrder": "maintainOrder"; }, { "selectedChange": "selectedChange"; }, never, never>;
}
