/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { ChangeDetectorRef, OnDestroy, OnInit } from '@angular/core';
import { MatToolbarIntl } from './toolbar-intl';
import * as i0 from "@angular/core";
export declare class MatToolbarFilter implements OnInit, OnDestroy {
    _intl: MatToolbarIntl;
    private _changeDetectorRef;
    private _intlChanges;
    /** Required: True if application has applied the filter, otherwise false. */
    filtered: boolean;
    /** Indicates the open state of the overlay. */
    open: boolean;
    /**
     * Tooltip for toolbar filter toggle button
     * @deprecated in merge-10, use toolbar-intl instead
     * @breaking-change merge-11
     */
    get toolbarFilterTooltip(): string;
    set toolbarFilterTooltip(value: string);
    _toolbarFilterTooltip: string;
    /**
     * Aria label of the filter toggle button
     * @deprecated in merge-10, use toolbar-intl instead
     * @breaking-change merge-11
     */
    get ariaLabel(): string;
    set ariaLabel(value: string);
    _ariaLabel: string;
    constructor(_intl: MatToolbarIntl, _changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    toggleFilters(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatToolbarFilter, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MatToolbarFilter, "mat-toolbar-filter", never, { "filtered": "filtered"; "open": "open"; "toolbarFilterTooltip": "toolbarFilterTooltip"; "ariaLabel": "aria-label"; }, {}, never, never>;
}
