/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { Optional } from '@angular/core';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
/**
 * To modify the labels and text displayed, create a new instance of MatGlobalHelpIntl and include it in a custom provider.
 */
export declare class MatToolbarIntl {
    /**
     * Stream that emits whenever the labels here are changed. Use this to notify
     * components if the labels have changed after initialization.
     */
    readonly changes: Subject<void>;
    /** Values for mat-toolbar-overlay
     **************************************************/
    /** Aria label for the toolbar overlay close button. */
    toolbarOverlayCloseAriaLabel: string;
    /** Text for the toolbar overlay close button. */
    toolbarOverlayCloseTooltip: string;
    /** Template for rendering the toolbar overlay title */
    toolbarOverlaySelectedTemplate: string;
    /** Values for mat-toolbar-filter
     **************************************************/
    /** Template for rendering the toolbar filter tooltip */
    toolbarFilterTooltip: string;
    /** Template for rendering the toolbar filter aria label */
    toolbarFilterAriaLabel: string;
    /** Values for mat-toolbar-selection-list
     **************************************************/
    /** Template for rendering the toolbar selection list tooltip */
    toolbarSelectionListTooltip: string;
    /** Template for rendering the toolbar selection list aria label */
    toolbarSelectionListAriaLabel: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatToolbarIntl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MatToolbarIntl>;
}
/** @docs-private */
export declare function MAT_TOOLBAR_INTL_PROVIDER_FACTORY(parentIntl: MatToolbarIntl): MatToolbarIntl;
/** @docs-private */
export declare const MAT_TOOLBAR_INTL_PROVIDER: {
    provide: typeof MatToolbarIntl;
    deps: Optional[][];
    useFactory: typeof MAT_TOOLBAR_INTL_PROVIDER_FACTORY;
};
