/*!
 * Copyright Veritas Technologies LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at
 * https://stash.veritas.com/projects/VDL/repos/vdl-angular-nx/browse/LICENSE
 */
import { OnInit } from '@angular/core';
import { MatToolbarRowExpansion } from './toolbar-row-expansion';
import * as i0 from "@angular/core";
/**
 * This directive is intended to be used in conjunction with an mat-toolbar-row-expansion tag.  It is
 * responsible for toggling the display of the provided content instance.
 */
export declare class MatToolbarTrigger implements OnInit {
    get _matToolbarTriggerFor(): MatToolbarRowExpansion;
    set _matToolbarTriggerFor(matToolbarFilterContainer: MatToolbarRowExpansion);
    private open;
    /** References the menu instance that the trigger is associated with. */
    matToolbarFilterContainer: MatToolbarRowExpansion;
    ngOnInit(): void;
    toggleContent(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatToolbarTrigger, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatToolbarTrigger, "[matToolbarTriggerFor]", ["matToolbarTrigger"], { "_matToolbarTriggerFor": "matToolbarTriggerFor"; "matToolbarFilterContainer": "matToolbarTriggerFor"; }, {}, never>;
}
